module ewald
  use constants, only : dp, zero, one
  use utilities, only : erfc, error, hpsort

  implicit none
  
contains

!-----------------------------------------------------------------------
  function ewald_energy() 
!-----------------------------------------------------------------------

    !> \large This routine computes the ion-ion interaction energy with the
    !> Ewald method.
    !>
    !> \centerline{\includegraphics*[width=17cm]{ewald0.png}}
    !>
    !> A Gaussian charge distribution is added and subtracted to each 
    !> atomic site:
    !> \[ \rho^z_i({\bf r}) = Z_i \kappa^3 e^{-\kappa^2r^2/\pi^{3/2}}. \]
    !>
    !> \centerline{\includegraphics*[width=17cm]{ewald.png}} 
    !>
    !> The effect of $\rho^z$ is to screen the point charge and to reduce
    !> the range of the electrostatic ion-ion interaction. The remaining terms 
    !> (arising from the periodic gaussian charge distributions)
    !> are easily calculated in reciprocal space. The explicit form of 
    !> $E_{\rm ion-ion}$ in the Ewald method is therefore: 
    !> \begin{eqnarray}
    !>  E_{\rm Ewald}=&  \frac{1}{2} \sum_{i \ne j} \sum_{\bf R} 
    !>  Z_i Z_j \frac{{\rm erfc}(2\sqrt{\alpha} \left\|{\bf R_{ij}+R}\right\|)}
    !>  {\left\|{\bf R_{ij}+R}\right\|} & {\rm Real-space \,\, term} 
    !>  \nonumber \\
    !>  +& \frac{4\pi}{\Omega} \sum_{\bf G \ne 0} \frac{e^{-G^2/4\alpha}}{G^2} 
    !>  \, \left\{ \mid \sum_i Z_i \cos({\bf G\cdot R_i}) \mid^2 +
    !>  \mid \sum_i Z_i \sin({\bf G\cdot R_i}) \mid^2 \right\} 
    !>  & {\rm Reciprocal-space \,\, term}  \nonumber \\
    !>  -&  \frac{4\sqrt{\alpha}}{\sqrt{\pi}} \, \sum_i Z_i^2 
    !> & {\rm Self-energy} \nonumber  \\
    !> -& \frac{4\pi}{\Omega} \frac{1}{4\alpha} \left( 
    !> \sum _i Z_i \right)^2 & {\rm Charged-system \,\, term} \nonumber 
    !> \end{eqnarray} 
    !> The parameter $\alpha$ is related to the width of the Gaussian 
    !> ($\kappa=2\sqrt{\alpha}$). A similar method is used to calculate the
    !> ionic contirbution to the forces (see 
    !> \hyperlink{force_ew}{\tt force\_ew})

    use constants, only : half, e2, two, alat, tpiba2, tpi
    use structure, only : nats, atoms, species, at, bg, ntyp, omega
    use reciprocal_lattice, only: gg, gcutm, ngm, structure_factor

    implicit none

    !   first the dummy variables

    real(DP)    ::  ewald_energy  ! output: the ewald energy
    complex(DP) ::  rhon

    !    here the local variables

    integer, parameter :: mxr=50  ! maximum number of R vectors included 
                                  ! in r sum
    integer::  &
         ng,  &        ! counter over reciprocal G vectors
         nr,  &        ! counter over direct vectors
         na,  &        ! counter on atoms
         nb,  &        ! counter on atoms
         nt,  &        ! counter on atomic types
         nrm, &        ! number of R vectors included in r sum
         ipol          ! counter on polarization
    real(DP) :: &
         charge, &     ! total ionic charge in the cell
         ewaldg, &     ! ewald energy computed in reciprocal space
         ewaldr, &     ! ewald energy computed in real space
         dtau(3), &    ! the difference tau_s - tau_s'
         alpha,   &    ! alpha term in ewald sum
         r(3,mxr),&    ! input of the rgen routine ( not used here )
         r2(mxr), &    ! the square modulus of R_j-tau_s-tau_s'
         rmax,    &    ! the maximum radius to consider real space sum
         rr,      &    ! buffer variable
         upperbound   ! used to optimize alpha

    !> Calculate the total charge $\sum_i Z_i^2$

    charge = ZERO
    do na=1,nats
       charge = charge + species(atoms(na)%itype)%zv
    end do

    alpha = 2.9d0; upperbound = ONE
    do while(upperbound > 1.0d-7)
       alpha=alpha-0.1d0
       
       !> choose alpha in order to have convergence in the sum over G 
       !> upperbound is a safe upper bound for the error in the sum over G

       if(alpha.le.0.d0) call error('ewald','optimal alpha not found',1)
       upperbound=2.d0*charge**2*sqrt(2.d0*alpha/tpi)* &
            erfc(sqrt(tpiba2*gcutm/4.d0/alpha))
    end do

    !> Charged-system term $4\pi/\Omega 
    !>  /(4\alpha) \left( \sum _i Z_i \right)^2$ 

    ewaldg=-charge**2 /alpha/4.d0

    !> Reciprocal-space term

    do ng = 2, ngm
       rhon = (ZERO,ZERO)
       do nt = 1,ntyp
          rhon = rhon + species(nt)%zv*conjg(structure_factor(ng,nt))*omega
       enddo
       ewaldg= ewaldg + abs(rhon)**2*exp(-gg(ng) &
            * tpiba2/alpha/4.d0)/gg(ng)/tpiba2
    enddo
    ewaldg = TWO *tpi/omega*ewaldg

    !> Self-interaction term $4\sqrt{\alpha}/\sqrt{\pi} \, \sum_i Z_i^2$

    do na=1, nats
       ewaldg= ewaldg - species(atoms(na)%itype)%zv**2 * &
            sqrt(8.d0/tpi * alpha)
    enddo

    !> Real-space term

    ewaldr = ZERO
    rmax = 4.d0/sqrt(alpha)/alat

    !> With this choice terms up to $Z_i Z_j {\rm erfc}(4)$ are counted 
    !> $({\rm erfc}(4)=2 \times 10^{-8})$

    do na=1, nats
       do nb=1, nats
          dtau(:)=atoms(na)%tau(:)-atoms(nb)%tau(:)

          !> Generate nearest-neighbors shells $\cdots$

          call rgen(dtau,rmax,mxr,at,bg,r,r2,nrm)

          !> $\cdots$ and sum to the real space part  

          do nr=1, nrm
             rr=sqrt(r2(nr))*alat
             ewaldr = ewaldr + species(atoms(na)%itype)%zv* &
                               species(atoms(nb)%itype)%zv &
                              * erfc(sqrt(alpha)*rr)/rr
          end do
       end do
    end do

    !> Sum all contributions

    ewald_energy= HALF * e2 * ( ewaldg+ewaldr )

    return
  end function ewald_energy

  !-----------------------------------------------------------------------
  subroutine ewald_force ( forceion )

    !>  \large This routine computes the ionic contribution to the forces
    !>  with the Ewald method (For a description of the Ewald method 
    !>  see \hyperlink{ewald}{\tt ewald}. 
    !>
    !> A Gaussian charge distribution is added and subtracted to each 
    !> atomic site:
    !> \[ \rho^z_i({\bf r}) = Z_i \kappa^3 e^{-\kappa^2r^2/\pi^{3/2}}. \]
    !> The effect of the $\rho^z$ is to screen the point charge and to reduce
    !> the range of the electrostatic ion-ion interaction. The remaining terms 
    !> (arising from the periodic distribution of gaussian charge distributions
    !> are easily calculated in reciprocal space. The explicit form of the
    !> ionic component of the force on atom $i$ is obtained by differentiating
    !> the  Ewald expression for  the ion-ion energy 
    !> (\hyperlink{ewald}{E$_{\rm ion}$}):
    !> \begin{eqnarray}
    !> {\bf F_i^{ion}} =& - \frac{\partial E_{\rm Ewald}}{\partial \bf R_i} 
    !> & \nonumber \\
    !> =& - \frac{1}{2} \sum_{i \ne j} \sum_{\bf R} Z_i Z_j \left\{
    !> \frac{{\rm erfc}(2\sqrt{\alpha} \left\|{\bf R_{ij}+R}\right\|)}
    !>  {\left\|{\bf R_{ij}+R}\right\|} + \sqrt{\frac{4\alpha}{\pi}} 
    !> e^{-\alpha\left\|{\bf R_{ij}+R}\right\|^2} \right\} 
    !> \frac{\bf R_{ij}+R}{\left\|{\bf R_{ij}+R}\right\|^2}
    !> & {\rm Real-space} \nonumber \\
    !> -& \frac{4 (2\pi)^2}{\Omega} \sum_{\bf G \ne 0} 
    !> Z_i \, \frac{e^{-G^2/4\alpha}}{G^2} \left\{ \cos({\bf G \cdot R_i})
    !> \left[ \sum_j Z_j \sin({\bf G\cdot R_j}) \right] -\sin({\bf G\cdot R_i})
    !> \left[ \sum_j Z_j \cos({\bf G\cdot R_j}) \right] \right\} {\bf G}
    !> & {\rm Reciprocal-space}  \nonumber
    !> \end{eqnarray}
    !> The parameter $\alpha$ is related to the width of the Gaussian 
    !> ($\kappa=2\sqrt{\alpha}$).

!-----------------------------------------------------------------------
    use constants, only : dp, zero, tpiba2, half, e2, tpi, two
    use structure, only : nats, atoms, species, omega, at, bg, alat, ntyp
    use reciprocal_lattice, only : gcutm, g, gg, structure_factor, ngm

    implicit none

    !   First the dummy variables

    real(DP) :: factor,  &
                forceion(3,nats)    ! output: the ewald part of the forces

!  Three parameters

    integer, parameter ::  mxr=50 ! the maximum number of R vectors
            
    integer ::  ig,  &           ! counter on G vectos
                n,   &           ! counter on r vectors
                na,  &           ! counter on atoms
                nb,  &           ! counter on atoms
                nt,  &           ! counter on atomic types
                nrm, &           ! the number of R vectors for real space sum
                ipol             ! counter on polarization

    real(DP) ::  sumnb,  &        ! auxiliary variable for speed
                 arg,    &        ! the argument of the exponential
                 alpha,  &        ! the alpha parameter 
                 dtau(3),&        ! the difference of two tau
                 r(3,mxr), &      ! the position of the atoms in the shell
                 r2(mxr),  &      ! the square of r      
                 rmax,     &      ! the maximum r
                 rr,       &      ! the modulus of the r vectors
                 charge,   &      ! the total charge  
                 upperbound       ! used to determine alpha

    complex(DP) :: aux(ngm)          ! auxiliary space

    forceion = ZERO
    charge   = ZERO
    do na=1, nats
       charge = charge +species(atoms(na)%itype)%zv
    end do

    !> Get $\alpha$ choose $\alpha$ in order to have convergence in 
    !> the sum over G {\tt upperbound} is a safe upper bound for the 
    !> error ON THE ENERGY

    alpha=1.1d0; upperbound = ONE
    do while( upperbound > 1.0d-6)
       alpha=alpha-0.1d0
       if(alpha.eq.0.d0) call error('force_ew','optimal alpha not found',1)
       upperbound=e2*charge**2*sqrt(2.d0*alpha/tpi)* &
            erfc(sqrt(tpiba2*gcutm/4.d0/alpha))
    end do

    !> RECIPROCAL SPACE

    aux=(ZERO,ZERO)
    
    !> Reciprocal-space: \[ Z_j \sum_j {\rm e}^{i{\bf G \cdot R_j}} = 
    !>  Z_j\left( \cos({\bf G\cdot R_j})+i\sin({\bf G\cdot R_j})\right) \]

    do nt=1,ntyp
       aux(:) = aux(:) + species(nt)%zv &
            *conjg(structure_factor(:,nt))*omega
    end do
    
    !> Reciprocal-space coefficient 

    do ig=2,ngm
       aux(ig)=aux(ig)*exp(-gg(ig)*tpiba2/alpha/4.d0)/(gg(ig)*tpiba2)
    end do

    !> Complete reciprocal-space term 
    !> \[ \frac{4 (2\pi)^2}{\Omega} \sum_{\bf G \ne 0} 
    !> Z_i \, \frac{e^{-G^2/4\alpha}}{G^2} \left\{ \cos({\bf G \cdot R_i})
    !> \left[ \sum_j Z_j \sin({\bf G\cdot R_j}) \right] -\sin({\bf G\cdot R_i})
    !> \left[ \sum_j Z_j \cos({\bf G\cdot R_j}) \right] \right\} \]

    do na=1,nats
       do ig=1,ngm
          arg = tpi * dot_product(g(:,ig),atoms(na)%tau)
          sumnb = cos(arg)*DIMAG(aux(ig))-sin(arg)*real(aux(ig))
          forceion(:,na) = forceion(:,na) + g(:,ig)*sumnb
       end do
       forceion(:,na) =  -species(atoms(na)%itype)%zv* &
            TWO *e2*tpi**2/omega /alat*forceion(:,na)
    end do

    !> REAL SPACE

    rmax=5.d0/(sqrt(alpha)*alat)

    !> with this choice terms up to $Z_i Z_j {\rm erfc}(5)$ are counted 
    !> (${\rm erfc}(5)=2\times 10^{-12}$)

    outer: do na=1, nats
       inner: do  nb=1, nats
          if( nb == na ) cycle inner
          dtau(:)=atoms(na)%tau(:)-atoms(nb)%tau(:)
          
          !> generates nearest-neighbors shells, {\tt r(i)=R(i)-dtau(i)}

          call rgen(dtau,rmax,mxr,at,bg,r,r2,nrm)

          !> Complete real-space term 
          !> \[ \frac{1}{2} \sum_{i \ne j} \sum_{\bf R} Z_i Z_j \left\{
          !> \frac{{\rm erfc}(2\sqrt{\alpha} \left\|{\bf R_{ij}+R}\right\|)}
          !>  {\left\|{\bf R_{ij}+R}\right\|} + \sqrt{\frac{4\alpha}{\pi}} 
          !> e^{-\alpha\left\|{\bf R_{ij}+R}\right\|^2} \right\} 
          !> \frac{\bf R_{ij}+R}{\left\|{\bf R_{ij}+R}\right\|^2} \]

          do n=1, nrm
             rr=sqrt(r2(n))*alat
             factor = species(atoms(na)%itype)%zv*&
                  species(atoms(nb)%itype)%zv*e2/rr**2* &
                  ( erfc(sqrt(alpha)*rr)/rr +           &
                  sqrt(8.0d0*alpha/tpi)*exp(-alpha*rr**2) ) * alat 
             forceion(:,na) = forceion(:,na) - factor*r(:,n)
          end do
       end do inner
    end do outer

    !> Back to subroutine \hyperlink{htforceion}{\tt forces}

    return
  end subroutine ewald_force

  !-----------------------------------------------------------------------
  subroutine rgen(dtau,rmax,mxr,at,bg,r,r2,nrm)
  !-----------------------------------------------------------------------
    !   generates neighbour shells (in units of alat) with length
    !   less than rmax,and returns them in order of increasing length.
    !      r=i*a1+j*a2+k*a3-dtau,
    !   where a1,a2,a3 are the vectors defining the lattice

    implicit none

    !    first the dummy variables
    
    integer   ::  nrm, &       ! output: the number of vectors in the sphere
                  mxr          ! input: the maximum number of vectors
    real(DP) ::  r(3,mxr), &   ! output: coordinates of vectors R+tau\_s-tau\_s'
                 r2(mxr), &    ! output: square modulus of vectors 
                               ! R+tau\_s-tau\_s' 
                 at(3,3), &    ! input: direct lattice vectors
                 bg(3,3), &    ! input: reciprocal lattice vectors
                 dtau(3), &    ! input: the vector tau\_s-tau\_s'
                 rmax          ! input: the radius of the sphere in real space

    !    and here the local variables

    integer, allocatable  :: irr(:) ! index on R vectors for order
    integer               :: nm1, & !
                             nm2, & !  maximum values for trial vectors
                             nm3, & !
                             i,   & !  
                             j,   & !  counters on trial vectors
                             k,   & ! 
                             ipol,& ! counter on polarizations
                             ir,  & ! counter on R vectors
                             indsw,&! index of swapping
                             iswap  ! used for swapping
    real(DP)              :: t(3), &! buffer contains the actual r
                             tt,   &! buffer cotains the modulus of actual r
                             swap, &! used for swapping
                             DNRM2  ! function to find the norm of a vector

    external DNRM2
    allocate(irr(mxr))

    nrm = 0
    if( rmax .eq. ZERO ) return
    nm1= int(DNRM2(3,bg(1,1),1)*rmax) + 2
    nm2= int(DNRM2(3,bg(1,2),1)*rmax) + 2
    nm3= int(DNRM2(3,bg(1,3),1)*rmax) + 2
 
    do i=-nm1,nm1
       do j=-nm2,nm2
          do k=-nm3,nm3
             tt = ZERO
             do ipol=1,3
                t(ipol)=i*at(ipol,1)+j*at(ipol,2)+k*at(ipol,3) - dtau(ipol)
                tt  = tt + t(ipol)*t(ipol)
             end do
             if(tt.le.rmax**2.and.abs(tt).gt.1.d-10) then
                nrm = nrm + 1
                if(nrm > mxr) call error('rgen','too many r-vectors',nrm)
                do ipol=1,3
                   r(ipol,nrm) = t(ipol)
                end do
                r2(nrm)  = tt
             end if
          end do
       end do
    end do

    !   reorder the vectors in order of increasing magnitude
    !   initialize the index inside sorting routine

    irr(1)=0
    if (nrm.gt.1) call hpsort ( r2(1:nrm), irr )
    do ir=1, nrm-1
20     indsw=irr(ir)
       if(indsw.ne.ir) then
          do ipol=1,3
             swap=r(ipol,indsw)
             r(ipol,indsw)=r(ipol,irr(indsw))
             r(ipol,irr(indsw))=swap
          end do
          iswap=irr(ir)
          irr(ir)=irr(indsw)
          irr(indsw)=iswap
          go to 20
       end if
    end do

    deallocate(irr)
    return
  end subroutine rgen

!
! Copyright (C) 2001 PWSCF group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!
!
!-----------------------------------------------------------------------

subroutine d2ionq ( q, dyn)
  !-----------------------------------------------------------------------
  !
  !    This routine computes the contribution of the ions to the
  !    dynamical matrix. Both the real and reciprocal space terms
  !    are included.
  !
  use constants, only : dp, zero, tpiba2, half, two
  use structure, only : nats, atoms, species, omega, at, bg, alat, ntyp
  use reciprocal_lattice, only : gcutm, g, gg, structure_factor, ngm

  implicit none  
  !
  !  first the dummy variables
  !

  integer :: nat
  ! input: the number of atoms
  ! input: the number of types of atoms
  ! input: the number of G vectors
  ! input: the type of each atom
  ! input: the number of modes

  real(kind=DP) ::  q(3)
  ! input: the positions of the atoms
  ! input: the coordinates of g vectors
  ! input: the modulus of g vectors
  ! input: the charge of each type
  ! input: the direct lattice vectors
  ! input: the reciprocal lattice vectors
  ! input: the volume of the unit cell
  ! input: the length scale
  ! input: cut-off of g vectors
  ! input: the q vector
  complex(kind=DP) :: dyn (3*nats,3*nats)  
  ! output: the ionic part of the dyn. mat
  ! input: the pattern of the modes
  !
  !   three parameters
  !

  integer :: mxr  
  ! the maximum number of r shells

  real(kind=DP) :: e2, tpi  
  ! the electron charge
  ! twp times pi

  parameter (mxr = 100, e2 = 2.d0, tpi = 2.d0 * 3.14159265358979d0)  

  integer :: nu_i, nu_j, na, nb, nta, ntb, ng, nrm, nr, icart, &
       jcart, na_icart, na_jcart, nb_icart, nb_jcart, nmodes
  ! counter on the modes
  ! counter on the modes
  ! counter on atoms
  ! counter on atoms
  ! the type of atom na
  ! the type of atom nb
  ! counter on G vectors
  ! the real number of R shells
  ! counter on r shells
  ! counter on cartesian coordinates
  ! counter on cartesian coordinates
  ! counter on the modes
  ! counter on the modes
  ! counter on the modes
  ! counter on the modes
  real(kind=DP) :: arg, fpi, argq, alpha, r (3, mxr), r2 (mxr), &
       dtau (3), rmax, rr, upperbound, charge, fac, df, d2f, ar, &
       gtq2, gt2, facq, qrg
  ! the argument of the phase
  ! 4 times pi
  ! the argument of the phase
  ! two pi / alat
  ! the parameter alpha used to converge the summ
  ! the  parameter
  ! the square of this parameter
  ! delta tau
  ! the maximum r on real space summations
  ! the rmax
  ! an estimate of the error in the real term
  ! the total charge
  ! the phase factor
  ! auxiliary variable
  ! auxiliary variable
  !
  ! the modulus of |q+G|
  ! the modulus of G
  ! a phase factor
  !


  complex(kind=DP), allocatable :: dy1(:,:), dy2(:, :), dy3(:, :)

  complex(kind=DP) :: facg, fnat, work
  ! the first term dynamical matrix
  ! the second dynamical matrix
  ! the third term of the dynamical matrix
  ! a phase with g
  ! a phase with the atoms
  ! working space

  nat=nats
  nmodes=3*nat
  tpiba2 = (tpi / alat) **2  

  fpi = 2.d0 * tpi  
  charge = 0.d0  
  do na = 1, nat  
     charge = charge+species(atoms(na)%itype)%zv   
  enddo
  !
  ! choose alpha in order to have convergence in the sum over G
  ! upperbound is an upper bound for the error in the sum over G
  ! estimated for the energy (empirical trust!)
  !
  alpha = 2.9d0  

11 alpha = alpha - 0.1d0  

  if (alpha.eq.0.d0) call error ('d2ion', 'optimal alpha not found', &
       1)

  upperbound = 2.d0 * charge**2 * sqrt (2.d0 * alpha / tpi) * erfc ( &
       sqrt (tpiba2*gcutm/4.d0/alpha) )

  if (upperbound.gt.1.d-9) goto 11  

  write (6, '(/5x,"Alpha used in Ewald sum = ",f8.4)') alpha  
  allocate(dy1(3*nats,3*nats), dy2(3*nats,3*nats), dy3(3*nats,3*nats))

  dy1=(0.d0,0.d0)
  dy2=(0.d0,0.d0)
  dy3=(0.d0,0.d0)
  !
  ! G-space sums here
  !
  do ng = 1, ngm  
     !
     !     The reciprocal space term has two contributions. The first one
     !
     gtq2 = ( (g (1, ng) + q (1) ) **2 + (g (2, ng) + q (2) ) **2 + &
          (g (3, ng) + q (3) ) **2) * tpiba2
     if (abs (gtq2) .gt.1.d-8) then  
        facq = - e2 * fpi * tpiba2 / omega * exp ( - gtq2 / alpha / &
             4.d0) / gtq2
     else  
        facq = 0.d0  
     endif
     do na = 1, nat  
        nta = atoms(na)%itype  
        do nb = 1, nat  
           ntb = atoms(nb)%itype 
           argq = tpi*((g(1,ng)+q(1))*(atoms(na)%tau(1)-atoms(nb)%tau(1))+&
                       (g(2,ng)+q(2))*(atoms(na)%tau(2)-atoms(nb)%tau(2))+&
                       (g(3,ng)+q(3))*(atoms(na)%tau(3)-atoms(nb)%tau(3)) )
           facg = facq * species(nta)%zv * species(ntb)%zv * &
                 cmplx(cos(argq), sin(argq)) 
           do icart = 1, 3  
              nu_i = 3 * (na - 1) + icart  
              do jcart = 1, 3  
                 nu_j = 3 * (nb - 1) + jcart  
                 dy1 (nu_i, nu_j) = dy1 (nu_i, nu_j) + facg * (q (icart) + g ( &
                      icart, ng) ) * (q (jcart) + g (jcart, ng) )
              enddo
           enddo
        enddo
     enddo
     !
     !   the second term
     !

     gt2 = gg (ng) * tpiba2  
     if (abs (gt2) .gt.1.d-8) then  
        fac = - e2 * fpi * tpiba2 / omega * exp ( - gt2 / alpha / 4.d0) &
             / gt2
     else  
        fac = 0.d0  

     endif
     do na = 1, nat  
        nta = atoms(na)%itype
        fnat = (0.d0, 0.d0)  
        do nb = 1, nat  
           ntb = atoms(nb)%itype 
           arg = tpi*((g(1,ng))*(atoms(na)%tau(1)-atoms(nb)%tau(1))+&
                      (g(2,ng))*(atoms(na)%tau(2)-atoms(nb)%tau(2))+&
                      (g(3,ng))*(atoms(na)%tau(3)-atoms(nb)%tau(3)) )
           facg = fac*species(nta)%zv*species(ntb)%zv*cmplx(cos(arg), 0.d0)  
           fnat = fnat + facg  

        enddo
        do icart = 1, 3  
           nu_i = 3 * (na - 1) + icart  
           do jcart = 1, 3  
              nu_j = 3 * (na - 1) + jcart  
              dy2 (nu_i, nu_j) = dy2 (nu_i, nu_j) + fnat * g (icart, ng) &
                   * g (jcart, ng)
           enddo
        enddo
     enddo

  enddo
  do nu_i = 1, nmodes  
     do nu_j = 1, nmodes  
        dy3 (nu_i, nu_j) = dy3 (nu_i, nu_j) + dy1 (nu_i, nu_j) - dy2 ( &
             nu_i, nu_j)
     enddo
  enddo
  !
  !  Then there is also a part in real space which is computed here.
  !
  rmax = 5.d0 / sqrt (alpha) / alat  
  !
  ! with this choice terms up to ZiZj*erfc(5) are counted (erfc(5)=2x10^-1
  !
  do na = 1, nat  
     nta = atoms(na)%itype
     do nb = 1, nat  
        ntb = atoms(nb)%itype
        dtau (:) = atoms(na)%tau(:)-atoms(nb)%tau(:)  
        !
        ! generates nearest-neighbors shells r(i)=R(i)-dtau(i)
        !
        call rgen (dtau, rmax, mxr, at, bg, r, r2, nrm)  
        do nr = 1, nrm  
           rr = sqrt (r2 (nr) ) * alat  
           ar = sqrt (alpha) * rr  
           qrg = tpi * (q (1) * (r (1, nr) + dtau (1) ) + q (2) * (r (2, nr) &
                + dtau (2) ) + q (3) * (r (3, nr) + dtau (3) ) )
           d2f = (3.d0 * erfc (ar) + sqrt (8.d0 / tpi) * ar * (3.d0 + 2.d0 * &
                ar**2) * exp ( - ar**2) ) / rr**5
           df = ( - erfc (ar) - sqrt (8.d0 / tpi) * ar * exp ( - ar**2) ) &
                / rr**3
           do icart = 1, 3  
              na_icart = 3 * (na - 1) + icart  
              nb_icart = 3 * (nb - 1) + icart  
              do jcart = 1, 3  
                 nb_jcart = 3 * (nb - 1) + jcart  
                 na_jcart = 3 * (na - 1) + jcart  
                 dy3(na_icart,nb_jcart)=dy3(na_icart,nb_jcart)+e2 &
                         *species(nta)%zv &
                   *species(ntb)%zv*cmplx(cos(qrg),sin(qrg))*(d2f*alat* &
                      r(icart,nr)*alat*r(jcart,nr))
                 dy3(na_icart,na_jcart)=dy3(na_icart,na_jcart)-e2 &
                            *species(nta)%zv*species(ntb)%zv*&
                           (d2f*alat*r(icart,nr)*alat*r(jcart,nr))
              enddo
              dy3(na_icart, nb_icart)=dy3(na_icart,nb_icart)+e2* &
                   species(nta)%zv*species(ntb)%zv* &
                   cmplx(cos(qrg), sin(qrg))*df
              dy3(na_icart, na_icart)=dy3(na_icart,na_icart)-e2* &
                      species(nta)%zv* &
                      species(ntb)%zv*df
           enddo
        enddo
     enddo

  enddo
  call dcopy(3*nat*3*nat*2,dy3,1,dyn,1)
  call dscal(3*nat*3*nat*2,-1.d0,dyn,1)

  deallocate(dy1,dy2,dy3)
  return  
end subroutine d2ionq

end module ewald

module fourier
  use constants, only : dp
  use utilities, only : error
  implicit none

  interface fft
   module procedure fft1
   module procedure fft3
  end interface

contains
  subroutine fft1(data, sign)
    complex(DP) :: data(:)
    integer     :: sign, N, stride

    stride = ( loc(data(2)) - loc(data(1)) ) /(2*DP)
    N      = size(data)

    call wft(data(1),N,stride,sign)
    if (sign < 0) data(:) = data(:) / N
    
    return
  end subroutine fft1

  subroutine fft3(data,sign)
    complex(DP)  :: data(:,:,:)
    integer            :: n1, n2, n3, p,q, sign

    n1 = size(data,1)
    n2 = size(data,2)
    n3 = size(data,3)

    do p=1, n2
       do q=1, n3
          call fft1(data(:,p,q),sign)
       end do
    end do

    do p=1, n1
       do q=1, n3
          call fft1(data(p,:,q),sign)
       end do
    end do

    do p=1, n1
       do q=1, n2
          call fft1(data(p,q,:),sign)
       end do
    end do

    return
  end subroutine fft3

end module fourier

subroutine wft(z,n,stride,isn)

  ! complex Fast Forier Transform computed in place
  ! using mixed-radix fast fourier transform algorithm.
  ! by r. c. singleton, stanford research institute, 
  ! oct. 1968
  ! 
  ! Original routine from CERNLIB
  ! Packed and wrapped for didactical purposes by 
  ! Stefano Baroni 01/03/03

  ! On input:
  ! w(:)   (complex)   Data array to be FFT-ed
  ! n      (integer)   Number of data values in w
  ! stride (integer)   is the spacing between consecutive
  !                    data values in w(:)
  ! On output:
  ! w(:)   (complex)   Transformed data array (no further 
  !                    normalization is performed)

  !  arrays at(maxf), ck(maxf), bt(maxf), sk(maxf), and np(maxp)
  !  are used for temporary storage. if the available storage
  !  is insufficient, the program is terminated by a stop.
  !  maxf must be .ge. the maximum prime factor of n.
  !  maxp must be .gt. the number of prime factors of n.
  !  in addition, if the square-free portion k cf n has two or
  !  more prime factors, then maxp must be .ge. k-1.
  !  array storage in nfac for a maximum of 11 factors of n.
  !  if n has more than one square-free factor, the product of the
  !  square-free factors must be .le. 210

  implicit real(kind=8) (a-h, o-z)
  integer stride
  dimension z(2,*)
  dimension nfac(11),np(209)
  ! array storage for maximum prime factor of 23
  dimension at(23),ck(23),bt(23),sk(23)
  equivalence (i,ii)
  ! the following two constants should agree with the array dimension

  maxf=23
  maxp=209
  if(n .lt. 2) return
  !org> inc=isn
  ! remove next 3 lines for original code
  ntot  = n
  nspan = n
  inc   = stride
  ! the following constants are rad = 2.*pi , s72 = sin(0.4*pi) ,
  ! c72 = cos(0.4*pi) and s120 = sqrt(0.75)
  rad  = 6.2831853071796d0
  s72  = 0.95105651629515d0
  c72  = 0.30901699437495d0
  s120 = 0.86602540378444d0
  if(isn .ge. 0) go to 10
  s72=-s72
  s120=-s120
  rad=-rad
  !org> inc=-inc
10 nt=inc*ntot
  ks=inc*nspan
  kspan=ks
  nn=nt-inc
  jc=ks/n
  radf=rad*dble(jc)*0.5d0
  i=0
  jf=0
  ! determine the factors of n
  m=0
  k=n
  go to 20
15 m=m+1
  nfac(m)=4
  k=k/16
20 if(k-(k/16)*16 .eq. 0) go to 15
  j=3
  jj=9
  go to 30
25 m=m+1
  nfac(m)=j
  k=k/jj
30 if(mod(k,jj) .eq. 0) go to 25
  j=j+2
  jj=j**2
  if(jj .le. k) go to 30
  if(k .gt. 4) go to 40
  kt=m
  nfac(m+1)=k
  if(k .ne. 1) m=m+1
  go to 80
40 if(k-(k/4)*4 .ne. 0) go to 50
  m=m+1
  nfac(m)=2
  k=k/4
50 kt=m
  j=2
60 if(mod(k,j) .ne. 0) go to 70
  m=m+1
  nfac(m)=j
  k=k/j
70 j=((j+1)/2)*2+1
  if(j .le. k) go to 60
80 if(kt .eq. 0) go to 100
  j=kt
90 m=m+1
  nfac(m)=nfac(j)
  j=j-1
  if(j .ne. 0) go to 90
  ! compute fourier transform
100 sd=radf/dble(kspan)
  cd=2.0d0*sin(sd)**2
  sd=sin(sd+sd)
  kk=1
  i=i+1
  if(nfac(i) .ne. 2) go to 400
  ! transform for factor of 2 (including rotation factor)
  kspan=kspan/2
  k1=kspan+2
210 k2=kk+kspan
  ak=z(1,k2)
  bk=z(2,k2)
  z(1,k2)=z(1,kk)-ak
  z(2,k2)=z(2,kk)-bk
  z(1,kk)=z(1,kk)+ak
  z(2,kk)=z(2,kk)+bk
  kk=k2+kspan
  if(kk .le. nn) go to 210
  kk=kk-nn
  if(kk .le. jc) go to 210
  if(kk .gt. kspan) go to 800
220 c1=1.0d0-cd
  s1=sd
230 k2=kk+kspan
  ak=z(1,kk)-z(1,k2)
  bk=z(2,kk)-z(2,k2)
  z(1,kk)=z(1,kk)+z(1,k2)
  z(2,kk)=z(2,kk)+z(2,k2)
  z(1,k2)=c1*ak-s1*bk
  z(2,k2)=s1*ak+c1*bk
  kk=k2+kspan
  if(kk .lt. nt) go to 230
  k2=kk-nt
  c1=-c1
  kk=k1-k2
  if(kk .gt. k2) go to 230
  ak=c1-(cd*c1+sd*s1)
  s1=(sd*c1-cd*s1)+s1
  ! the following three statements compensate for truncation
  ! error. if rounded arithmetic is used, they may be deleted.
  c1=0.5d0/(ak**2+s1**2)+0.5d0
  s1=c1*s1
  c1=c1*ak
  ! next statement should be deleted if non-rounded arithmetic is use
  ! c1=ak
  kk=kk+jc
  if(kk .lt. k2) go to 230
  k1=k1+inc+inc
  kk=(k1-kspan)/2+jc
  if(kk .le. jc+jc) go to 220
  go to 100
  ! transform for factor of 3 (optional code)
320 k1=kk+kspan
  k2=k1+kspan
  ak=z(1,kk)
  bk=z(2,kk)
  aj=z(1,k1)+z(1,k2)
  bj=z(2,k1)+z(2,k2)
  z(1,kk)=ak+aj
  z(2,kk)=bk+bj
  ak=-0.5d0*aj+ak
  bk=-0.5d0*bj+bk
  aj=(z(1,k1)-z(1,k2))*s120
  bj=(z(2,k1)-z(2,k2))*s120
  z(1,k1)=ak-bj
  z(2,k1)=bk+aj
  z(1,k2)=ak+bj
  z(2,k2)=bk-aj
  kk=k2+kspan
  if(kk .lt. nn) go to 320
  kk=kk-nn
  if(kk .le. kspan) go to 320
  go to 700
  ! transform for factor of 4
400 if(nfac(i) .ne. 4) go to 600
  kspnn=kspan
  kspan=kspan/4
410 c1=1.0d0
  s1=0
420 k1=kk+kspan
  k2=k1+kspan
  k3=k2+kspan
  akp=z(1,kk)+z(1,k2)
  akm=z(1,kk)-z(1,k2)
  ajp=z(1,k1)+z(1,k3)
  ajm=z(1,k1)-z(1,k3)
  z(1,kk)=akp+ajp
  ajp=akp-ajp
  bkp=z(2,kk)+z(2,k2)
  bkm=z(2,kk)-z(2,k2)
  bjp=z(2,k1)+z(2,k3)
  bjm=z(2,k1)-z(2,k3)
  z(2,kk)=bkp+bjp
  bjp=bkp-bjp
  if(isn .lt. 0) go to 450
  akp=akm-bjm
  akm=akm+bjm
  bkp=bkm+ajm
  bkm=bkm-ajm
  if(s1 .eq. 0.0d0) go to 460
430 z(1,k1)=akp*c1-bkp*s1
  z(2,k1)=akp*s1+bkp*c1
  z(1,k2)=ajp*c2-bjp*s2
  z(2,k2)=ajp*s2+bjp*c2
  z(1,k3)=akm*c3-bkm*s3
  z(2,k3)=akm*s3+bkm*c3
  kk=k3+kspan
  if(kk .le. nt) go to 420
440 c2=c1-(cd*c1+sd*s1)
  s1=(sd*c1-cd*s1)+s1
  ! the following three statements compensate for truncation
  ! error. if rounded arithmetic is used, they may be deleted.
  c1=0.5d0/(c2**2+s1**2)+0.5d0
  s1=c1*s1
  c1=c1*c2
  ! next statement should be deleted if non-rounded arithmetic is use
  ! c1=c2
  c2=c1**2-s1**2
  s2=2.0d0*c1*s1
  c3=c2*c1-s2*s1
  s3=c2*s1+s2*c1
  kk=kk-nt+jc
  if(kk .le. kspan) go to 420
  kk=kk-kspan+inc
  if(kk .le. jc) go to 410
  if(kspan .eq. jc) go to 800
  go to 100
450 akp=akm+bjm
  akm=akm-bjm
  bkp=bkm-ajm
  bkm=bkm+ajm
  if(s1 .ne. 0.0) go to 430
460 z(1,k1)=akp
  z(2,k1)=bkp
  z(1,k2)=ajp
  z(2,k2)=bjp
  z(1,k3)=akm
  z(2,k3)=bkm
  kk=k3+kspan
  if(kk .le. nt) go to 420
  go to 440
  ! transform for factor of 5 (optional code)
510 c2=c72**2-s72**2
  s2=2.0d0*c72*s72
520 k1=kk+kspan
  k2=k1+kspan
  k3=k2+kspan
  k4=k3+kspan
  akp=z(1,k1)+z(1,k4)
  akm=z(1,k1)-z(1,k4)
  bkp=z(2,k1)+z(2,k4)
  bkm=z(2,k1)-z(2,k4)
  ajp=z(1,k2)+z(1,k3)
  ajm=z(1,k2)-z(1,k3)
  bjp=z(2,k2)+z(2,k3)
  bjm=z(2,k2)-z(2,k3)
  aa=z(1,kk)
  bb=z(2,kk)
  z(1,kk)=aa+akp+ajp
  z(2,kk)=bb+bkp+bjp
  ak=akp*c72+ajp*c2+aa
  bk=bkp*c72+bjp*c2+bb
  aj=akm*s72+ajm*s2
  bj=bkm*s72+bjm*s2
  z(1,k1)=ak-bj
  z(1,k4)=ak+bj
  z(2,k1)=bk+aj
  z(2,k4)=bk-aj
  ak=akp*c2+ajp*c72+aa
  bk=bkp*c2+bjp*c72+bb
  aj=akm*s2-ajm*s72
  bj=bkm*s2-bjm*s72
  z(1,k2)=ak-bj
  z(1,k3)=ak+bj
  z(2,k2)=bk+aj
  z(2,k3)=bk-aj
  kk=k4+kspan
  if(kk .lt. nn) go to 520
  kk=kk-nn
  if(kk .le. kspan) go to 520
  go to 700
  ! transform for odd factors
600 k=nfac(i)
  kspnn=kspan
  kspan=kspan/k
  if(k .eq. 3) go to 320
  if(k .eq. 5) go to 510
  if(k .eq. jf) go to 640
  jf=k
  s1=rad/dble(k)
  c1=cos(s1)
  s1=sin(s1)
  if(jf .gt. maxf) go to 998
  ck(jf)=1.0d0
  sk(jf)=0.0d0
  j=1
630 ck(j)=ck(k)*c1+sk(k)*s1
  sk(j)=ck(k)*s1-sk(k)*c1
  k=k-1
  ck(k)=ck(j)
  sk(k)=-sk(j)
  j=j+1
  if(j .lt. k) go to 630
640 k1=kk
  k2=kk+kspnn
  aa=z(1,kk)
  bb=z(2,kk)
  ak=aa
  bk=bb
  j=1
  k1=k1+kspan
650 k2=k2-kspan
  j=j+1
  at(j)=z(1,k1)+z(1,k2)
  ak=at(j)+ak
  bt(j)=z(2,k1)+z(2,k2)
  bk=bt(j)+bk
  j=j+1
  at(j)=z(1,k1)-z(1,k2)
  bt(j)=z(2,k1)-z(2,k2)
  k1=k1+kspan
  if(k1 .lt. k2) go to 650
  z(1,kk)=ak
  z(2,kk)=bk
  k1=kk
  k2=kk+kspnn
  j=1
660 k1=k1+kspan
  k2=k2-kspan
  jj=j
  ak=aa
  bk=bb
  aj=0.0d0
  bj=0.0d0
  k=1
670 k=k+1
  ak=at(k)*ck(jj)+ak
  bk=bt(k)*ck(jj)+bk
  k=k+1
  aj=at(k)*sk(jj)+aj
  bj=bt(k)*sk(jj)+bj
  jj=jj+j
  if(jj .gt. jf) jj=jj-jf
  if(k .lt. jf) go to 670
  k=jf-j
  z(1,k1)=ak-bj
  z(2,k1)=bk+aj
  z(1,k2)=ak+bj
  z(2,k2)=bk-aj
  j=j+1
  if(j .lt. k) go to 660
  kk=kk+kspnn
  if(kk .le. nn) go to 640
  kk=kk-nn
  if(kk .le. kspan) go to 640
  ! multiply by rotation factor (except for factors of 2 and 4)
700 if(i .eq. m) go to 800
  kk=jc+1
710 c2=1.0d0-cd
  s1=sd
720 c1=c2
  s2=s1
  kk=kk+kspan
730 ak=z(1,kk)
  z(1,kk)=c2*ak-s2*z(2,kk)
  z(2,kk)=s2*ak+c2*z(2,kk)
  kk=kk+kspnn
  if(kk .le. nt) go to 730
  ak=s1*s2
  s2=s1*c2+c1*s2
  c2=c1*c2-ak
  kk=kk-nt+kspan
  if(kk .le. kspnn) go to 730
  c2=c1-(cd*c1+sd*s1)
  s1=s1+(sd*c1-cd*s1)
  ! the following three statements compensate for truncation
  ! error. if rounded arithmetic is used, they may
  ! be deleted.
  c1=0.5d0/(c2**2+s1**2)+0.5d0
  s1=c1*s1
  c2=c1*c2
  kk=kk-kspnn+jc
  if(kk .le. kspan) go to 720
  kk=kk-kspan+jc+inc
  if(kk .le. jc+jc) go to 710
  go to 100
  ! permute the results to normal order---done in two stages
  ! permutation for square factors of n
800 np(1)=ks
  if(kt .eq. 0) go to 890
  k=kt+kt+1
  if(m .lt. k) k=k-1
  j=1
  np(k+1)=jc
810 np(j+1)=np(j)/nfac(j)
  np(k)=np(k+1)*nfac(j)
  j=j+1
  k=k-1
  if(j .lt. k) go to 810
  k3=np(k+1)
  kspan=np(2)
  kk=jc+1
  k2=kspan+1
  j=1
  !org>  if(n .ne. ntot) go to 850
  !org>! permutation for single-variate transform (optional code)
820 ak=z(1,kk)
  z(1,kk)=z(1,k2)
  z(1,k2)=ak
  bk=z(2,kk)
  z(2,kk)=z(2,k2)
  z(2,k2)=bk
  kk=kk+inc
  k2=kspan+k2
  if(k2 .lt. ks) go to 820
830 k2=k2-np(j)
  j=j+1
  k2=np(j+1)+k2
  if(k2 .gt. np(j)) go to 830
  j=1
840 if(kk .lt. k2) go to 820
  kk=kk+inc
  k2=kspan+k2
  if(k2 .lt. ks) go to 840
  if(kk .lt. ks) go to 830
  jc=k3
!org>  go to 890
!org>!     permutation for multivariate transform
!org> 850 k=kk+jc
!org> 860 ak=z(1,kk)
!org>   z(1,kk)=z(1,k2)
!org>   z(1,k2)=ak
!org>   bk=z(2,kk)
!org>   z(2,kk)=z(2,k2)
!org>   z(2,k2)=bk
!org>   kk=kk+inc
!org>   k2=k2+inc
!org>   if(kk .lt. k) go to 860
!org>   kk=kk+ks-jc
!org>   k2=k2+ks-jc
!org>   if(kk .lt. nt) go to 850
!org>   k2=k2-nt+kspan
!org>   kk=kk-nt+jc
!org>   if(k2 .lt. ks) go to 850
!org> 870 k2=k2-np(j)
!org>   j=j+1
!org>   k2=np(j+1)+k2
!org>   if(k2 .gt. np(j)) go to 870
!org>   j=1
!org> 880 if(kk .lt. k2) go to 850
!org>   kk=kk+jc
!org>   k2=kspan+k2
!org>   if(k2 .lt. ks) go to 880
!org>   if(kk .lt. ks) go to 870
!org>   jc=k3
890 if(2*kt+1 .ge. m) return
  kspnn=np(kt+1)
  ! permutation for square-free factors of n
  j=m-kt
  nfac(j+1)=1
900 nfac(j)=nfac(j)*nfac(j+1)
  j=j-1
  if(j .ne. kt) go to 900
  kt=kt+1
  nn=nfac(kt)-1
  if(nn .gt. maxp) go to 998
  jj=0
  j=0
  go to 906
902 jj=jj-k2
  k2=kk
  k=k+1
  kk=nfac(k)
904 jj=kk+jj
  if(jj .ge. k2) go to 902
  np(j)=jj
906 k2=nfac(kt)
  k=kt+1
  kk=nfac(k)
  j=j+1
  if(j .le. nn) go to 904
  ! determine the permutation cycles of length greater than 1
  j=0
  go to 914
910 k=kk
  kk=np(k)
  np(k)=-kk
  if(kk .ne. j) go to 910
  k3=kk
914 j=j+1
  kk=np(j)
  if(kk .lt. 0) go to 914
  if(kk .ne. j) go to 910
  np(j)=-j
  if(j .ne. nn) go to 914
  maxf=inc*maxf
  ! reorder a and b, following the permutation cycles
  go to 950
924 j=j-1
  if(np(j) .lt. 0) go to 924
  jj=jc
926 kspan=jj
  if(jj .gt. maxf) kspan=maxf
  jj=jj-kspan
  k=np(j)
  kk=jc*k+ii+jj
  k1=kk+kspan
  k2=0
928 k2=k2+1
  at(k2)=z(1,k1)
  bt(k2)=z(2,k1)
  k1=k1-inc
  if(k1 .ne. kk) go to 928
932 k1=kk+kspan
  k2=k1-jc*(k+np(k))
  k=-np(k)
936 z(1,k1)=z(1,k2)
  z(2,k1)=z(2,k2)
  k1=k1-inc
  k2=k2-inc
  if(k1 .ne. kk) go to 936
  kk=k2
  if(k .ne. j) go to 932
  k1=kk+kspan
  k2=0
940 k2=k2+1
  z(1,k1)=at(k2)
  z(2,k1)=bt(k2)
  k1=k1-inc
  if(k1 .ne. kk) go to 940
  if(jj .ne. 0) go to 926
  if(j .ne. 1) go to 924
950 j=k3+1
  nt=nt-kspnn
  ii=nt-inc+1
  if(nt .ge. 0) go to 924
  return
  ! error finish, insufficient array storage
998 stop "   array bounds exceeded within subroutine cft"
end subroutine wft

module iterative
  implicit none
contains
  
  subroutine cegter ( psi, e, maxter, maxdim, threshold )

    !     iterative solution of the eigenvalue problem:
    !
    !     ( h - e ) * psi = 0
    !
    !     where h is a complex hermitean matrix, e is a real scalar,
    !     and psi a complex vector

    use constants, only : dp, zero, one
    use pw_types, only: wave_function, clonate, axpy, scal, construct, &
                        destroy, operator(.dot.), assignment(=), psi_link
    use lapack_wrap, only: cdiagh
    use hamiltonian, only: h_psi, g_psi
    use utilities, only : error

    type(wave_function), intent(inout), dimension(:) :: psi 
    real(DP),            intent(out),   dimension(:) :: e
    integer,             intent(in),        optional :: maxter, maxdim
    real(DP),            intent(in),        optional :: threshold
    type(wave_function),     pointer,   dimension(:) :: phi, hphi ! temp
    integer,             allocatable,   dimension(:) :: pivot     ! temp

    logical,     allocatable  :: conv(:) ! flag: .true. when e(n) is convgd
    complex(DP), allocatable  :: hp(:,:) ! projection of the hamiltonian
                                         ! onto the current basis set
    complex(DP), allocatable  :: vc(:,:) ! eigenvectors of hp (column-wise)
    real(DP),    allocatable  :: ew(:)   ! temp array for eigenvalues

    integer                   :: n,m, np, neigv, iter, itermax, nbase, &
                                 pbase, basemax, notcnv, info
    real(DP)                  :: thresh
    type(wave_function), pointer :: swap

    ! set up input variables

    neigv = size(e)
    if(present(maxter)) then
       itermax = maxter
    else
       itermax = 50
    end if
    
    if(present(maxdim)) then
       basemax = maxdim
    else
       basemax = 4*neigv
    end if
    
    if(present(threshold)) then
       thresh = threshold
    else
       thresh = 1.0d-7
    end if
    
    ! prepare work arrays

    allocate ( phi(basemax),        &
               hphi(basemax),       &
               hp(basemax,basemax), & 
               vc(basemax,basemax), &
               ew(basemax),         &
               conv(neigv),         &
               pivot(neigv) )
    
    call psi_link(phi(1:neigv),psi(1:neigv))
    call clonate(psi(1), phi(neigv+1:basemax))
    call clonate(psi(1), hphi(1:basemax))

    swap => hphi(basemax)   ! temporary swap wave-function needed when 
                            ! hphi(basemax) is not used

    ! orthonormalize the trial wave-functions
    
    call gram ( phi(1:neigv) )
    
    ! prepare the reduced hamiltonian for the first iteration         
    ! hp contains the projection of the hamiltonian onto the reduced space
    ! vc contains the eigenvectors of hp

    vc = cmplx(ZERO,ZERO)
    do n = 1, neigv
       call h_psi(phi(n),hphi(n))
       do m = n, neigv
          hp(m,n) = phi(m).dot.hphi(n)
          hp(n,m) = conjg(hp(m,n))
       enddo
       e(n)    = hp(n,n)
       vc(n,n) = cmplx(ONE,ZERO)
    enddo

    conv(:) = .false.
    nbase   = neigv
    
    ! ITERATE!

    iterate: do iter = 1, itermax
       np   = nbase
       sweep: do n = 1, neigv
          if ( .not.conv(n) ) then  
             ! this root not yet converged ... calculate the residual and 
             ! construct a new basis vector out of it
             np = np + 1
             phi(np) = ZERO
             do m=1, nbase                          !
                call axpy &                         ! phi(np)=(H-e(n)) * psi(n)
                     (      vc(m,n),hphi(m),phi(np))!
                call axpy &                         ! where
                     (-e(n)*vc(m,n), phi(m),phi(np))! psi(n) = 
             end do                                 !   sum_m phi(m)*vc(m,n)
             call g_psi(phi(np),e(n),phi(np))       ! phi(np) = (H-e(n)) phi(n)
                                                    !  / (Hd-e(n)) 
          end if                                    !          
       end do sweep

       pbase = nbase
       nbase = np
       call gram ( phi(1:nbase), exclude=pbase )    !  orthonormalize

       ! calculate h times the newly obtained basis-set elements
       ! and update the reduced hamiltonian

       do n = pbase+1, nbase
          call h_psi(phi(n),hphi(n))
          do m=1, n
             hp(m,n) = phi(m).dot.hphi(n)
             hp(n,m) = conjg(hp(m,n))
          end do
       enddo

       ! diagonalize the reduced hamiltonian

       call cdiagh( hp(:,1:nbase), ew(1:nbase), vc(:,1:nbase) )
       e(1:neigv) = ew(1:neigv)

       ! test for convergence
       ! the converge criterion is that the magnitude if the projection
       ! of each eigenvector onto the most recently generated basis
       ! vectors is smaller than thres

       conv(:) = (/ ( abs(dot_product(vc(pbase+1:nbase,n), &
            vc(pbase+1:nbase,n))) <= thresh, n=1, neigv ) /)
       notcnv     = neigv - count(conv(1:neigv))

       ! if overall convergence has been achieved or if the dimension of
       ! the reduced basis set is becoming too large, refresh the basis set. 
       ! i.e. replace its first neigv elements with the current estimates of 
       ! the eigenvectors and set the basis dimension to neigv
       
       if( notcnv==0 .or. nbase+notcnv > basemax )  then
          do n=1,neigv
             hphi(n) = ZERO
             do m=1,nbase
                call axpy(vc(m,n),phi(m),hphi(n))
             end do
          end do
          
          do n=1,neigv
             phi(n) = hphi(n)
             call h_psi(phi(n),hphi(n))
          end do

          nbase = neigv
          hp = (ZERO,ZERO)
          vc = (ZERO,ZERO)
          do n = 1, nbase
             hp(n,n) = cmplx(e(n),ZERO)
             vc(n,n) = cmplx(ONE,ZERO)
          end do
          
       end if

       ! all roots converged: return
       if( notcnv==0 ) exit iterate
       
    end do iterate

    do n = 1, neigv
       if(.not.conv(n)) write(*,"(a,i3,a,f10.5,a,1pe8.1,a,i3,a)") &
            "WARNING: e(",n,") =",e(n)," not converged to within ", &
            thresh, " in ",itermax," iterations"
    end do

    ! deallocate work arrays and exit

    swap => null()
    do n=1, basemax
       call destroy( phi(n))
       call destroy(hphi(n))
    end do
    deallocate ( phi, hphi, hp, vc, ew, conv, pivot )
    
    return
  end subroutine cegter
  
  subroutine gram(psi,exclude)

    use constants, only : dp, one, zero
    use pw_types,  only : axpy, scal, operator(.dot.), wave_function

    type(wave_function), intent(inout), dimension(:) :: psi
    integer, intent(in), optional                    :: exclude
    integer                                          :: start, m,n
    complex(DP)                                      :: ss
    
    if(present(exclude)) then
       start = exclude + 1
    else
       start = 1
    end if
    
    do n = start, size(psi)
       do m = 1, n
          ss = psi(m).dot.psi(n)
          if( m /= n ) then
             call axpy(-ss,psi(m),psi(n))
          else
             ! write(*,*) 'gram ',n,abs(ss)
             call scal( ONE / sqrt(abs(ss)) , psi(n) )
          end if
       end do
    end do

  end subroutine gram

end module iterative

module utilities
  !>
  !> This module contains several simple general-purpose utilities
  !>

  use constants
  implicit none

contains

  subroutine error( routine, message, ierr )

    !    This is a simple routine which writes an error message to
    !    standard output. 
    !    If ierr = 0 it does nothing, 
    !    if ierr < 0 it writes the message but does not stop, 
    !    if ierr > 0 it writes the message and stops.

    character*(*), intent(in) :: routine, & ! name of the calling routine
                                 message    ! output message
    integer, intent(in)   :: ierr       ! error flag
    integer               :: i

    if( ierr == 0 ) return
    write(*,*) " "
    write(*,"(1x,78a)") ("-",i=1,78)
    write(*,"(5x,3a,i10)") "from ",routine,": error #",ierr
    write(*,"(5x,a)") message
    write(*,"(1x,78a)") ("-",i=1,78)

    if(ierr > 0) then
       write(*,"(a)") "     stopping ... "
       stop
    else
       write(*,*) " "
       return
    end if
  end subroutine error

  subroutine inv3x3(a,b,det)
    !>
    !> This routine calculates the inverse of a $3 \times 3$ real matrix 
    !> and, optionally, it also returns the determinant.
    !>
    !> When the columns of the input matrix, {\tt a}, coincide with the 
    !> basis vectors of a Bravais lattice (in units of {\tt alat}), the 
    !> rows of inverse, {\tt b}, coincide with the basis vectors of the 
    !> reciprocal lattice (in units of $2 \pi \over {\tt alat}$), and the
    !> determinant with the volume of the unit cell (in units of ${\tt 
    !> alat}^3$).
    !>
    !> The {\tt b} and {\tt det} output variables are optional. If {\tt b} 
    !> is not present, the inverse is overwritten on {\tt a}.
    !>

    real(kind=DP), intent(inout), dimension(:,:)         :: a
    real(kind=DP), intent(out), optional, dimension(:,:) :: b
    real(kind=DP), intent(out), optional                 :: det 
    real(kind=DP), dimension(3,3)                        :: inv
    real(kind=DP)                                        :: omg
    integer   :: iperm,       &! counter on the permutations
                 i,j,k,l       ! Auxiliary variables

    i = 1
    j = 2
    k = 3
    do iperm=1,3
       inv(i,1) = (a(2,j)*a(3,k)-a(2,k)*a(3,j))
       inv(i,2) = (a(3,j)*a(1,k)-a(3,k)*a(1,j))
       inv(i,3) = (a(1,j)*a(2,k)-a(1,k)*a(2,j))
       l = i
       i = j
       j = k
       k = l
    end do

    omg = a(1,1)*inv(1,1) + a(2,1)*inv(1,2) + a(3,1)*inv(1,3)
    inv(:,:)  = inv(:,:) / omg

    if(present(b)) then
       b(:,:) = inv(:,:)
    else
       a(:,:) = inv(:,:)
    end if

    if(present(det)) det = abs(omg)

    return
  end subroutine inv3x3

  subroutine hpsort(ra,ind) 

    !>
    !> This routine sorts an array {\tt ra(1:n)} into ascending order using 
    !> the {\sl heapsort} algorithm. {\tt ra} is replaced on output by its 
    !> sorted rearrangement. It also creates an index table, {\tt ind}, by 
    !> making an exchange in the index array whenever an exchange is made 
    !> on the sorted data array, {\tt ra}. In case of equal values in the 
    !> input data array, {\tt ra} the values in the index array, {\tt ind} 
    !> are used to order the entries. If on input $\tt ind(1)  = 0$ then 
    !> indices are initialized in the routine; if on input 
    !> $\tt ind(1) \ne  0$, then indices are assumed to have been 
    !> initialized before entering the routine and these indices are 
    !> carried around during the sorting process.
    !>
    !> No work space is needed!
    !>
    !> Adapted from Numerical Recipes pg. 329 (new edition) and ported to 
    !> f90 on Nov 11 2002 by SB
    !>
    
    integer, intent(out), dimension(:)    :: ind    ! in-out variables  
    real(DP), intent(inout), dimension(:) :: ra     !
  
    integer                               :: n, i, ir, j, l, iind ! local
    real(DP)                              :: rra                  ! variables

    n = size(ra)
    if( n > size(ind) ) stop "   hpsort: wrong dimensions for the input data"

    if ( ind(1) == 0 ) ind(1:n) = (/ (i, i=1,n) /) ! initialize index array

    if (n < 2) return                              ! nothing to order

    ! initialize indices for hiring and retirement-promotion phase

    l  = n/2 + 1
    ir = n
    outer: do
       if (l > 1) then    ! still in hiring phase
          l    = l-1
          rra  = ra(l)
          iind = ind(l)
       else                  ! in retirement-promotion phase.
          rra     = ra(ir)   ! clear a space at the end of the array
          iind    = ind(ir)  !  
          ra(ir)  = ra(1)    ! retire the top of the heap into it
          ind(ir) = ind(1)   !
          ir      = ir -1    ! decrease the size of the corporation
          if (ir == 1) then  ! done with the last promotion
             ra(1) = rra     ! the least competent worker at all !
             ind(1)= iind    !
             exit outer
          end if
       end if
       i = l               ! wheter in hiring or promotion phase, we 
       j = l + l           ! set up to place rra in its proper level
       
       do while (j <= ir) 
          if (j < ir) then
             if (ra(j) < ra(j+1)) then ! compare to better underling
                j = j+1 
             else if (ra(j) == ra(j+1)) then
                if (ind(j) < ind(j+1)) j = j+1
             end if
          end if
          if (rra < ra(j)) then ! demote rra
             ra(i) = ra(j)
             ind(i)= ind(j)
             i = j
             j = j + j
          else if (rra == ra(j)) then
             if (iind < ind(j)) then ! demote rra
                ra(i) = ra(j)
                ind(i)= ind(j)
                i = j
                j = j + j
             else
                j = ir + 1       ! set j to terminate do-while loop
             end if
          else                   ! this is the right place for rra
             j = ir + 1          ! set j to terminate do-while loop
          end if
       end do
       ra(i) = rra
       ind(i)= iind
       
    end do outer

    return
  end subroutine hpsort

!---------------------------------------------------------------------
real(dp) function erf (x)  
  !---------------------------------------------------------------------
  !
  !     Error function - computed from the rational approximations of
  !     W. J. Cody, Math. Comp. 22 (1969), pages 631-637.
  !
  !     for abs(x) le 0.47 erf is calculated directly
  !     for abs(x) gt 0.47 erf is calculated via erf(x)=1-erfc(x)
  !
  real(kind=dp) :: x, x2, p1 (4), q1 (4)
  data p1 / 2.42667955230532d2, 2.19792616182942d1, &
       6.99638348861914d0, - 3.56098437018154d-2 /
  data q1 / 2.15058875869861d2, 9.11649054045149d1, &
       1.50827976304078d1, 1.00000000000000d0 /
  !
  if (abs (x) .gt.6.d0) then  
     !
     !  erf(6)=1-10^(-17) cannot be distinguished from 1 with 16-byte words
     !
     erf = sign (1.d0, x)  
  else  
     if (abs (x) .le.0.47d0) then  
        x2 = x**2  
        erf = x * (p1 (1) + x2 * (p1 (2) + x2 * (p1 (3) + x2 * p1 ( &
             4) ) ) ) / (q1 (1) + x2 * (q1 (2) + x2 * (q1 (3) + x2 * q1 ( &
             4) ) ) )
     else  
        erf = 1.d0 - erfc (x)  
     endif
  endif
  !
  return  
end function erf
!
!---------------------------------------------------------------------
real(dp) function erfc (x)  
  !---------------------------------------------------------------------
  !
  !     erfc(x) = 1-erf(x)  - See comments in erf
  !

  real(kind=dp) :: x, ax, x2, xm2, p2 (8), q2 (8), p3 (5), q3 (5), pim1
  data p2 / 3.00459261020162d2, 4.51918953711873d2, &
       3.39320816734344d2, 1.52989285046940d2, 4.31622272220567d1, &
       7.21175825088309d0, 5.64195517478974d-1, - 1.36864857382717d-7 /
  data q2 / 3.00459260956983d2, 7.90950925327898d2, &
       9.31354094850610d2, 6.38980264465631d2, 2.77585444743988d2, &
       7.70001529352295d1, 1.27827273196294d1, 1.00000000000000d0 /
  data p3 / - 2.99610707703542d-3, - 4.94730910623251d-2, - &
       2.26956593539687d-1, - 2.78661308609648d-1, - 2.23192459734185d-2 &
       /
  data q3 / 1.06209230528468d-2, 1.91308926107830d-1, &
       1.05167510706793d0, 1.98733201817135d0, 1.00000000000000d0 /

  data pim1 / 0.564189583547756d0 /  
  !        ( pim1= sqrt(1/pi) )
  ax = abs (x)  
  if (ax.gt.26.d0) then  
     !
     !  erfc(26.0)=10^(-296); erfc( 9.0)=10^(-37);
     !
     erfc = 0.d0  
  elseif (ax.gt.4.d0) then  
     x2 = x**2  
     xm2 = (1.d0 / ax) **2  
     erfc = (1.d0 / ax) * exp ( - x2) * (pim1 + xm2 * (p3 (1) &
          + xm2 * (p3 (2) + xm2 * (p3 (3) + xm2 * (p3 (4) + xm2 * p3 (5) &
          ) ) ) ) / (q3 (1) + xm2 * (q3 (2) + xm2 * (q3 (3) + xm2 * &
          (q3 (4) + xm2 * q3 (5) ) ) ) ) )
  elseif (ax.gt.0.47d0) then  
     x2 = x**2  
     erfc = exp ( - x2) * (p2 (1) + ax * (p2 (2) + ax * (p2 (3) &
          + ax * (p2 (4) + ax * (p2 (5) + ax * (p2 (6) + ax * (p2 (7) &
          + ax * p2 (8) ) ) ) ) ) ) ) / (q2 (1) + ax * (q2 (2) + ax * &
          (q2 (3) + ax * (q2 (4) + ax * (q2 (5) + ax * (q2 (6) + ax * &
          (q2 (7) + ax * q2 (8) ) ) ) ) ) ) )
  else  
     erfc = 1.d0 - erf (ax)  
  endif
  !
  ! erf(-x)=-erf(x)  =>  erfc(-x) = 2-erfc(x)
  !
  if (x.lt.0.d0) erfc = 2.d0 - erfc  
  !
  return  
end function erfc
!---------------------------------------------------------------------
real(dp) function gauss_freq (x)  
  !---------------------------------------------------------------------
  !
  !     gauss_freq(x) = (1+erf(x/sqrt(2)))/2 = erfc(-x/sqrt(2))/2
  !             - See comments in erf
  !
  real(kind=dp) :: x, c

  data c / 0.707106781186548d0 /  
  !        ( c= sqrt(1/2) )
  gauss_freq = 0.5d0 * erfc ( - x * c)  
  !
  return  
end function gauss_freq
end module utilities

  subroutine set_vbare(vbare)
    use constants, only : dp
    use pw_types,  only : field, available, construct, field_ft, &
                          reciprocal_to_direct_space, reciprocal_space
    use structure, only  : atom, atoms, element, pseudo, species
    
    type(field)              :: vbare
    real(DP)                 :: q, dq
    complex(DP), pointer     :: vg(:), s(:)
    integer                  :: i,j,k, ig,  indx, n

    if (.not.available(vbare)) then
       call construct(vbare,RECIPROCAL_SPACE)
    else
       vbare%state = RECIPROCAL_SPACE
       vbare%val(:,:,:) = cmplx(ZERO,ZERO)
    end if

    do ig=1, vbare%ngm
       q = sqrt(vbare%gg(ig)*tpiba2)
       i = vbare%ig1(ig)
       j = vbare%ig2(ig)
       k = vbare%ig3(ig)

       do n=1, size(species)
          vg => species(n)%ps%vg
          s  => species(n)%s
          vbare%val(i,j,k) = vbare%val(i,j,k) + s(ig)*vg(ig)
       end do
    end do

    call field_ft(vbare,RECIPROCAL_TO_DIRECT_SPACE)
    
    return
  end subroutine set_vbare

module reciprocal_lattice
  use constants, only: dp
  use utilities, only: hpsort, error
  implicit none

  REAL(DP)                      :: gcutm    ! squared-wavevector cutoff (in
                                            ! units of tpiba2 = (2*pi/alat)^2)
                                            ! only wavevectors whose squared 
                                            ! norm does not exceed gcutm are 
                                            ! kept

  real(DP), allocatable, target :: g(:,:),& ! array of reciprocal-space 
                                            ! vectors arranged in order of
                                            ! increasing magnitude (unit is
                                            ! tpiba = (2*pi/alat) )
                                   gg(:)    ! squared norms of the g's

  integer                       :: ngm      ! current # of g's

  ! first two days up to here

  integer                       :: nr1=0, & !
                                   nr2=0, & ! current fft dimensions
                                   nr3=0    !
  
  integer, allocatable, target  :: ig1(:),& ! ig1(i), ig2(i), ig3(i)
                                   ig2(:),& ! are the fft indeces of
                                   ig3(:)   ! g(:,i)

  ! third day  up to here

  complex(dp), allocatable, target :: structure_factor(:,:)

  ! fourth day up to here

contains

  subroutine ggen(gcut)
    use structure, only: at, bg

    real(DP), intent(in)       :: gcut

    real(DP)                   :: t(3), tt
    integer, allocatable       :: nl(:)
    integer                    :: i,j,k, ng, nli, nx1,nx2,nx3

    logical, save              :: first=.true.

    gcutm = gcut

    ! count the total number of g-vectors such that |g|^2 <= gcutm

    if(.not. first) call error('ggen', &
         'this routine should be called only once',1)

    nx1=int(2*sqrt(gcutm)*sqrt(at(1,1)**2+at(2,1)**2+at(3,1)**2))+1
    nx2=int(2*sqrt(gcutm)*sqrt(at(1,2)**2+at(2,2)**2+at(3,2)**2))+1
    nx3=int(2*sqrt(gcutm)*sqrt(at(1,3)**2+at(2,3)**2+at(3,3)**2))+1

    ngm = 0
    do i = -(nx1+1), nx1+1
       do j = -(nx2+1), nx2+1
          do k = -(nx3+1), nx3+1
             t(:) = i*bg(:,1) + j*bg(:,2) + k*bg(:,3)
             tt   = t(1)*t(1) + t(2)*t(2) + t(3)*t(3)
             if ( tt <= gcutm ) ngm = ngm + 1
          end do
       end do
    end do

    ! allocate memory for g-vectors and their squared norms

    allocate(g(3,ngm))
    allocate(gg(ngm))
    allocate(nl(ngm))

    ! re-calculate the g-vectors and their squared norms and store them

    ngm = 0
    do i = -(nx1+1), nx1+1
       do j = -(nx2+1), nx2+1
          do k = -(nx3+1), nx3+1
             t(:) = i*bg(:,1) + j*bg(:,2) + k*bg(:,3)
             tt   = t(1)*t(1) + t(2)*t(2) + t(3)*t(3)
             if ( tt <= gcutm ) then
                ngm      = ngm + 1
                g(:,ngm) = t(:)
                gg(ngm)  = tt
             end if
          end do
       end do
    end do

    ! sort the g's in order of increasing norm

    nl(1) = 0 ! this is an input value to the hpsort routine to 
              ! indicate that the nl array is not initialized
    call hpsort( gg(1:ngm), nl )

    do ng = 1, ngm-1
       i = ng
       t(:) = g(:,i)
       do while ( nl(i) /= ng )
          nli    = nl(i)
          g(:,i) = g(:,nli)
          nl(i)  = i
          i      = nli
       end do
       g(:,i) = t(:)
       nl(i) = i
    end do

    deallocate (nl)
    first = .false.

    return
  end subroutine ggen

  ! first two days up to here

  subroutine set_fft(mr1,mr2,mr3)
    
    ! sets fft dimensions (nr1,nr2,nr3), pivot arrays (ig1,ig2,ig3,nl), 
    ! and current number of g vectors (|g|<=gcutm)

    use structure, only: at

    integer, intent(in), optional :: mr1, mr2, mr3
    integer :: ng, n1, n2, n3, minr1, minr2, minr3, maxr1, maxr2, maxr3, ngx

    nr1 = 0
    if(present(mr1)) nr1 = mr1
    nr2 = 0
    if(present(mr2)) nr2 = mr2
    nr1 = 0
    if(present(mr3)) nr3 = mr3

    ngx = ngm
    
    if(.not.allocated(ig1)) allocate ( ig1(ngx) )
    if(.not.allocated(ig2)) allocate ( ig2(ngx) )
    if(.not.allocated(ig3)) allocate ( ig3(ngx) )

    maxr1 = -100000
    maxr2 = -100000
    maxr3 = -100000
    minr1 =  100000
    minr2 =  100000
    minr3 =  100000

    do ng =1, ngx

       if( dot_product(g(:,ng),g(:,ng)) > gcutm ) exit
       
       n1      = nint( dot_product(g(:,ng),at(:,1)) )
       maxr1   = max(n1,maxr1)
       minr1   = min(n1,minr1)
       ig1(ng) = n1
       
       n2      = nint( dot_product(g(:,ng),at(:,2)) )
       maxr2   = max(n2,maxr2)
       minr2   = min(n2,minr2)
       ig2(ng) = n2

       n3      = nint( dot_product(g(:,ng),at(:,3)) )
       maxr3   = max(n3,maxr3)
       minr3   = min(n3,minr3)
       ig3(ng) = n3

    end do

    if( minr1 /= -maxr1 .or. minr2 /= -maxr2 .or. minr3 /= -maxr3 ) &
         call error("set_fft","wrong input data: nrmin /= -nrmax",1)
    
    if( 2*maxr1+1 > nr1 .or. 2*maxr2+1 > nr2 .or. 2*maxr3+1 > nr3 ) then
       nr1 = 2*maxr1 + 1
       nr2 = 2*maxr2 + 1
       nr3 = 2*maxr3 + 1
    end if

    do
       if( allowed(nr1) ) exit
       nr1 = nr1 + 1
    end do

    do 
       if( allowed(nr2) ) exit
       nr2 = nr2 + 1
    end do

    do 
       if( allowed(nr3) ) exit
       nr3 = nr3 + 1
    end do

    do ng = 1, ngm
       
       if( ig1(ng) < 0 ) ig1(ng) = ig1(ng) + nr1
       ig1(ng) = ig1(ng) + 1
       
       if( ig2(ng) < 0 ) ig2(ng) = ig2(ng) + nr2
       ig2(ng) = ig2(ng) + 1
       
       if( ig3(ng) < 0 ) ig3(ng) = ig3(ng) + nr3
       ig3(ng) = ig3(ng) + 1
       
    end do
    
    return
    
  end subroutine set_fft
  
  function allowed ( nr ) result(is_allowed)
    
    ! find if the fft dimension is a good one
    ! a "bad one" is either not implemented (as on IBM with ESSL)
    ! or implemented but with awful performances (most other cases)

    integer, intent(in)         :: nr
    logical                     :: is_allowed
    
    integer, dimension(5)            :: pwr
    integer, dimension(5), parameter :: factors = (/ 2, 3, 5, 7, 11 /)
    
    integer                     :: mr, i, fac, p, maxpwr
    
    ! find the factors of the input fft dimension
    
    mr = nr
    
    pwr(:) = 0
    
    for_each_factor: do i=1,5
       fac=factors(i)
       maxpwr = nint(log(real(mr))/log(real(fac)))+1
       do p=1, maxpwr
          if ( mr==1 ) then
             exit for_each_factor
          else if ( modulo (mr,fac) == 0 ) then
             mr=mr/fac
             pwr(i)=pwr(i)+1
          end if
       end do
    end do for_each_factor
    
    is_allowed = ( mr == 1 )
    
    return
    
  end function allowed
  
!> Subroutine {\tt set\_structure\_factor} sets up the atomic structure 
!> factor for each atomic {\tt species}: \begin{equation} {1\over \Omega} 
!> S({\bf G}) = \sum_{\tau} {\rm e}^{-i{\bf G}\cdot\tau}, \end{equation} 
!> where the sum is extended to all the atoms in the unit cell of the given 
!> species, and $\Omega$ is the volume of the unit cell.

  subroutine set_structure_factor
    use constants, only: zero, tpi
    use structure, only: element, species, atom, atoms, ntyp, nats, omega
    implicit none
    integer        :: na, nt, k
    real(DP)       :: phase
    
    if (.not.allocated(structure_factor)) then
       allocate(structure_factor(ngm,ntyp))
    else
       if (ngm/=size(structure_factor,1)) call error ('set_structure_factor', &
            '1st structure_factor dimension has been changed ',ngm)
       if (ntyp/=size(structure_factor,2)) call error ('set_structure_factor',&
            '2nd structure_factor dimension has been changed ',ngm)
    end if

    do k=1, ngm
       structure_factor(k,:) = cmplx(ZERO,ZERO)
       do na=1, nats
          nt = atoms(na)%itype 
          phase = dot_product(g(:,k),atoms(na)%tau) * TPI
          structure_factor(k,nt) = structure_factor(k,nt) &
               + cmplx(cos(phase),-sin(phase))
       end do
    end do
    structure_factor = structure_factor / omega

    do nt=1,ntyp
       species(nt)%s => structure_factor(:,nt)
    end do

    return
    
  end subroutine set_structure_factor
  
end module reciprocal_lattice

module phonon_mod

 use constants, only : dp
 use pw_types,  only : field
 use energy_bands, only : evc, et, unit_psi_in
 implicit none

 type(field) :: dmuxc                        ! the derivative of xc potential
 integer :: nks, nbnd
 real(kind=dp) :: q(3)                       ! the q point
 real(kind=dp) :: alpha_pv
 real(kind=dp), allocatable :: xkq(:,:), wkq(:)
 real(kind=dp), allocatable :: amass(:)      ! the mass of the atoms      
 complex(kind=dp), allocatable :: dyn(:,:)         ! the dynamical matrix
 complex(kind=dp), allocatable, target :: evq(:,:)  ! wavefunctions and

 
contains
!
!---------------------------------------------------------------------------
!
subroutine phonon(ecut)
!>
!> This routine is the main driver of the linear response calculation.
!> It uses four additional routines.
use structure, only : nats
implicit none
real(kind=dp) :: ecut

allocate(dyn(3*nats, 3*nats))
dyn=(0.d0,0.d0)
!>
!> {\tt phq\_init} initializes the variables of the phonon calculation:
   call phq_init(ecut)
!>
!> {\tt dynmat0} computes the part of the dynamical matrix indepedent
!> from the induced change density. This part of the dynamical matrix
!> has two terms. The second derivative of the ion-ion Ewald energy
!> with respect to two atomic displacements and the expectation value 
!> of the second derivative of the bare potential with respect to 
!> the displacement of the same atom.
   call dynmat0
!>
!> {\tt phqscf} sets up the linear system, evaluates the change of the 
!> wavefunctions due to the atomic displacement and computes the
!> induced charge density. Finally, it computes the part of
!> the dynamical matrix which depends on the induced charge density.
   call phqscf(ecut)
!>
!> {\tt dyndia} forces the dynamical matrixi to be Hermitian. It divides this
!> matrix by the square root of the masses and diagonalizes it.
   call dyndia

   deallocate(dyn)

end subroutine phonon
!
!--------------------------------------------------------------------------
!
 subroutine dynmat0
!>
!>  This routine computes the part of the dynamical matrix independent
!>  from the induced charge density.
 use constants, only : tpiba2, tpi
 use pw_types,  only : destroy, assignment(=), field_ft, &
                       direct_to_reciprocal_space
 use structure, only : atoms, species, nats, ntyp
 use reciprocal_lattice, only : g, ngm
 use ewald, only : d2ionq
 use scf, only: rho
 
 complex(kind=DP),pointer :: vg(:)
 real(kind=DP) :: fac, gtau
 type(field) :: aux
 integer :: na, icart, jcart, na_icart, na_jcart, ng
!>
!> The routine {\tt d2ionq} computes the second derivative of the ion-ion
!> Ewald energy:
 call d2ionq(q,dyn)
!>
!> The expectation value of the second derivative of the bare potential
!> with respect to an atomic displacement is calculated here.
!> It has only diagonal elements $s=s'$ and it reads: 
!> \begin{equation}  
!> \int d^3 r {\partial^2 V_{bare}\over \partial u_{s\alpha}({\bf q=0})
!> u_{s'\beta}({\bf q=0})} \rho({\bf r})= -\delta_{ss'}\sum_{\bf G} 
!> \rho^*({\bf G})
!> e^{-i{\bf G}\cdot{\tau_s}} {\bf G}_\alpha {\bf G}_\beta V^s({\bf G})
!> \end{equation}
 aux=rho
 call field_ft(aux,DIRECT_TO_RECIPROCAL_SPACE)

 do na = 1, nats
    vg => species(atoms(na)%itype)%ps%vg
    do ng = 1, ngm
       gtau = tpi*(g(1,ng)*atoms(na)%tau(1) + &
                   g(2,ng)*atoms(na)%tau(2) + &
                   g(3,ng)*atoms(na)%tau(3) )
       fac = vg(ng)*tpiba2* &
            (DREAL(aux%val(aux%ig1(ng),aux%ig2(ng),aux%ig3(ng)))*cos(gtau)&
            -DIMAG(aux%val(aux%ig1(ng),aux%ig2(ng),aux%ig3(ng)))*sin(gtau))
       do icart = 1, 3
          na_icart = 3 * (na - 1) + icart
          do jcart = 1, 3
             na_jcart = 3 * (na - 1) + jcart
            dyn (na_icart,na_jcart)=dyn(na_icart,na_jcart)- &
                                     fac*g(icart,ng)*g(jcart,ng)
          enddo
       enddo
    enddo
 enddo
 
 call destroy(aux)

 return
 end subroutine dynmat0
!
!--------------------------------------------------------------------------
!
 subroutine phqscf(ecut)
 use pw_types, only : construct, destroy, direct_space
 use structure, only :  nats
!>
!>  This routine is a driver. For each atom $s$ which moves in the
!>  $\alpha$ direction ($x$, $y$ or $z$), {\tt solve\_linter} sets up
!>  and solves a linear system which gives the first order change of the 
!>  wavefunctions due to the perturbation. These quantities are used 
!>  to calculate the induced charge density
!>  $d\rho\over d u_{s\alpha}({\bf q})$. Finally, this routine calls 
!>  {\tt drhodv} which calculates the remaining part of the dynamical matrix. 
 implicit none
 real(kind=dp) :: ecut
 type(field) :: drhoscf    ! for each mode contains d rho / d u
 integer :: mode

 call construct(drhoscf,DIRECT_SPACE)
 do mode=1,3*nats
    call solve_linter (drhoscf,mode,ecut)
    call drhodv(drhoscf, mode)
 enddo 
 call destroy(drhoscf)
 
 return
 end subroutine phqscf
!
!--------------------------------------------------------------------------
!
 subroutine solve_linter(drhoscf,mode,ecut)
!>
!> This routine sets up and solves a self-consistent linear system.
!> The solutions are the derivatives of the wave-functions with respect 
!> to the atomic displacement.
!> This routine is called for each perturbation. 
 use constants, only : zero
 use scf, only : broyden, linear_mixing
 use pw_types, only: construct, destroy, assignment(=), axpy, &
                     field_times_wvfct, k_point, wave_function, field, &
                     direct_space, operator(.dot.)

 implicit none

 integer, intent(in) :: mode             ! the mode to do
 type(field), intent(inout) :: drhoscf   ! save the delta rho
 real(kind=dp), intent(in) :: ecut       ! cut-off energy


 integer :: kter                      ! counter on interation
 integer :: ibnd,jbnd                 ! counters on bands
 integer :: ik,i,n_iter,npw,npwq, idum ! counters
 integer, parameter :: niter_ph=100   ! maximum number of iterations
 type(k_point), target :: kvect, kqvect ! the k vector

 complex(kind=dp), allocatable,target :: dvpsi(:,:), dpsi(:,:)
 type(wave_function), allocatable :: psi(:), psiq(:), dvpsiq(:), dpsiq(:)
 type(wave_function)  :: auxg         ! auxiliary
 type(field) :: dvin, dvout           ! self consistent potentials
 real(kind=dp) :: dr2, thresh, weight, beta, tol, anorm, kk(3)
 real(kind=dp), allocatable :: h_diag(:)! preconditioning
 real(kind=dp), allocatable :: etq(:) ! eigenvalues at k+q
 complex(kind=dp) :: ps               ! auxiliary
 logical :: conv_root                 ! check convergence of linear system
 logical :: convt                     ! if true convergence has been achieved


 write(6,'(''Computing perturbation #'',i5)') mode
 write(6,*)

 call construct(dvin,DIRECT_SPACE)
 call construct(dvout,DIRECT_SPACE)

 open(unit=4,form='unformatted',status='scratch') 
 open(unit=8,form='unformatted',status='scratch') 
 open(unit=9,form='unformatted',status='scratch') 
!>
!>  Iterate to self-consistence:
 do kter = 1, niter_ph
     
    convt = .true.
    drhoscf=(ZERO, ZERO)
    rewind (unit = unit_psi_in) ! with wavefunctions 
    rewind (unit = 4) ! with dvpsi
    rewind (unit = 8) ! with dpsi 
    rewind (unit = 9) ! with dpsi 
!>
!> Threshold for the iterative solution of the linear system:
    if (kter.gt.1) thresh = max(min(thresh*0.25d0,sqrt(dr2)),1.d-12)
!>
!>  For each ${\bf k}$ point we construct and solve the linear system:
    do ik = 1, nks
       call construct( kvect, xkq(:,2*ik-1), ecut )
       call construct( kqvect, xkq(:,2*ik), ecut )
       npw=kvect%npw
       npwq=kqvect%npw
       allocate(evc(npw,nbnd),et(nbnd))
       allocate(evq(npwq,nbnd),etq(nbnd))
       allocate(dpsi(npwq,nbnd),dvpsi(npwq,nbnd),h_diag(npwq))
       allocate(psi(nbnd),psiq(nbnd),dvpsiq(nbnd),dpsiq(nbnd))
       read(unit_psi_in) kk(:), idum, idum
       read(unit_psi_in) evc, et
       read(unit_psi_in) kk(:), idum, idum
       read(unit_psi_in) evq, etq
       call construct(psi,kvect,evc)
       call construct(psiq,kqvect,evq)
       call construct(dvpsiq,kqvect,dvpsi)
       call construct(dpsiq,kqvect,dpsi)
       call construct(auxg,kqvect)

       if (kter.eq.1) then
!>
!>  At the first iteration the change of the wavefunction
!>  {\tt dpsi} and the change of the Hartree and exchange and 
!>  correlation potential
!>  {\tt dvin} are set to zero. We also call {\tt dvqpsi} to compute
!>  the non self-consistent part of the right hand side of the linear system.
          dpsi=(ZERO,ZERO)
          dvin=(ZERO,ZERO)
          call dvqpsi (dvpsiq,psi,mode)
          write(4) dvpsi
!>
!> Starting threshold for the iterative solution of the linear system:
          thresh = 1.0d-2
       else
!>
!>  After the first iteration, the non self-consistent part of the right
!>  hand side is read from file, as well as an estimate of the solution of the
!>  linear system {\tt dpsi}. This estimate is the solution of the 
!>  linear system at the previous iteration.
          read(4) dvpsi
          if (mod(kter,2)==0) read(8) dpsi
          if (mod(kter,2)==1) read(9) dpsi
!> 
!> After the first iteration we have an estimate of the induced Hartree 
!> and exchange and correlation potential. The right hand side of the
!> linear system depends self-consistently from the induced potential.
!> We compute here the product ${\partial V_{Hxc}({\bf r})\over 
!> \partial u_{s\alpha}({\bf q})}\|\psi_{{\bf k}v}\rangle$
!> and add it to {\tt dvpsi}.
          do ibnd = 1, nbnd
             call field_times_wvfct(dvin,psi(ibnd),auxg)
             call axpy((1.d0,0.d0), auxg, dvpsiq(ibnd))
          enddo
       endif
!>
!>  Here we apply the projector on the conduction band to the right
!>  hand side of the linear system ($P_{{\bf k+q}c}=1-P_{{\bf k+q}v}$):
       do ibnd = 1, nbnd
!          auxg%val=(0.d0,0.d0)
          auxg=(0.d0,0.d0)
          do jbnd = 1, nbnd
             ps=-(psiq(jbnd).dot.dvpsiq(ibnd))
             call axpy(ps, psiq(jbnd), auxg)
          enddo
          call axpy((1.d0,0.d0), auxg, dvpsiq(ibnd))
       enddo
!>
!> Finally we put the minus sign: 
       dvpsi=-dvpsi
!>
!>  and call {\tt cgsolve\_all} to solve the linear system for all bands.
!>  {\tt h\_diag} is a preconditioning vector.
       h_diag=1.d0/max(1.0d0,kqvect%gk)
       conv_root = .true.
       call cgsolve_all (et, dvpsi, dpsi, h_diag, npwq, &
                    thresh, kqvect, conv_root, anorm, nbnd)
       if (.not.conv_root) write(6,'('' Some roots are not converged'')')
!>
!> Now {\tt dpsi} contains the change of the wavefunctions, at the current
!> ${\bf k}$ point, due to the current perturbation.
!> We save it on file to use it at the next iteration.
       if (mod(kter,2).eq.1) write(8) dpsi
       if (mod(kter,2).eq.0) write(9) dpsi
!>
!> And add the contribution of this wavefunctions to the induced charge
!> density, calling the routine {\tt incdrhoscf}:
       weight = wkq(2*ik-1)
       call incdrhoscf (drhoscf, psi, dpsiq, weight)
!>
!>  Deallocate and destroy all the variables which depend on the ${\bf k}$
!>  and ${\bf k+q}$ point.

       call destroy(psi)
       call destroy(psiq)
       call destroy(dvpsiq)
       call destroy(dpsiq)
       call destroy(auxg)
       deallocate(evc,et,evq,etq)
       deallocate(dpsi,dvpsi,h_diag)
       deallocate(psi,psiq,dvpsiq,dpsiq)
       call destroy(kvect)
       call destroy(kqvect)
  enddo
!>
!> After the loop on ${\bf k}$ points, {\tt drhoscf} contains the 
!> current estimate of the induced charge density. Now we can compute 
!> the induced Hartree and exchange and correlation potential.
  call dv_of_drho (drhoscf, dvout)
!>
!>  Finally we mix the old and the new potential and check for self-consistency.
!>  We use the same routine ({\tt Broyden}) written for mixing the potentials
!>  in the unperturbed problem.
  beta=0.7
  tol=1.d-12
  n_iter=4
  convt = broyden(dvin,dvout,beta,kter,n_iter,tol,dr2)
  dvin=dvout

  write(6, 500) kter, tol, dr2
500 format('iter =', i5, ' expected scf =', e15.3, ' delta dv = ', e15.3)
  if (convt) goto 155
!>
!> If not converged, make another iteration with the new potential.
enddo   ! on iterations
155 continue
call destroy(dvin)
call destroy(dvout)
write(6,*)
close(4)
close(8)
close(9)
return
end subroutine solve_linter
!
!--------------------------------------------------------------------------
!
subroutine drhodv(drhoscf,mode)
!>
!>  The part of the dynamical matrix which depends on the induced
!>  charge density is: 
!>  \begin{equation}
!>  \int d^3 r {\partial \rho({\bf r})^* \over \partial u_{s\alpha}({\bf q})}
!>  {\partial V_{bare}({\bf r})\over \partial u_{s'\beta}({\bf q})}
!>  \end{equation}
!>  The routine {\tt compute\_dvloc} computes the derivative of the bare
!>  potential for each mode while {\tt drhoscf} contains the charge
!>  induced by a displacement along the {\tt mode} mode.
!>  This routine calculates the integral using the {\tt .dot.} operator
!>  defined in the {\tt pw\_types} to integrate the product of two fields.
!>
use structure, only : omega, nats
use pw_types, only : field, construct, destroy, operator(.dot.), &
                     reciprocal_space
implicit none
integer, intent(in) :: mode
type(field), intent(in) :: drhoscf
type(field) :: dvloc
integer :: nu
do nu = 1, 3 * nats
   call construct(dvloc,RECIPROCAL_SPACE)
   call compute_dvloc(nu, dvloc)
   dyn(mode,nu)=dyn(mode,nu)+ (drhoscf.dot.dvloc)*omega
   call destroy(dvloc)
enddo

return
end subroutine drhodv
!
!--------------------------------------------------------------------------
!
subroutine incdrhoscf(drhoscf,psi,dpsiq,weight)
!>
!>  This routine adds the contribution of the current ${\bf k}$ point
!>  wavefunctions to the induced charge density:
!>  \begin{equation}
!>  {d \rho_{\bf k} \over d u_{s\alpha}({\bf q})} = 4 \sum_v 
!>  \psi^*_{{\bf k}v}({\bf r})
!>  {d \psi_{{\bf k}v}({\bf r}) \over d u_{s\alpha}({\bf q}) } 
!>  \end{equation}
use constants, only : degspin
use structure, only : omega
use pw_types,  only : field_ft, assignment(=), set_field_state, &
                      reciprocal_space, reciprocal_to_direct_space, &
                      field, wave_function, destroy
implicit none
type(field), intent(inout) :: drhoscf
type(wave_function), intent(in) :: psi(:), dpsiq(:)
real(kind=dp),intent(in) :: weight

type(field) :: aux1, aux2
real(kind=dp) :: wgt
integer :: ibnd

wgt=2.d0*weight*degspin/omega

do ibnd = 1, nbnd
   aux1=psi(ibnd)
   aux2=dpsiq(ibnd)
   call field_ft(aux1, RECIPROCAL_TO_DIRECT_SPACE)
   call field_ft(aux2, RECIPROCAL_TO_DIRECT_SPACE)
   drhoscf%val = drhoscf%val + wgt*conjg(aux1%val)*aux2%val
   call set_field_state(aux1,RECIPROCAL_SPACE)
   call set_field_state(aux2,RECIPROCAL_SPACE)
enddo
call destroy(aux1)
call destroy(aux2)

return
end subroutine incdrhoscf
!
!--------------------------------------------------------------------------
!
subroutine dv_of_drho(drhoscf,dvout)
!>
!> This routine receives as input the induced charge density at a
!> given iteration and calculates the induced Hartree and exchange 
!> and correlation potential.
!> The induced exchange and correlation potential is calculated 
!> in direct space. We have:
!> \begin{equation}
!> {\partial V_{xc}({\bf r})\over \partial u_{s\alpha}({\bf q})} =
!> {\partial V_{xc}({\bf r})\over \partial \rho({\bf r})}
!> {\partial \rho({\bf r})\over \partial u_{s\alpha}({\bf q})}
!> \end{equation}
!> ${\partial V_{xc}({\bf r})\over \partial \rho({\bf r})}$ is calculated
!> only once in {\tt phq\_init} and saved in {\tt dmuxc}.
!>
!> The induced Hartree potential is calculated in reciprocal space 
!> and Fourier transform brings it to direct space.
!> \begin{equation}
!> {\partial V_{H}({\bf q+G})\over \partial u_{s\alpha}({\bf q})}=
!> {\partial \rho({\bf q+G})\over \partial u_{s\alpha}({\bf q})} 
!> {4\pi e^2 \over ({\bf q+G})^2}
!> \end{equation}
use constants, only : e2, fpi, tpiba2
use pw_types, only : construct, destroy, field_ft, assignment(=), field, &
                     direct_space, reciprocal_to_direct_space, &
                     direct_to_reciprocal_space
use reciprocal_lattice, only : g, ngm, ig1, ig2, ig3
implicit none
type(field) :: drhoscf, dvout
type(field) :: dvaux
real(kind=dp) :: qg2
integer :: ig
!>
!>  The induced exchange and correlation potential:
call construct(dvaux,DIRECT_SPACE)
dvaux%val  = dmuxc%val * drhoscf%val
!>
!>  This potential is transformed to reciprocal space to be added to the 
!>  induced Hartree potential:
call field_ft(dvaux,DIRECT_TO_RECIPROCAL_SPACE)
!>
!>  The induced Hartree potential. First we bring the charge to reciprocal
!>  space and then apply the equation, adding it to the exchange and
!>  correlation part
dvout=drhoscf
call field_ft(dvout,DIRECT_TO_RECIPROCAL_SPACE)
do ig = 1, ngm
   qg2 = (g(1,ig)+q(1))**2+(g(2,ig)+q(2))**2+(g(3,ig)+q(3))**2
   if (qg2.gt.1.d-8) then
       dvaux%val(ig1(ig),ig2(ig),ig3(ig))= &
             dvaux%val(ig1(ig),ig2(ig),ig3(ig))+e2*fpi* &
             dvout%val(ig1(ig),ig2(ig),ig3(ig))/(tpiba2*qg2)
   endif
enddo
!>
!> Finally, transform to direct space:
dvout=dvaux

call field_ft(dvout,RECIPROCAL_TO_DIRECT_SPACE)
call destroy(dvaux)

return
end subroutine dv_of_drho
!
!------------------------------------------------------------------------
!
subroutine dvqpsi(dvpsiq,psi,mode)
!>
!>  This routine computes the non self-consistent part of the right 
!>  hand side of the linear system
!>  ${\partial V_{bare}({\bf r})\over \partial u_{s\alpha}({\bf q})} 
!>  \| \psi_{{\bf k}v} \rangle$. The routine {\tt compute\_dvloc}
!>  computes the derivative of the potential and this routine calls
!>  {\tt field\_times\_wvfct} to apply the potential to the wavefunctions:
use pw_types, only : construct, field, wave_function, field_times_wvfct, &
                     reciprocal_space, destroy
implicit none

integer, intent(in) :: mode                ! the mode for this perturbation
type(wave_function), intent(inout) :: psi(:), dvpsiq(:) 
type(field) :: aux1
integer :: ibnd

call construct(aux1,RECIPROCAL_SPACE)
call compute_dvloc(mode,aux1)
do ibnd = 1, nbnd
   call field_times_wvfct(aux1,psi(ibnd),dvpsiq(ibnd))
enddo
call destroy(aux1)
return
end subroutine dvqpsi
!
!---------------------------------------------------------------------------
!
subroutine ch_psi_all (n, h, ah, e, kqvect, m)
!>
!>  This routine applies to the $m$ vectors {\tt h(:,m)}
!>  the operator $H-\varepsilon_m+Q$ where $H$ is the Hamiltonian, 
!>  $\varepsilon_m$ is the eigenvalue and
!>  $Q=\alpha_v \sum_{kv} \|\psi_{{\bf k}v} \rangle\langle
!>  \psi_{{\bf k}v}\|$ is the projector on the valence band, multiplied
!>  by $\alpha_v$. $\alpha_v$ is computed in {\tt phq\_init} and
!>  is sufficiently big to assure that the linear system is not
!>  singular.
use energy_bands, only : et
use hamiltonian, only: h_psi
use pw_types, only : k_point, wave_function, construct, destroy
implicit none
integer :: n, m

type(k_point) :: kqvect
type(wave_function) :: psih, psip
complex(kind=dp) :: h(n,nbnd), ah(n,nbnd)
real(kind=dp) :: e(nbnd)

complex(kind=dp), allocatable, target :: ps(:,:)
integer ibnd

allocate(ps(nbnd,m))
!>
!> Compute the product of the Hamiltonian and the h vector
do ibnd = 1, m
   call construct(psih,kqvect,h(:,ibnd))
   call construct(psip,kqvect)
!>
!>  Apply $H$ to the wavefunction
   call h_psi(psih,psip)
!>
!>   then we compute the operator $(H-\epsilon)$ on the wavefunctions
   ah(:,ibnd) = psip%val(:) - e(ibnd)*psih%val(:)
   call destroy(psip)
   call destroy(psih)
enddo
!>
!>   Here we apply the $Q$ operator 
ps=(0.d0,0.d0)

call ZGEMM ('C', 'N', nbnd, m, n, (1.d0, 0.d0) , evq, &
      n, h, n, (0.d0, 0.d0) , ps, nbnd)

ps=ps*alpha_pv

call ZGEMM ('N', 'N', n, m, nbnd, (1.d0, 0.d0) , evq, &
      n, ps, nbnd, (1.d0, 0.d0) , ah, n)

deallocate(ps)

return
end subroutine ch_psi_all
!
!---------------------------------------------------------------------------
!
subroutine cg_psi(psi, h_diag)
!>
!>  Preconditioning of the CG procedure.
implicit none

complex(kind=DP) :: psi (:, :) ! inp/out: the vector to be preconditioned
real(kind=DP) :: h_diag (:, :) ! input: the preconditioning vector

psi = psi * h_diag

return
end subroutine cg_psi 
!
!---------------------------------------------------------------------------
!
subroutine compute_dvloc(mode,dvloc)
!>
!>  This routine computes ${\partial V_{bare}({\bf r})\over \partial 
!>  u_{s\alpha}({\bf q})}$. It sets its Fourier components and 
!>  makes a Fourier transform to direct space.
!>  We have:
!>  \begin{equation}
!>  {\partial V_{bare}({\bf q+G})\over \partial u_{s\alpha}({\bf q})}=
!>  -i({\bf q}+{\bf G})_\alpha V^s({\bf q}+{\bf G}) 
!>   e^{-i({\bf q}+{\bf G})\cdot {\bf \tau}_s}
!>  \end{equation}
use constants, only : tpiba, tpi
use structure, only : atoms, omega, species
use pw_types, only : assignment(=), field, field_ft, reciprocal_to_direct_space
implicit none
integer, intent(in) :: mode
type(field), intent(inout) :: dvloc

integer :: na, ipol, nt, ig
real(kind=dp) :: arg
complex(kind=dp) :: eigqts, fact, gtau

dvloc=(0.d0,0.d0)

na=(mode-1)/3+1
ipol=mod(mode-1,3)+1

arg = (q(1)*atoms(na)%tau(1)+q(2)*atoms(na)%tau(2)+q(3)*atoms(na)%tau(3))*tpi
eigqts=cmplx(cos(arg),-sin(arg))
fact = tpiba*(0.d0, -1.d0)*eigqts/ omega
nt = atoms(na)%itype
do ig = 1, dvloc%ngm
   arg = ( dvloc%g(1,ig)*atoms(na)%tau(1) + &
           dvloc%g(2,ig)*atoms(na)%tau(2) + &
           dvloc%g(3,ig)*atoms(na)%tau(3)  ) * tpi
   gtau = cmplx(cos(arg),-sin(arg))
   dvloc%val(dvloc%ig1(ig),dvloc%ig2(ig),dvloc%ig3(ig)) = &
   dvloc%val(dvloc%ig1(ig),dvloc%ig2(ig),dvloc%ig3(ig) )  &
   +species(nt)%ps%vgq(ig)*(q(ipol)+ dvloc%g(ipol,ig))*fact*gtau
enddo
call field_ft (dvloc,RECIPROCAL_TO_DIRECT_SPACE)

return
end subroutine compute_dvloc
!
!---------------------------------------------------------------------------
!
subroutine phq_init(ecut)
!>
!>  This routine computes the main quantities needed in the phonon
!>  calculation. It converts the masses to atomic units,
!>  computes the second derivative of the exchange and
!>  correlation energy with respect to the charge, 
!>  and sets the shift $\alpha_v$ which multiply the valence band
!>  projector. 
use scf, only : rho
use pw_types, only : construct, k_point, direct_space, destroy

implicit none
integer :: i,j,k
real(kind=dp) :: rhotot, emin, emax, ecut, kk(3)
real(kind=dp), parameter :: amconv= 1.66042d-24/9.1095d-28*0.5d0
integer :: ik, ibnd, inbnd, inpw
type(k_point) :: kvect
!>
!>  Mass conversion:
amass=amconv*amass
!>
!>  The function {\tt dmxc} calculates numerically the derivative of 
!>  the exchange and correlation potential with respect to the charge.
!>  Within LDA, this function is local.
call construct(dmuxc, DIRECT_SPACE)

dmuxc%val=0.d0
do i=1, rho%nr1
   do j=1, rho%nr2
      do k=1, rho%nr3
         rhotot=rho%val(i,j,k)
         if (rhotot.gt.1.d-30) dmuxc%val(i,j,k) = dmxc (rhotot)
      enddo
   enddo
enddo
!>
!>  Reads from file all the eigenvalues and finds the maximum and minimum
!>  eigenvalues which are used to set $\alpha_v$.
rewind(unit_psi_in)
call construct( kvect, xkq(:,1), ecut )
read(unit_psi_in) kk(:), inbnd, inpw
allocate(evc(kvect%npw,nbnd),et(nbnd))
read(unit_psi_in) evc,et
emin = et(1)
emax = et(1)
do ik=1,2*nks
   if (ik.gt.1) then
      call construct( kvect, xkq(:,ik), ecut )
      read(unit_psi_in) kk(:), inbnd, inpw
      allocate(evc(kvect%npw,nbnd),et(nbnd))
      read(unit_psi_in) evc,et
   endif  
   do ibnd = 1, nbnd
      emax = max (emax, et (ibnd) )
      emin = min (emin, et (ibnd) )
   enddo
   call destroy(kvect)
   deallocate(evc,et)
enddo
alpha_pv = 2.d0 * (emax - emin)
!>
!> if $\alpha_v$ is too small set it to a small but reasonable number.
alpha_pv = max (alpha_pv, 1.0d-2)

return
end subroutine phq_init
!
!-----------------------------------------------------------------------
!
function dmxc (rho)  
!>
!> This routine evaluates the derivative of the xc potential with 
!> respect to the charge density.
use constants,   only : e2
use functionals, only : xc
implicit none  

real(kind=DP) :: rho, dmxc  
! input: the charge density ( positive )
! output: the derivative of the xc potential

real(kind=DP) :: dr, vxp, vcp, vxm, vcm, ex, ec  
! delta rrho for numerical derivatives
! the potentials for + charge
! the potentials for - charge
! the energy
real(kind=DP) :: small
parameter (small = 1.d-30)  

 dmxc = 0.d0  
 if (rho.le.small) return  
!>
!> Numerical differentiation of the exchange and correlation potential.
  dr = min (1.d-6, 1.d-4 * rho)  
  call xc(rho + dr, ex, ec, vxp, vcp)  
  call xc(rho - dr, ex, ec, vxm, vcm)  
  dmxc = (vxp + vcp - vxm - vcm) / (2.d0 * dr)  
!>
!> e2 brings energy to Ry units
  dmxc = e2 * dmxc  
  return  

end function dmxc
!
!---------------------------------------------------------------------------
!
subroutine cgsolve_all (e, d0psi, dpsi, h_diag, ndim, ethr, &
                           kqvect, conv_root, anorm, nbnd)
!----------------------------------------------------------------------
!
!     iterative solution of the linear system:
!
!                 ( h - e + Q ) * dpsi = d0psi                      (1)
!
!                 where h is a complex hermitian matrix, e is a real sca
!                 dpsi and d0psi are complex vectors
!
!     on input:
!                 h_psi             EXTERNAL  name of a subroutine:
!                                   h_psi(ndim,psi,psip)
!                                   Calculates  H*psi products.
!                                   Vectors psi and psip shoul be dimens
!                                   (ndim,nvec). nvec=1 is used!
!
!                 cg_psi             EXTERNAL  name of a subroutine:
!                                   g_psi(ndim,ndim,notcnv,psi,e)
!                                   which calculates (h-e)^-1 * psi, wit
!                                   some approximation, e.g. (diag(h)-e)
!
!                 e                 real     unperturbed eigenvalue.
!
!                 dpsi              contains an estimate of the solution
!                                   vector.
!
!                 d0psi             contains the right hand side vector
!                                   of the system.
!
!                 ndim              integer row dimension of dpsi, ecc.
!
!                 ndim              integer actual row dimension of dpsi
!
!                 ethr              real     convergence threshold. solu
!                                   improvement is stopped when the erro
!                                   eq (1), defined as l.h.s. - r.h.s.,
!                                   less than ethr in norm.
!
!     on output:  dpsi              contains the refined estimate of the
!                                   solution vector.
!
!                 d0psi             is corrupted on exit
!
!
!   Last revised 6 apr. 1997 by A. Dal Corso & F. Mauri
!
!
use pw_types, only : k_point

implicit none  
!
!   first the dummy variables
!
integer :: ndim, nbnd
! input: the maximum dimension of the vectors
! input: the actual dimension of the vectors
! output: counter on iterations
! input: the number of bands
type(k_point) :: kqvect
! input: the k point

real(kind=DP) :: e (nbnd), anorm, h_diag (ndim), ethr  
! input: the actual eigenvalue
! output: the norm of the error in the solution
! input: an estimate of ( H - epsilon
! input: the required precision

complex(kind=DP) :: dpsi (ndim, nbnd), d0psi (ndim, nbnd)  
! output: the solution of the linear syst
! input: the known term

logical :: conv_root  
! output: if true the root is converged
! input: the routine computing h_psi
! input: the routine computing cg_psi
!
!  three parameters
!

integer :: maxter  
! the maximum number of iterations
parameter (maxter = 200)  
!
!  here the local variables
!

integer :: iter, ibnd, lbnd
integer , pointer :: conv (:)  
! counter on iteration
! counter on bands
! if 1 the root is converged

complex(kind=DP), pointer :: g (:,:), gp (:,:), t (:,:), &
     h (:,:), hold (:,:), aux (:,:), aux1 (:,:)
complex(kind=DP) ::  dcgamma, dclambda, ZDOTC
!  the gradient of psi
!  the preconditioned gradient
!  the delta gradient
!  the conjugate gradient
!  the the old h
!  the the old h
!  the the old h
!  the ratio between rho
!  step lenght
!  the scalar product


real(kind=DP), pointer :: rho (:), rhoold (:), auxr (:,:), eu (:)
real(kind=DP) :: kter_eff, a, c
! the residue
! auxiliary for h_diag
! account the number of iterations with b
! coefficient of quadratic form
!
allocate(g(ndim,nbnd))  
allocate(gp(ndim,nbnd))  
allocate(t(ndim,nbnd))  
allocate(h(ndim,nbnd))  
allocate(hold(ndim,nbnd))  
allocate(aux1(ndim,nbnd))  
allocate(aux(ndim,nbnd))  
allocate(conv(nbnd))  
allocate(rho(nbnd))  
allocate(rhoold(nbnd))  
allocate(auxr(ndim,nbnd)) 
allocate(eu(nbnd)) 

kter_eff = 0.d0  
do ibnd = 1, nbnd  
   conv (ibnd) = 0  
enddo
do iter = 1, maxter  
!
!        compute the gradient. can reuse information from previous step
!
!
   if (iter.eq.1) then  
      call ch_psi_all (ndim, dpsi, g, e, kqvect, nbnd)  
      do ibnd = 1, nbnd  
        call ZAXPY(ndim,(-1.d0, 0.d0), d0psi(1,ibnd), 1, g(1,ibnd), 1)
      enddo
   endif
!
!  compute residual
!
   lbnd = 0  
   do ibnd = 1, nbnd  
      if (conv (ibnd) .eq.0) then  
         call ZCOPY (ndim, g (1, ibnd), 1, gp (1, ibnd), 1)  
         lbnd = lbnd+1  
         call ZCOPY (ndim, gp (1, ibnd), 1, aux (1, lbnd), 1)  
         call DCOPY (ndim, h_diag, 1, auxr (1, lbnd), 1)  
      endif
   enddo
   call cg_psi (aux(:,1:lbnd), auxr(:,1:lbnd))  
   kter_eff = kter_eff + float (lbnd) / float (nbnd)  
   lbnd = 0  
   do ibnd = 1, nbnd  
      if (conv (ibnd) .eq.0) then  
        lbnd = lbnd+1  
        call ZCOPY (ndim, aux (1, lbnd), 1, gp (1, ibnd), 1)  
      endif
   enddo
   do ibnd = 1, nbnd  
      if (conv (ibnd) .eq.0) then  
         rho(ibnd) = ZDOTC(ndim, gp (1, ibnd), 1, g (1, ibnd), 1)
         anorm = sqrt (rho (ibnd) )  
!               write(6,'(2i5,e20.5)') iter,ibnd,anorm
         if (anorm.lt.ethr) conv (ibnd) = 1  
      endif
   enddo
   conv_root = .true.  
   do ibnd = 1, nbnd  
      conv_root = conv_root.and. (conv (ibnd) .eq.1)  
   enddo
   if (conv_root) goto 100  
!
!        compute the step direction h. Conjugate it to previous step
!
   lbnd = 0  
   do ibnd = 1, nbnd  
      if (conv (ibnd) .eq.0) then  
        call ZCOPY (ndim, gp (1, ibnd), 1, h (1, ibnd), 1)  
        call DSCAL (2 * ndim, - 1.d0, h (1, ibnd), 1)  
        if (iter.ne.1) then  
           dcgamma = rho (ibnd) / rhoold (ibnd)  
           call ZAXPY (ndim, dcgamma, hold (1, ibnd), 1, h (1, ibnd), 1)
        endif
        rhoold (ibnd) = rho (ibnd)  
        call ZCOPY (ndim, h (1, ibnd), 1, hold (1, ibnd), 1)  
        lbnd = lbnd+1  
        call ZCOPY (ndim, h (1, ibnd), 1, aux (1, lbnd), 1)  
        eu (lbnd) = e (ibnd)  
      endif
   enddo
!
!        compute t = A*h
!
   call ch_psi_all (ndim, aux, aux1, eu, kqvect, lbnd)  
   lbnd = 0  
   do ibnd = 1, nbnd  
      if (conv (ibnd) .eq.0) then  
         lbnd = lbnd+1  
         call ZCOPY (ndim, aux1 (1, lbnd), 1, t (1, ibnd), 1)  
      endif
   enddo
!
!        compute the coefficients a and c for the line minimization
!        compute step length lambda
   do ibnd = 1, nbnd  
      if (conv (ibnd) .eq.0) then  
         a = ZDOTC (ndim, h (1, ibnd), 1, g (1, ibnd), 1)  
         c = ZDOTC (ndim, h (1, ibnd), 1, t (1, ibnd), 1)  
         dclambda = DCMPLX ( - a / c, 0.d0)  
!
!           move to new position
!
         call ZAXPY (ndim, dclambda, h (1, ibnd), 1, dpsi (1, ibnd), 1)
!
!           update to get the gradient
!
!g=g+lam
         call ZAXPY (ndim, dclambda, t(1, ibnd), 1, g (1, ibnd), 1)
      endif
   enddo
enddo
100 continue  
deallocate(eu)  
deallocate(auxr)  
deallocate(rho)  
deallocate(rhoold)  
deallocate(conv)  
deallocate(aux)  
deallocate(aux1)  
deallocate(hold)  
deallocate(h)  
deallocate(t)  
deallocate(gp)  
deallocate(g)  

return  
end subroutine cgsolve_all
!
!-----------------------------------------------------------------------
!
subroutine dyndia
!>
!>   This routine diagonalizes the dynamical matrix. 
!>   The frequencies are written on output by this routine.
use structure, only : nats, atoms
use lapack_wrap, only: cdiagh
implicit none  

real(kind=DP), allocatable :: w2 (:)  !   the frequencies square
integer :: nmodes, nta, ntb, mu, nu, na, nb
real(kind=DP) :: rydthz, rydcm1, w1
! conversion from a.u. to terahertz
! conversion from a.u. to cm^-1
! the frequency
complex(kind=DP), allocatable :: z(:,:)  

nmodes=3*nats
allocate(z(nmodes, nmodes))
allocate(w2(nmodes))
!>
!> The dynamical matrix must be exactly hermitian: 

do mu = 1, nmodes  
   do nu = 1, mu  
      dyn (mu, nu)=0.5d0*(dyn(mu,nu)+conjg(dyn(nu,mu)))
      dyn (nu, mu)=conjg(dyn(mu, nu))  
   enddo
enddo
!>
!> Divide the dynamical matrix by the square root of the masses:
do mu = 1, nmodes  
   na = (mu - 1) / 3 + 1  
   nta = atoms(na)%itype 
   do nu = 1, nmodes  
      nb = (nu - 1) / 3 + 1  
      ntb = atoms(nb)%itype  
      dyn(mu, nu)=dyn(mu,nu)/sqrt(amass(nta)*amass(ntb))
   enddo
enddo
!>
!> Diagonalize the dynamical matrix and finds phonon frequencies
!> and displacements.
call cdiagh (dyn, w2, z)  
!>
!> Conversion factors  ryd=>thz e ryd=>1/cm:
rydthz = 13.6058d0 * 241.796d0  
!
!  1 Ry = 13.6058 eV, Planck constant h^-1= 241.796 10^12 1/(eV sec) 
!
rydcm1 = 13.6058d0 * 8065.5d0  
!
!  lambda = wavelenght, lambda^-1 = \nu / c where c=29979245800 cm/sec
!  241.796 10^12 / 29979245800 = 8065.5 
!
!>
!>  Writes on output the frequencies.
write(6,9000) (q(mu), mu=1,3)  

9000 format(/,5x,'Diagonalizing the dynamical matrix', &
               //,5x,'q = ( ',3f14.9,' ) ',//,1x,74('*'))
dyn=(0.d0,0.d0)
do mu = 1, nmodes  
   w1 = sqrt(abs(w2(mu)))  
   if (w2 (mu) .lt.0.d0) w1 = - w1  
   write (6, 9010) mu, w1 * rydthz, w1 * rydcm1  
9010 format   (5x,'omega(',i2,') =',f15.6,' [THz] =',f15.6,' [cm-1]')  
enddo
write (6, '(1x,74("*"))')  
deallocate(z,w2)
return  
end subroutine dyndia

end module phonon_mod

!
!-----------------------------------------------------------------------
      subroutine summary(kvect,nks,ecut,lattice)
!-----------------------------------------------------------------------
!
!    This routine writes on output all the informations obtained from the
!    input file and from the setup routine, before starting the 
!    self-consistent calculation.
!
     use constants, only : DP, alat
     use structure, only : omega, atoms, nats, ntyp, at, bg
     use reciprocal_lattice, only: gcutm, ngm, nr1, nr2, nr3
     use pw_types, only : k_point

     implicit none
!
!     declaration of the local variables
!
      integer  ::  &
             nks,  &       ! number of k-points
             i,    &       ! counter on the celldm elements
             ipol, &       ! counter on polarizations
             apol, &       ! counter on direct or reciprocal lattice vectors
             na,   &       ! counter on atoms
             isym, &       ! counter on symmetries
             ik,   &       ! counter on k points  
             ib,   &       ! counter on beta functions
             nt,   &       ! counter on types
             l             ! counter on angular momenta
      character    :: &
             ps*5,    &    ! name of pseudo type
             lattice*(*)

      type(k_point) :: kvect(nks)
      real(DP)    :: ecut
!
!     we start with a general description of the run
!
      write (6, 100) lattice, alat, omega, nats, ntyp,   &
                     ecut, 4.d0*ecut
100   format (/,5x,                                    &
          'bravais-lattice           =          ',a3,/,5x,      &
          'lattice parameter (a_0)   = ',f12.4,'  a.u.',/,5x, &
          'unit-cell volume          = ',f12.4,' (a.u.)^3',/,5x, &
          'number of atoms/cell      = ',i12,/,5x,   &
          'number of atomic types    = ',i12,/,5x,   &
          'kinetic-energy cutoff     = ',f12.4,'  Ry',/,5x, &
          'charge density cutoff     = ',f12.4,'  Ry',/,5x)


      write(6,'(5x,''crystal axes: (cart. coord. in units of a_0)'')')
      write(6,'(3(15x,''a('',i1,'') = ('',3f8.4,'' )  '',/ ) )') & 
                ( apol, (at(ipol,apol), ipol=1,3), apol=1,3) 
      write(6,'(5x,   ''reciprocal axes: (cart. coord. in units 2 pi/a_0)'')')
      write(6,'(3(15x,''b('',i1,'') = ('',3f8.4,'' )  '',/ ) )') &
           (apol,(bg(ipol,apol), ipol=1,3), apol=1,3)
!
!    description of the atoms inside the unit cell
!
      write(6,'(/,3x,''Carthesian axes'')')
      write(6, '(/,5x,''site n.     atom         positions (a_0 units)'')')
      write(6, '(7x,'' tau('',i2,'') = ('',3f11.7,''  )'')')  &
                    (na, ( atoms(na)%tau(ipol),ipol=1,3),na=1,nats )

      nks = size(kvect(:))
      write(6,'(/5x,''number of k points='',i5)') nks

      write(6,'(23x,''carth. coord. in units 2pi/a_0'')')
      do ik=1,nks
         write(6,'(8x,''k('',i4,'') = ('',3f12.7,''), wk ='',f12.7)')  &
            ik, (kvect(ik)%k(ipol),ipol=1,3), kvect(ik)%wk
      enddo
      write (6, 2000) gcutm,ngm,nr1,nr2,nr3
2000  format(/5x,'G cutoff =',f10.4,' (',i7,' G-vectors)',&
     '     FFT grid: (',i3, ',',i3,',',i3,')')

      return
      end

module structure

  use constants,   only : dp, sq2, sq3, tpi, pi, zero, half, one, two
  use constants,   only : alat, tpiba, tpiba2, eps
  use utilities,   only : error
  implicit none

  real(dp)        :: at(3,3), &      ! basis vectors of the Bravais lattice
                                     ! (in units of alat)
                     bg(3,3),&       ! basis vectors of the reciprocal lattice
                                     ! (in units of tpiba = 2 pi / alat)
                     omega           ! volume of the unit cell

  character (len=15) :: lattice_type !

  type atom
   real(DP), pointer     :: tau(:)  ! cartesian coordinates of the atom
   character (len=2)     :: label   ! label for the atomic species
   integer               :: itype   ! pointer to the tables of at species
  end type atom

  type pseudo
   real(dp), pointer :: vps(:)  ! reciprocal-space table for pseudo-potential
   real(dp)          :: dq      ! v(i*dq) = vps(i)
   complex(dp),pointer :: vg(:) ! the pseudo-potential on the G-vector array
   complex(dp),pointer :: vgq(:) ! the pseudo-potential on the G+q-vector array
  end type pseudo

  type element
   character (len=2)     :: name    ! name of the species (matches atom%label)
   real(dp)              :: zv      ! valence number
   complex(dp), pointer  :: s(:)    ! structure factor for the present species
   type(pseudo)          :: ps      ! pseudopotential for the present species
  end type element

  type(atom), allocatable          :: atoms(:)
  type(element), allocatable       :: species(:)
  integer                          :: ntyp, nats, nelec


contains

  subroutine latgen(lattice,celldm)

    !   This routine sets up the alat, at, bg, omega, tpiba, 
    !   tpiba2 (=tpiba^2), and lattice_type variables (see
    !   above for a definition of these variables). The alat, 
    !   tpiba, and tpiba2 variable actually define physical units
    !   and they are therefore found in the "constants" module.

    use utilities, only: error, inv3x3
    implicit none

    character (len=*), intent(in)  :: lattice   ! index of the Bravais lattice
    real(DP),          intent(in)  :: celldm(6) ! shape & dimensions of the 

    ! simple cubic lattice
    !    label       = 'sc'
    !    celldm(1)   = lattice parameter
    !    celldm(2:6) : not used
    !
    ! face-centered cubic lattice
    !    label       = 'fcc'
    !    celldm(1)   = lattice parameter
    !    celldm(2:6) : not used
    !
    ! body-centered cubic lattice
    !    label       = 'bcc'
    !    celldm(1)   = lattice parameter
    !    celldm(2:6) : not used
    !
    ! Other Bravais lattices not yet implemented
    !
    ! hexagonal lattice
    !    label       = 'hexagonal'
    !    celldm(1)   = lattice parameter (a)
    !    celldm(3)   = c/a
    !    celldm(2)   : not used
    !    celldm(4:6) : not used
    !
    ! trigonal lattice
    !    label       = 'trigonal'
    !    celldm(1)   = lattice parameter (a)
    !    celldm(4)   = cos(alpha) ! angle between a1 and a2
    !    celldm(2:3) : not used
    !    celldm(5:6) : not used
    !
    ! tetragonal lattice
    !    label       = 'tetragonal'
    !    celldm(1)   = lattice parameter (a)
    !    celldm(3)   = c/a
    !    celldm(2)   : not used
    !    celldm(4:6) : not used
    !
    ! body-centered tetragonal lattice
    !    label       = 'bc-tetragonal'
    !    celldm(1)   = lattice parameter (a)
    !    celldm(3)   = c/a
    !    celldm(2)   : not used
    !    celldm(4:6) : not used
    !
    ! simple orthorombic lattice
    !    label       = 'orthorombic'
    !    celldm(1)   = lattice parameter (a)
    !    celldm(2)   = b/a
    !    celldm(3)   = c/a
    !    celldm(4:6) : not used
    !
    ! one-face centered orthorombic lattice
    !    label       = 'ofc-orthorombic'
    !    celldm(1)   = lattice parameter (a)
    !    celldm(2)   = b/a
    !    celldm(3)   = c/a
    !    celldm(4:6) : not used
    !
    ! all-face centered orthorombic lattice
    !    label       = 'afc-orthorombic'
    !    celldm(1)   = lattice parameter (a)
    !    celldm(2)   = b/a
    !    celldm(3)   = c/a
    !    celldm(4:6) : not used
    !
    ! simple monoclinic lattice
    !    label       = 'monoclinic'
    !    celldm(1)   = lattice parameter (a)
    !    celldm(2)   = b/a
    !    celldm(3)   = c/a
    !    celldm(4)   = cos(alpha) ! angle between a and b
    !    celldm(5:6) : not used
    !
    ! one-face centered monoclinic lattice
    !    label       = 'ofc-monoclinic'
    !    celldm(1)   = lattice parameter (a)
    !    celldm(2)   = b/a
    !    celldm(3)   = c/a
    !    celldm(4)   = cos(alpha) ! angle between a and b
    !    celldm(5:6) : not used
    !
    ! triclinic lattice
    !    label       = 'triclinic'
    !    celldm(1)   = lattice parameter (a)
    !    celldm(2)   = b/a
    !    celldm(3)   = c/a
    !    celldm(4)   = cos(alpha) ! angle between b and c
    !    celldm(5)   = cos(beta ) ! angle between a and c
    !    celldm(6)   = cos(gamma) ! angle between a and b
    !

    real(DP) :: term,   &     !\
                term1,  &     ! \ 
                term2,  &     !   Auxiliary variables
                cbya,   &     ! /
                singam, &     !/ 
                sin           ! the sine function
    integer  :: ipol          ! counter on the coordinates 

    alat         = celldm(1)
    at (:,:)     = zero
    lattice_type = lattice

    select case(lattice)

    case ( 'sc' )       !     simple cubic lattice
       if ( celldm( 1 ) <= zero ) &
            call error( 'latgen', 'SC: wrong celldm', 1 )
       at(1,1) = one; at(2,2) = one; at(3,3) = one

    case ( 'fcc' )        !     fcc lattice
       if ( celldm( 1 ) <= zero ) &
            call error( 'latgen', 'FCC: wrong celldm', 2 )
       at(:,:) = half
       at(1,1) = ZERO; at(2,2)= ZERO; at(3,3) = ZERO
    case ( 'bcc' )        !     bcc lattice
       if ( celldm( 1 ) <= zero ) &
            call error( 'latgen', 'BCC: wrong celldm', 3 )
       at(:,:) = half
       at(1,1) = -half; at(2,2) = -half; at(3,3) = -half; 
    case ( 'hexagonal' )          !     hexagonal lattice
       if ( celldm( 1 ) <= zero .or. &
            celldm( 3 ) <= zero ) &
            call error( 'latgen', 'HEXAGONAL: wrong celldm', 4 )
       cbya = celldm( 3 )
       at ( 1,1 ) =   one
       at ( 2,1 ) = - half
       at ( 2,2 ) =   sq3 / two
       at ( 3,3 ) =   cbya

    case ( 'trigonal' )          !     trigonal lattice
       if ( celldm( 1 ) <= zero .or. &
            celldm( 4 ) <= -half ) & 
            call error( 'latgen', 'TRIGONAL: wrong celldm', 5 )
       term1 = sqrt( one + two * celldm(4) )
       term2 = sqrt( one - celldm( 4 ) )
       at ( 2,1 ) =   sq2 * term2 / sq3
       at ( 3,1 ) =   term1 / sq3
       at ( 1,2 ) =   term2 / sq2
       at ( 2,2 ) = - at ( 1,2 ) / sq3
       at ( 3,2 ) =   at ( 3,1 )
       at ( 1,3 ) = - at ( 1,2 )
       at ( 2,3 ) =   at ( 2,2 )
       at ( 3,3 ) =   at ( 3,1 )
       
    case ( 'tetragonal' )          !     tetragonal lattice
       if ( celldm( 1 ) <= zero .or. &
            celldm( 3 ) <= zero ) & 
            call error( 'latgen', 'TETRAGONAL: wrong celldm', 6 )
       cbya = celldm( 3 )
       at ( 1,1 ) = one
       at ( 2,2 ) = one
       at ( 3,3 ) = cbya
       
    case ( 'bc-tetragonal' )          !     body centered tetragonal lattice
       if ( celldm( 1 ) <= zero .or. &
            celldm( 3 ) <= zero ) &
            call error( 'latgen', 'Body-Centered TETRAGONAL: wrong celldm', 7 )
       cbya = celldm( 3 )
       at ( 1,1 ) =   half
       at ( 2,1 ) =   at ( 1,1 )
       at ( 3,1 ) =   cbya / two
       at ( 1,2 ) =   at ( 1,1 )
       at ( 2,2 ) = - at ( 1,1 )
       at ( 3,2 ) =   at ( 3,1 )
       at ( 1,3 ) = - at ( 1,1 )
       at ( 2,3 ) = - at ( 1,1 )
       at ( 3,3 ) =   at ( 3,1 )
       
    case ( 'orthorombic' )          !     Simple orthorombic lattice
       if ( celldm( 1 ) <= zero .or. & 
            celldm( 2 ) <= zero .or. & 
            celldm( 3 ) <= zero )    &
            call error( 'latgen', 'ORTHOROMBIC: wrong celldm', 8 )
       at ( 1,1 ) = one
       at ( 2,2 ) = celldm( 2 )
       at ( 3,3 ) = celldm( 3 )

    case ( 'ofc-orthorombic' )      !     One face centered orthorombic lattice
       if ( celldm( 1 ) <= zero .or. &
            celldm( 2 ) <= zero .or. &
            celldm( 3 ) <= zero )    & 
            call error( 'latgen', &
            'One-Face-Centered ORTHOROMBIC: wrong celldm', 9 )
       at ( 1,1 ) =   half
       at ( 2,1 ) =   half * celldm( 2 )
       at ( 1,2 ) = - at ( 1,1 )
       at ( 2,2 ) =   at ( 2,1 )
       at ( 3,3 ) =   celldm( 3 )

    case ( 'afc-orthorombic' )       !  All face centered orthorombic lattice
       if ( celldm( 1 ) <= zero .or. &
            celldm( 2 ) <= zero .or. &
            celldm( 3 ) <= zero )    &
            call error( 'latgen', &
            'All-Face-Centered ORTHOROMBIC: wrong celldm', 10 )
       at ( 1,1 ) = half
       at ( 2,1 ) = half * celldm( 2 )
       at ( 1,2 ) = at ( 1,1 )
       at ( 3,2 ) = half * celldm( 3 )
       at ( 2,3 ) = half * celldm( 2 )
       at ( 3,3 ) = at ( 3,2 )

    case ( 'bc-orthorombic' )        !     Body centered orthorombic lattice
       if ( celldm( 1 ) <= zero .or. &
            celldm( 2 ) <= zero .or. &
            celldm( 3 ) <= zero )    &
            call error( 'latgen', &
            'Body-Centered ORTHOROMBIC: wrong celldm', 11 )
       at ( 1,1 ) =   half
       at ( 2,1 ) =   half * celldm( 2 )
       at ( 3,1 ) =   half * celldm( 3 )
       at ( 1,2 ) = - at ( 1,1 )
       at ( 2,2 ) =   at ( 2,1 )
       at ( 3,2 ) =   at ( 3,1 )
       at ( 1,3 ) = - at ( 1,1 )
       at ( 2,3 ) = - at ( 2,1 )
       at ( 3,3 ) =   at ( 3,1 )

    case ( 'monoclinic' )          !     Simple monoclinic lattice
       if ( celldm( 1 ) <= zero .or. &
            celldm( 2 ) <= zero .or. &
            celldm( 3 ) <= zero .or. &
            abs ( celldm( 4 ) ) > one ) & 
            call error( 'latgen', 'MONOCLINIC: wrong celldm', 12 )
       sin = sqrt( one - celldm( 4 ) ** 2 )
       at ( 1,1 ) = one
       at ( 1,2 ) = celldm( 2 ) * celldm( 4 )
       at ( 2,2 ) = celldm( 2 ) * sin
       at ( 3,3 ) = celldm( 3 )
       
    case ( 'ofc-monoclinic' )          !  One-face centered monoclinic lattice
       if ( celldm( 1 ) <= zero .or. &
            celldm( 2 ) <= zero .or. &
            celldm( 3 ) <= zero .or. &
            abs ( celldm( 4 ) ) > one ) & 
            call error( 'latgen', &
            'One-Face-Centered MONOCLINIC: wrong celldm', 13 )
       sin = sqrt( one - celldm( 4 ) ** 2 )
       at ( 1,1 ) =   celldm( 4 )
       at ( 3,1 ) =   sin
       at ( 1,2 ) =   at ( 1,1 )
       at ( 3,2 ) = - at ( 3,1 )
       at ( 1,3 ) =   celldm( 2 )
       at ( 2,3 ) =   celldm( 3 )
       
    case ( 'triclinic' )         !     Triclinic lattice
       if ( celldm( 1 ) <= zero .or. &
            celldm( 2 ) <= zero .or. &
            celldm( 3 ) <= zero .or. &
            abs ( celldm( 4 ) ) > one .or. &
            abs ( celldm( 5 ) ) > one .or. & 
            abs ( celldm( 6 ) ) > one ) &
            call error( 'latgen', 'TRICLINIC: wrong celldm', 14 )
       sin    = sqrt( one - celldm( 4 ) ** 2 )
       singam = sqrt( one - celldm( 6 ) ** 2 )
       term = sqrt( ( one + &
            two * celldm( 4 ) * celldm( 5 )  * celldm( 6 ) - &
            celldm( 4 ) ** 2 - & 
            celldm( 5 ) ** 2 - &
            celldm( 6 ) ** 2 ) &
            / ( one - celldm( 6 ) ** 2 ) )
       at ( 1,1 ) =   one
       at ( 1,2 ) =   celldm( 2 ) * celldm( 6 )
       at ( 2,2 ) =   celldm( 2 ) * singam
       at ( 1,3 ) =   celldm( 3 ) * celldm( 5 )
       at ( 2,3 ) =   celldm( 3 ) * ( celldm( 4 ) &
            - celldm( 5 ) * celldm( 6 ) ) / singam
       at ( 3,3 ) =   celldm( 3 ) * term
       
    case default
       call error('latgen', lattice//': wrong lattice label', 999 )

    end select

    call inv3x3(at,bg,omega) ! calculate the basis vectors of the 
    bg     = transpose(bg)   ! reciprocal lattice
    omega  = omega * alat**3
    tpiba  = two  * pi / alat
    tpiba2 = tpiba * tpiba

    return
  end subroutine latgen

  subroutine setup_elements 

    integer :: ityp, na, nb
    character (len=2), allocatable :: label(:)
!
! set number of atoms  
!
    nats = size(atoms)
    write (*,fmt='(" # of atoms/cell  = ",i4)') nats

    allocate(label(nats))
    label(:) = ''
!
! set number of atomic type and for each atom its type variable
!
    ntyp =0
    do na=1,nats
       ityp = 0
       do nb=1,na-1
         if (atoms(nb)%label==atoms(na)%label) ityp = atoms(nb)%itype
       end do
       if (ityp==0) then
           ntyp=ntyp+1
           ityp=ntyp
           label(ityp)=atoms(na)%label
       end if
       atoms(na)%itype = ityp
!       write(*,*) atoms(na)%tau(:), atoms(na)%label, atoms(nb)%itype
    enddo

    write (*,fmt='(" # of atomic type = ",i4)') ntyp

    allocate(species(ntyp))
!
! set the species names
!
    species%name = label(1:ntyp)
    write(*,*) species%name

    deallocate(label)

    return 
  end subroutine setup_elements

  subroutine set_electron_nmbr

    integer na, ityp, izv

    if (.not.allocated(atoms)) call error ( 'setup_electron_nmbr', &
       ' needed information on atoms is not available yet ',1)

    if (.not.allocated(species)) call error ( 'setup_electron_nmbr', &
       ' needed information on species is not available yet ',1)

    nelec = 0
    do na=1,nats
      ityp = atoms(na)%itype
      izv = nint(species(ityp)%zv)
      if (abs(species(ityp)%zv-izv) > eps) call error ('setup_electron_nmbr', &
         'an atom has non integer ionic charge',na)
      nelec = nelec + izv
    end do

    write (*,fmt='(" # of electrons/cell =",i6)') nelec

    return
  end subroutine set_electron_nmbr

end module structure

module functionals
  use constants, only : dp, zero, one, two, eps, three, fpi, four, third
  implicit none


  integer             :: mfxcx=1, mfxcc=1, mgcx=0, mgcc=0
  real(dp), parameter :: f76 = 7.0_dp/6.0_dp,  f43 = FOUR * THIRD
  real(dp), parameter :: pi34 = THREE/FPI,  alpha = TWO/THREE

contains
  subroutine xc(rho,ex,ec,vx,vc)

    !==--------------------------------------------------------------==
    !==  lda exchange and correlation functionals (in Hartree a.u.)  ==
    !==                                                              ==
    !==  exchange  :  slater alpha                                   ==
    !==  correlation : ceperley & alder (perdew-zunger parameters)   ==
    !==                vosko, wilk & nusair                          ==
    !==                lee, yang & parr                              ==
    !==                perdew & wang                                 ==
    !==                wigner                                        ==
    !==                hedin & lundqvist                             ==
    !==                ortiz & ballone (perdew-zunger formula)       ==
    !==                ortiz & ballone (perdew-wang formula)         ==
    !==                gunnarsson & lundqvist                        ==
    !==--------------------------------------------------------------==

    use utilities, only : error

    real(dp), intent(in)  :: rho
    real(dp), intent(out) :: ex,ec,vx,vc
    integer               :: iflag
    real(dp)              :: rs

    if(rho <= EPS) then
       ec = ZERO
       vc = ZERO
       ex = ZERO
       vx = ZERO
    else 

       ! exchange
       select case (mfxcx)
       case (0)
          ex=ZERO
          vx=ZERO
       case (1)
          call slaterx(rho,ex,vx)
       case default
          call error('xc','invalid value of mfxcx',1)
       end select

       ! correlation: many different functionals are foreseen
       ! only two (perdew-zunger and wigner) actually implemented

       select case (mfxcc)
       case (0)
          ec=ZERO
          vc=ZERO
       case (1)                  ! Perdew-Zunger
          rs=(pi34/rho)**third
          if(rs < ONE) then
             iflag=1
          else
             iflag=2
          end if

          call pz(rs,ec,vc,iflag)
       case (2:5)                ! Wigner 
          call wigner(rho,ec,vc)
       case default
          call error('xc','invalid value of mfxcc',2)
       end select

    end if

    return
  end subroutine xc

  subroutine slaterx(rho,ex,vx)

    real(dp), intent(in) :: rho
    real(dp), intent(out):: ex, vx
    real(dp), parameter  :: f1 = -1.10783814957303361_dp ! -9/8*(3/pi)**(1/3)
    real(dp)             :: rs

    rs = rho**third
    ex = f1*alpha*rs
    vx = f43*f1*alpha*rs

    return
  end subroutine slaterx

!==--------------------------------------------------------------==
!==  j.p. perdew and alex zunger prb 23, 5048 (1981)             ==
!==--------------------------------------------------------------==

  subroutine pz(rs,epz,vpz,iflg)
    use utilities, only : error
 
    real(dp), intent(in)  :: rs
    real(dp), intent(out) :: epz, vpz
    integer, intent(in)   :: iflg

    real(dp), parameter :: a   = 0.0311_dp, b   =-0.048_dp, &
                           c   = 0.0020_dp, d   =-0.0116_dp,&
                           b1  = 1.0529_dp, b2  = 0.3334_dp, &
                           gc  =-0.1423_dp

    real(dp)            :: xln, rs1, rs2, ox,dox

    epz = ZERO
    vpz = ZERO

    select case (iflg)
    case (1) ! high-density formula
       xln=log(rs)
       epz=a*xln+b+c*rs*xln+d*rs
       vpz=a*xln + (b-a/THREE)+TWO/THREE*c*rs*xln+(TWO*d-c)/THREE*rs
    case (2) ! interpolation formula
        rs1 = sqrt(rs)
        rs2 = rs
        ox  = ONE + b1*rs1 + b2*rs2
        dox = ONE + f76*b1*rs1 + f43*b2*rs2
        epz = gc/ox
        vpz = epz*dox/ox
    case default 
       call error('pz','invalid flag',1)
    end select

    return
  end subroutine pz

  subroutine wigner(rho,fxc,exc)

    real(dp), intent(in)  :: rho
    real(dp), intent(out) :: fxc,exc
    real(dp)              :: x

    if(rho > EPS) then
       x=rho**THIRD
       fxc=-x*((0.943656+8.8963*x)/(1.0+12.57*x)**2)
       exc=-0.738*x*(0.959/(1.0+12.57*x))
    else
       fxc = ZERO
       exc = ZERO
    end if

    return
  end subroutine wigner
end module functionals

module lapack_wrap
  use constants, only : dp
  use utilities, only : error
  implicit none

contains
  subroutine cdiagh (h,e,v)

    ! f90 interface to LAPACK routines which calculate 
    ! eigenvalues and eigenvectors of a complex hermitean matrix H. 
    !
    ! On output, the matrix H is unchanged
    !
    ! Requires: LAPACK library (ZHEEV and ZHEEVX)
    !           LOC    integer function which returns the address of 
    !                  a variable
    !          
    use constants, only : zero, tpiba2 

    complex(DP), intent(inout)       :: h(:,:)   ! matrix to be diagonalized
    real   (DP), intent(out), target :: e(:)     ! eigenvalues
    complex(DP), intent(out), target :: v(:,:)   ! eigenvectors (column-wise)

    integer  :: n,      &! dimension of the matrix to be diagonalized
                lwork,  &! auxiliary variable
                info,   &! flag saying if LAPACK execution was OK
                ldh,    &! leading dimension of h, as 
                         ! declared in the calling pgm unit
                ldv,    &! leading dimension of v, as 
                         ! declared in the calling pgm unit
                neigv,  &! number of eigenvalues to calculate
                idummy, i, j, m

    character  (len=1) :: jobz, range, uplo  ! select the task in LAPACK

    real(DP), dimension(:), allocatable    :: rwork,& ! work array used by 
                                                      ! LAPACK
                                              diag_h  ! temp array for saving
                                                      ! diag(h)
    complex(DP), dimension(:), allocatable :: work    ! as above
    integer, dimension(:), allocatable     :: iwork   !    "
    integer, dimension(:), allocatable     :: ifail   !    "
    complex(DP)                            :: copt_sz
    real(DP)                               :: rdummy

    logical                                :: use_zheev
    complex(DP), pointer                   :: hh(:,:)
    real(DP),    pointer                   :: ee(:)
!
!   determine the size of the arrays and decide to use zheev or zheevx
!
    n     = size(h,2)
    if ( n     > size(v,1) ) &
         call error('cdiagh','V array has too few rows', size(v,1) )

    neigv = size(e)
    if ( neigv > size(v,2) ) &
         call error('cdiagh', 'V array has too few columns', size(v,2) )

    use_zheev = (neigv > n/4) ! n/4 is the threshold for using zheev
!
!   Initialize common flags
!
    lwork = -1  ! flag saying that the size of work arrays 
                ! has to be estimated by LAPACK (either ZHEEV or ZHEEVX)
    jobz  = 'V' ! compute eigenvalues and eigenvectors
    uplo  = 'U' ! LAPACK routines use the upper triangle of the input matrx

    v(:,:) = (ZERO,ZERO)

    if(use_zheev) then
       ! ZHEEV calculates all the eigenvalues and eigenvectors
       if( neigv==n ) then
          hh => v
          ee => e
          ldh = ( loc(v(1,2))-loc(v(1,1) ) ) / (2*DP) 
       else
          allocate(hh(1:n,1:n), ee(1:n) )
          ldh = n
       end if
       hh(1:n,1:n) = h(1:n,1:n)

       ! allocate work arrays of known size
       allocate(rwork(3*n-2))

       ! calculate optimal size of work arrays
       call zheev(jobz,uplo,n,hh,ldh,ee,copt_sz,lwork,rwork,info)
       call error('cdiagh', &
            'failed to calculate optimal size of work array',abs(info))
       lwork  = nint(real(copt_sz))

       ! allocate work arrays
       allocate(work(lwork))

       ! DIAGONALIZE!
       call zheev(jobz,uplo,n,hh,ldh,ee,work,lwork,rwork,info)

       call error('cdiagh','info =/= 0',abs(info))

       if(neigv == n) then
          hh => null()
          ee => null()
       else
          e(    1:neigv) = ee(    1:neigv)
          v(1:n,1:neigv) = hh(1:n,1:neigv)
          deallocate(hh, ee)
       end if

       deallocate(work,rwork)

    else
       ! ZHEEVX calculates selected eigenvalues and eigenvectors
       !
       ! Find the leading dimensions of h and v
       !
       ldh   = ( loc(h(1,2))-loc(h(1,1) ) ) / (2*DP) 
       ldv   = ( loc(v(1,2))-loc(v(1,1) ) ) / (2*DP) 

       ! allocate arrays of known size

       allocate(ee(n),rwork(7*n),iwork(5*n),ifail(n),diag_h(n))
       range = 'I'
       rdummy=0.0_DP
       ! calculate optimal size of work arrays
       call zheevx( jobz, range, uplo, n, h, ldh, rdummy, rdummy, 1, neigv, &
            zero, m, ee, v, ldv, copt_sz, lwork, rwork, iwork, ifail, info )
       
       call error('cdiagh', &
            'failed to calculate optimal size of work arrays',abs(info))
       lwork  = nint(real(copt_sz))

       ! allocate work arrays
       allocate(work(lwork))

       ! save the diagonal of H for further use
       diag_h = (/ (real(h(i,i)), i=1, n) /)

       ! DIAGONALIZE!
       call zheevx( jobz, range, uplo, n, h, ldh, rdummy, rdummy, 1, &
            neigv, zero, m, ee, v, ldv, work, lwork, rwork, iwork,   &
            ifail, info )

       call error('cdiagh','info =/= 0',abs(info))
       ! fill back the upper triangle of H which was destroyed by zheevx

       do i=1, n
          h(i,i) = cmplx(diag_h(i),ZERO)
          do j=i+1,n
             h(i,j) = conjg(h(j,i))
          end do
       end do
       e(1:neigv)=ee(1:neigv) 
       
       deallocate(work,rwork,iwork,ifail,diag_h)
       deallocate(ee)
    end if

    return
  end subroutine cdiagh

end module lapack_wrap

program dfpt

!> \centerline{\LARGE \bf 0) SPECIFICATION STATEMENTS } 
  use constants,            only: dp, tpiba, tpiba2, four, zero, one, eps
  use pw_types,             only: field, k_point, construct, destroy, &
                                  assignment(=), axpy, direct_space
  use structure,            only: latgen, bg, atoms, atom, nelec, ntyp,&
                                  setup_elements, set_electron_nmbr
  use reciprocal_lattice,   only: ggen, ngm, set_fft, set_structure_factor
  use lapack_wrap,          only: cdiagh
  use appelbaum_and_hamann, only: set_ah_tables, fill_ah_vatom, fill_ahq_vatom
  use energy_bands,         only: c_bands, sum_bands, unit_wvfct, &
                                  unit_wvfct_aux, first
  use scf,                  only: Vscf, v_of_rho, linear_mixing, broyden, &
                                  delta_v, rho, eband, tot_ene, forces
  use phonon_mod,           only: amass, xkq, wkq, q, nks, nbnd, phonon
  use utilities,            only: error

  implicit none
  character (len=15) :: lattice, material, label
  real(dp)           :: celldm(6) = zero, &
                        xk1(3), xk2(3),   &
                        kmax=zero,        &
                        ecut,             &
                        gcut,             &
                        x

  real(dp),allocatable :: xk(:,:), wk(:)
  real(dp)             :: wksum

  integer              :: nats, na, nb, nt
  real(dp),allocatable,target :: tau(:,:)

  type(field)          :: v_in, v_out, vbare, velec
  type(k_point), allocatable, dimension(:) :: kvect, kvectq

  integer            :: iter, maxter=20
  logical            :: conv

  real(dp)           :: tr2, tol=1.0d-12, beta = 0.7, ethr

  integer            :: npoints, ios, i, n, npw
  
  integer            :: ik1,ik2,ik3,nk1,nk2,nk3
  integer            :: n_iter=4, isolve=1

  character (len=3)  :: reply

  !> \centerline{\LARGE \bf 1) PRELIMINARIES} 
  !> \centerline{\includegraphics*[width=16cm]{flux1.png}}

  !> \large Read in the first three lines of the input file: 
  !> a label ({\tt material}), the Bravais lattice ({\tt lattice}), 
  !> and a vector describing the simulation cell ({\tt celldm}).
  write(*,advance='no',fmt='(" material > ")')
  read(*,*) material
  write(*,*) material
  write(*,*)

  write(*,fmt='("Read structural information >> ")')

  write(*,advance='no',fmt='(" Bravais lattice (sc/bcc/fcc) > ")')
  read(*,*) lattice
  write(*,*) lattice

  write(*,advance='no',fmt='(" celldm(1:6) > ")')
  read(*,*) celldm
  write(*,fmt='(6f7.3)') celldm

  !> The subroutine {\tt latgen} sets up the lattice parameter ({\tt alat}),
  !> the basis vectors of the Bravais lattice ({\tt at}), the basis vectors 
  !> of the reciprocal lattice ({\tt bg}), and the volume of the unit cell 
  !> ({\tt omega}).
  call latgen(lattice,celldm)

  !> Read in the number of independent atoms ({\tt nats}) and the atomic 
  !> coordinates ({\tt tau}).
  write(*,advance='no',fmt='(" # of atoms > ")')
  read(*,*) nats
  write(*,*) nats
  allocate(tau(3,nats),atoms(nats))
  write(*,fmt='(" atom coordinates and label > ")')
  do na=1,nats
     read(*,*) tau(:,na), atoms(na)%label
     write(*,fmt='(3f8.4,2x,a)') tau(:,na), atoms(na)%label 
     atoms(na)%tau => tau(:,na)
  enddo

  !> Setup atomic variables: number of atoms ({\tt nats}), number of atomic 
  !> types ({\tt ntyp}), and the species label.
  call setup_elements
  write(*,fmt='("Read atomic masses >> ")')
  allocate(amass(ntyp))
  read(*,*) (amass(nt), nt=1,ntyp)
  write(*,*)


  !> Read in parameters controlling the simulation: the kinetic-energy cutoff
  !> ({\tt ecut}), the coefficient governing the broyden mixing ({\tt
  !> beta}), the tolerance threshold for convergence ({\tt tol}), the 
  !> diagonalization scheme ({\tt isolve}).
  write(*,fmt='(/"Read control parameters >> ")')


  read(*,*) ecut
  write(*,*) ecut
  write(*,advance='no',fmt='(" mixing fraction (0 < beta < 1) > ")') 
  read(*,*) beta
  write(*,*) beta
  write(*,advance='no',fmt='(" scf threshold (roughly (dV)**2) > ")') 
  read(*,*) tol
  write(*,*) tol
  write(*,advance='no',fmt='(" isolve 0 (lapack) 1 (Davidson) > ")') 
  read(*,*) isolve
  write(*,*) isolve



  !> Read in variables for the generation of the k-point grid.

  write(*,advance='no',fmt='(" nk1,nk2,nk3  > ")')
  read(*,*) nk1,nk2,nk3
  write(*,*) nk1,nk2,nk3
  if (nk1*nk2*nk3==0) then
     write(*,advance='no',fmt='(a)') ' enter the number of k-points > '
     read(*,*) nks
     allocate(xk(3,nks),wk(nks))
     do i=1,nks
        write(*,advance='no',fmt='(a)') ' enter k-point and weight > '
        read(*,*) xk(:,i), wk(i)
     end do
  else
    nks = nk1*nk2*nk3
    write(*,advance='no',fmt='(" number of k-points > ",i5)') nks
    allocate(xk(3,nks),wk(nks))
    i = 0
    wk(:) = one
    do ik1=0,nk1-1
       do ik2=0,nk2-1
          do ik3=0,nk3-1
             i=i+1
             xk(:,i) = float(ik1)/nk1 * bg(:,1) +  &
                       float(ik2)/nk2 * bg(:,2) +  &
                       float(ik3)/nk3 * bg(:,3) 
          end do
       end do
    end do
  end if
  write(*,*)
  wksum = sum(wk(:))
  if ( any( wk < 0 ) .or. wksum==0 ) call error('main', &
      ' k point weights must be positive numbers ',1)
  wk(:) = wk(:)/wksum
  write(*,advance='no',fmt='(a)') ' enter q-point > '
        read(*,*) q(:)
  write(6,'(3f20.8)') q(:)

  kmax = 0.d0
  do i=1,nks
     kmax = max( kmax, sqrt(dot_product(xk(:,i),xk(:,i))) )
  end do

  !> The energy threshold {\tt ecut} toghether with the longhest k-vector
  !> {\tt kmax}  allowed in the Brillouin Zone limits the set of 
  !> reciprocal-space {\bf G}-vectors that is necessary to consider. 
  !> The cutoff in the reciprocal-space vectors {\tt gcut} is determined 
  !> by the formula 
  !> \[ \mid  {\bf k}_{max} + {\bf G} \mid^2 \le E_{cut}. \]
  gcut = ( sqrt(ecut/tpiba2) + kmax ) **2 + eps
  gcut = max(gcut,FOUR*ecut/tpiba2)

  !> \centerline{\includegraphics*[width=16cm]{flux2.png}}

  !> The subroutine {\tt ggen} sets the arrays of {\bf G}-vectors {\tt g} and 
  !> the corresponding squared norm {\tt gg} such that 
  !> $ \mid{\bf G}\mid^2 \le {\tt gcut}$. The {\bf G}-vectors are stored  
  !> in order of increasing norm.
  call ggen(gcut)

!> The subroutine {\tt set\_fft} sets the dimensions of the Fast Fourier 
!> Transform ({\tt mr1,mr2,mr3}), and the pivot arrays ({\tt ig1,ig2,ig3,
!> nl}).  
  call set_fft

  allocate(kvect(nks))
  call construct(kvect(1:nks),xk(:,1:nks),ecut,wk(1:nks))

!> The following subroutines build the {\it Appelbaum and Hamann} 
!> pseudopotential for the given atom (Si).
  call set_ah_tables
  call fill_ah_vatom
  call fill_ahq_vatom

!> Calculate the electronic charge in the unit cell
  call set_electron_nmbr 
  nbnd = nelec/2

!> Print out a summary of the work done so far (see output file).
  call summary(kvect, nks, ecut,lattice)

  !> \centerline{\includegraphics*[width=16cm]{flux3.png}}

  !> The subroutine {\tt set\_structure\_factor} calculates the atomic 
  !> structure factor for each atomic {\tt species}: \[{1\over \Omega} 
  !> S({\bf G}) = \sum_{\tau} {\rm e}^{-i{\bf G}\cdot \tau},\] 
  !> where the sum is extended to all the atoms (with coordinates $\tau$) 
  !> in the unit cell of the given species, and $\Omega$ is the volume of
  !> the unit cell.
  call set_structure_factor

  !> Calculate the starting potential V$_{in}$ as a superposition  of 
  !> pseudopotentials.
  call set_vbare(vbare)

  open(unit=unit_wvfct,form='unformatted',status='scratch')
  open(unit=unit_wvfct_aux,form='unformatted',status='scratch')

  call construct(v_in,  DIRECT_SPACE)
  call construct(v_out, DIRECT_SPACE)
  call construct(velec, DIRECT_SPACE)

  vscf = vbare

  tr2  = one
  iter = 1
  conv=.false.

  ethr = sqrt(tol)/100.0

  !> \centerline{\LARGE \bf 2) SELF-CONSISTENT LOOP} 
  !> \centerline{\includegraphics*[width=16cm]{flux4.png}}
  ITERATE: do while(iter <= maxter .and. .not.conv)
     write(6,'(/,78(''*''))')
     write(6,'(5x,'' Iteration  '',i5,'' ecut='',f7.2,'' beta='',f7.2)') &
                     iter,ecut,beta
     write(6,'(78(''*''))')

  !> The new potential is updated
     v_in = vscf

     !> The Kohn-Sham equation, expressed in form of an eigenvalue equation, 
     !> \[ \sum_{\bf G^\prime} {\cal H}_{\bf k+G,k+G^\prime} \, 
     !> \tilde{\psi}_{{\bf G^\prime},\nu} ({\bf k}) = \epsilon_{{\bf k},\nu} 
     !> \, \tilde{\psi}_{{\bf G},\nu}({\bf k}), \]
     !> is solved for each {\bf k}-point in the subroutine {\tt c\_bands}.
     call c_bands(kvect,nbnd,isolve)
     !> The eigenvalues $\epsilon_{{\bf k},\nu}$ ($\Rightarrow$ energy bands)
     !> and the eigenvectors $\tilde{\psi}_{{\bf G},\nu}({\bf k})$  are then
     !> used in the subroutine {\tt sum\_bands} to calculate the new electron 
     !> density \[ \rho_{out}({\bf r}) = \sum_{{\bf k}\nu} 
     !> \mid\psi_{{\bf k}\nu}({\bf r})\mid^2 \, w_{\bf k}, \] 
     !> and the band energy E$_{\rm band}$: \[ E_{\rm band} =
     !> \sum_{{\bf k},\nu} \epsilon_{{\bf k},\nu}. \]
     write(*,*)
     call sum_bands(kvect,nbnd,nelec)
     !> The functionals of the density (the Hartree potential $V_{\rm H}$
     !> and the exchange-correlation potential $\mu_{\rm xc}$ and energy 
     !> $\varepsilon_{\rm xc})$ are calculated in subroutine {\tt v\_of\_rho}. 
     !> \[ V_{\rm H}[\rho({\bf r})] = e^2 \int \frac{\rho_{\rm out}({\bf r}
     !> ^\prime)}
     !> {\mid{\bf r-r^\prime}\mid} {\rm d \bf r^\prime} \] 
     call v_of_rho(rho,velec)
     !> The effective potential $V_{\rm out}$ is updated:
     !> \[ V_{\rm out}({\bf r}) = V_{\rm ions}({\bf r}) + V_{\rm H}({\bf r}) +
     !> \mu_{\rm xc}[\rho_{out}({\bf r})] .\]
     v_out = vbare
     call axpy(ONE,velec,v_out)
     !> To improve convergence, the potential for the next iteration is 
     !> obtained by mixing $V_{\rm in}$ and $V_{\rm out}$. In this example the
     !> Broyden mixing method is employed. The potential $V_{\rm in}$ is then 
     !> updated.
!     conv = linear_mixing(v_in,v_out,beta,tol,tr2)
     conv = broyden(v_in,v_out,beta,iter,n_iter,tol,tr2)
     vscf    = v_out
     delta_v = v_in

!> The total energy $E_{\rm tot}$ is finally calculated in subroutine 
!> {\tt tot\_ene}: \[ E_{\rm tot} = E_{\rm band} - \frac{1}{2}
!> \int \rho({\bf r}) V_{\rm H}[\rho({\bf r})] {\rm d \bf r} +
!> \int \rho({\bf r}) \left( \varepsilon_{\rm xc}[
!> \rho({\bf r})] - \mu_{\rm xc}[\rho({\bf r})]
!> \right) {\rm d \bf r}. \]
     call tot_ene(conv)
     write(6,'(5x,''tr2 ='',e22.2)') tr2
     iter=iter+1
  !> Endo of the self-consistent loop.
  end do ITERATE

  if (conv) then
     write(*,'(a)')  ' Convergence has been achieved '
  else
     write(*,'(a,i6)') &
          ' Maximum number of iteration exceeded. maxter = ', maxter
     write(*,'(a)')  ' Convergence has not been achieved '
     stop
  end if
!  call forces()
!>
!> In order to compute phonon frequencies we must know the wavefunctions
!> at ${\bf k}$ and ${\bf k+q}$. We compute here the wavefunctions with
!> the current self-consistent potential. 
!>

 allocate(xkq(3,2*nks),wkq(2*nks))
 wkq=0.d0
 do i=1,nks
    xkq(:,2*i-1)=xk(:,i)
    wkq(2*i-1)=wk(i)
    xkq(:,2*i)=xk(:,i)+q(:)
 enddo
 allocate(kvectq(2*nks))
 call construct(kvectq(1:2*nks),xkq(:,1:2*nks),ecut,wkq(1:2*nks))
  
 first=.true.
 call c_bands(kvectq,nbnd,isolve)
!>
!> The subroutine phonon calculates the phonon frequencies. It solves the 
!> linear system, computes the dynamical matrix and diagonalizes it.
!>
 call phonon(ecut)
!
 call destroy(kvect)
 deallocate(kvect)
 call destroy(kvectq)
 deallocate(kvectq)

 close(unit=unit_wvfct)
 close(unit=unit_wvfct_aux)

stop

end program dfpt

module constants
  implicit none

! This file contains the definition of frequently used numerical and
! physical constants 

  integer,  parameter :: dp       = kind(1.0d0) ! The kind of double-precision
                                                ! fortran variables

  real(dp), parameter :: zero     = 0.0_dp,               &
                         one      = 1.0_dp,               &
                         two      = 2.0_dp,               &
                         three    = 3.0_dp,               &
                         four     = 4.0_dp,               &
                         half     = one/two,              &
                         third    = one/three,            &
                         sq2      = 1.41421356237309_dp,  &  ! sqrt(2)
                         sq3      = 1.73205080756888_dp,  &  ! sqrt(3)
                         pi       = 3.14159265358979_dp,  & 
                         tpi      = two*pi,               &
                         fpi      = four*pi,              &
                         e2       = two,                  &  ! e^2 in Ry au
                         degspin  = two,                  &  ! spin degeneracy
                         ry_to_ev = 13.6058_dp,           &  ! Ry->eV conv
                         aa_to_au = one / 0.529177_dp,    &  ! Angs -> au
                         eps      = 1.0d-8                   ! a (not too)
                                                             ! small number
  real(dp), parameter :: ELECTRONMASS_SI  = 9.10938215E-31_DP, &  ! electron mass [Kg]
                         AMU_SI           = 1.660538782E-27_DP,&  ! Atomic Mass Unit [Kg]
                         AMU_RY           = AMU_SI / ELECTRONMASS_SI / TWO ! mass conv to Ry au

  ! system-specific constants

  real(dp)        :: alat,    & ! lattice parameter and unit length (a.u.)
                     tpiba,   & ! wave-number unit: 2 pi / alat 
                     tpiba2     ! (2 pi /a alat)^2

end module constants 

module Appelbaum_and_Hamann
! 
!  Joel A. Appelbaum and D.R. Hamann 
! Self-Consistent Pseudopotential for Si
!   Phys. Rev. B 8, 1777 (1973) 
!

  implicit none

contains

  subroutine set_AH_tables
    use constants,          only : dp, e2, fpi, three, four, half, zero, pi
    use utilities,          only  :  error
    use constants,          only  :  tpiba2
    use reciprocal_lattice, only  :  gg, gcutm
    use structure,          only  :  omega, element, species
    real(dp)                      :: v1, v2, alpha, q, dq, q2, qmax
    integer                       :: table_size, k, n
    
    for_each_species: do n=1, size(species)
       select case(species(n)%name)
       case('Si')
          v1          =  3.042_dp * E2 ! The factor E2 accounts for the convers
          v2          = -1.372_dp * E2 ! Hartree -> Ry
          alpha       =  0.6102_dp
          species(n)%zv = 4.0_dp
       case default
          call error('setup_potential','element '//' currently not allowed',1)
       end select

       qmax = sqrt(gcutm*tpiba2)
       dq = 0.01_dp
       table_size = qmax / dq + 2
       allocate (species(n)%ps%vps(0:table_size))
    
       q = ZERO
       species(n)%ps%vps(0) = (PI *E2 *species(n)%zv / alpha) &
            + (PI/alpha)**(THREE*HALF) * (v1 + THREE*HALF*v2/alpha) 

       do k = 1, table_size
          q  = q + dq
          q2 = q*q
          species(n)%ps%vps(k) = exp(-q2/FOUR/alpha) * &
               ( -FPI* species(n)%zv* E2 /q2 + (PI/alpha)**(THREE*HALF)* &
               ( v1 + v2/alpha * (THREE*HALF - q2/FOUR/alpha) ) ) 
       end do

       species(n)%ps%dq   = dq

    end do for_each_species
    
  end subroutine set_AH_tables

  subroutine fill_AH_vatom
    use constants, only : dp, zero, tpiba2
    use reciprocal_lattice, only : ngm, gg
    use structure, only : atom, atoms, element, species, ntyp
    
    complex(DP), pointer     :: vg(:,:)
    real(DP), pointer        :: vps(:)
    complex(DP)              :: v_value
    real(DP)                 :: vatom, q, dq
    integer                  :: i,j,k, ig,  indx, n

    allocate(vg(ngm,ntyp))

    do n=1,ntyp
       vps => species(n)%ps%vps
       dq  =  species(n)%ps%dq
       do ig=1, ngm
          q = sqrt(gg(ig)*tpiba2)
          v_value = cmplx(ZERO,ZERO)
          indx = q / dq
          vg(ig,n) = vps(indx) + (q-indx*dq)*(vps(indx+1)-vps(indx))/dq
       end do
       species(n)%ps%vg => vg(:,n)
    end do
          
    return
  end subroutine fill_AH_vatom

  subroutine fill_ahq_vatom
    use constants, only : dp, e2, tpiba2, three, half, four, pi, fpi
    use reciprocal_lattice, only : ngm, g, tpiba2
    use structure, only : atom, atoms, element, species, ntyp
    use phonon_mod, only : q
    
    complex(DP), pointer     :: vgq(:,:)
    real(DP)                 :: vatom, xq, dq, v1,v2,alpha, q2
    integer                  :: i,j,k, ig,  indx, n

    v1          =  3.042_dp * E2 ! The factor E2 accounts for 
    v2          = -1.372_dp * E2 ! Hartree -> Ry
    alpha       =  0.6102_dp


    allocate(vgq(ngm,ntyp))

    do n=1,ntyp
       do ig=1, ngm
          xq =  ( (g(1,ig)+q(1))**2 + (g(2,ig)+q(2))**2 + &
                      (g(3,ig)+q(3))**2 )*tpiba2
          if (sqrt(xq).lt.1d-9) then
             vgq(ig,n)= (PI *E2 *4.d0 / alpha) &
            + (PI/alpha)**(THREE*HALF) * (v1 + THREE*HALF*v2/alpha)
          else
             vgq(ig,n) =  exp(-xq/FOUR/alpha) * &
               ( -FPI* 4.d0* E2 /xq + (PI/alpha)**(THREE*HALF)* &
               ( v1 + v2/alpha * (THREE*HALF - xq/FOUR/alpha) ) )
          endif
       end do
       species(n)%ps%vgq => vgq(:,n)
    end do
          
    return
  end subroutine fill_ahq_vatom




end module Appelbaum_and_Hamann

    subroutine plot_field(the_field,file_name)

    use constants, only : dp, zero, eps, tpi
    use pw_types,  only : field, available, destroy, field_ft, &
                          direct_to_reciprocal_space, assignment(=), &
                          direct_space
    use utilities, only : error

    implicit none

    character (len=*), intent(in) :: file_name
    type(field), intent(in)  :: the_field
    type(field)              :: aux_field
    real(dp)                 :: r0(3),dr1(3),dr2(3)
    integer                  :: n1=0,n2=0
    integer                  :: ig,i1,i2
    complex(dp)              :: the_value_in_r
    real(dp)                 :: arg ,capel,r(3)

 
    if(.not.available(the_field)) call error('plot_field', &
       ' cannot plot an idle field',1)
    aux_field = the_field

    if (aux_field%state==DIRECT_SPACE) &
        call field_ft(aux_field,DIRECT_TO_RECIPROCAL_SPACE)

    write(*,'(a)') ' plotting a 2D cut of the field '
    write(*,advance='no',fmt='(a)') ' n1, n2 > '
    read(*,*) n1,n2
    write(*,advance='no',fmt='(a)') ' origin of the 2D plot > '
    read(*,*) r0(:)
    read_directions: do
       write(*,advance='no',fmt='(a)') ' first direction > '
       read(*,*) dr1(:)
       write(*,advance='no',fmt='(a)') ' second direction > '
       read(*,*) dr2(:)
       if (abs(dot_product(dr1,dr2))> eps) then 
          call error ('plot_field', &
               'the two directions are not orthogonal',-1)
          cycle read_directions
       end if
       exit read_directions
    end do read_directions

    open(unit=3,file=file_name,status='unknown')
    capel = zero
    do i1=0,n1
       write (3,*)
       do i2=0, n2
          r = r0 + float(i1)/n1*dr1 + float(i2)/n2*dr2
          the_value_in_r = zero 
          do ig=1,aux_field%ngm
             arg = TPI * dot_product(r,aux_field%g(:,ig))
             the_value_in_r = the_value_in_r + &                   
                              cmplx(cos(arg),sin(arg)) * &
                              aux_field%val( aux_field%ig1(ig), &
                                             aux_field%ig2(ig), &
                                             aux_field%ig3(ig) )
          end do
          capel = capel + abs(imag(the_value_in_r))
          write (3,fmt='(f10.5)') real(the_value_in_r)
       end do
    end do
    if (capel.gt.eps) then
       write (*,*) ' sum of immaginary part = ', capel
       call error('plot_field','the plotted field was not real',1)
    end if

    call destroy(aux_field)

    close(unit=3)

    return

    end subroutine plot_field

module hamiltonian
  use constants, only : dp
  use utilities, only : error
  use scf, only: Vscf, V0
  implicit none
contains

  subroutine h_psi(psi,psip)

    use pw_types, only : wave_function, available, direct_space, &
                         field_times_wvfct

    type(wave_function), intent(in)             :: psi
    type(wave_function), intent(in out), target :: psip
    
    if( .not. available(psi) .or. .not. available(psip) ) &
         call error('h_psi','in and/or out wvfct not available',1)
    
    if ( any ( psi%k%k(:)/=psip%k%k(:) ) ) call error('h_psi', &
         'in and out wvfct must correspond to the same k point',1)
    
    if(Vscf%state /= DIRECT_SPACE) &
         call error('h_psi','Vscf not in real space',1)
    
    call field_times_wvfct(Vscf,psi,psip)
    psip%val(:) = psi%k%gk(:)*psi%val(:) + psip%val(:)

    return
    
  end subroutine h_psi
  
  subroutine g_psi(psi,e,psip)
    use pw_types, only : wave_function, available 

    type(wave_function), intent(in)             :: psi
    real(DP),            intent(in)             :: e
    type(wave_function), intent(in out), target :: psip
    
    if( .not. available(psi) .or. .not. available(psip) ) &
         call error('g_psi','in and/or out wvfct not available',1)
    
    if ( any ( psi%k%k(:)/=psip%k%k(:) ) ) call error('g_psi', &
         'in and out wvfct''s do not match',1)

    psip%val(:) = psi%val(:)
    where( psi%k%gk(:) + V0 - e > 0.01)
       psip%val(:) = psi%val(:) / ( psi%k%gk(:) + V0 - e )
    end where

    return
    
  end subroutine g_psi
  
  subroutine fill_h(hc,k)
    
    use constants, only : zero, one
    use pw_types, only : construct, destroy, wave_function, k_point, &
                         assignment(=)
    use reciprocal_lattice, only: g, ngm

    implicit none

    complex(DP),   intent(out) :: hc(:,:)
    type(k_point), intent(in)  :: k
    type(wave_function)        :: psi, psip
    integer                    :: i, npw

    npw = size(hc,2)

    hc(:,:)  = cmplx(zero,zero)

    call construct(psi,k); call construct(psip,k)

    do i=1, npw
       psi        = ZERO
       psi%val(i) = cmplx(ONE,ZERO)
       call h_psi(psi,psip)
       hc(1:npw,i) = psip%val(1:npw)
    end do

    call destroy(psi); call destroy(psip)

  end subroutine fill_h

end module hamiltonian

module pw_types

  !> This module contains the definition of a few derived types which are
  !> used throughout the code.

  use constants, only : dp, zero, tpiba2, tpiba
  use utilities, only: error, hpsort
  implicit none

  integer, parameter :: IS_IDLE        = 0, & ! Status flag for derived
                        IS_CONSTRUCTED = 1    ! data types

  type, public:: k_point

   !> The derived data type {\tt k\_point} holds all the information 
   !> associated with a given {\bf k} point in the Brillouin zone, relevant
   !> for plane-wave pseudopotential calculations

   real(DP)          :: k(3)    ! coordinates of k-point in the BZ
   real(DP)          :: wk=ZERO ! weight of k-point for BZ integrations
   integer           :: npw     ! number of PW's at this k-point
   real(DP), pointer :: gk(:)   ! array containing |k+G|^2, i.e. the 
                                ! kinetic energy associated to each PW. 
                                ! Units are Bohr radii^(-1)
   integer, pointer  :: igk(:)  ! k+G(igk(i)) is the i-th wave-vector in the 
                                ! list sorted in order of increasing |k+G|
   integer           :: status=&! initialization tag
                        IS_IDLE ! variable never used before

  end type k_point

  ! first two days up to here

  integer, parameter, public   :: IS_ASSOCIATED    = 1, &
                                  IS_ALLOCATED     = 2

  type, public :: wave_function
   complex(DP),   pointer :: val(:) => null()
   type(k_point), pointer :: k      => null()
   integer                :: status = IS_IDLE
  end type wave_function

  integer, parameter :: DIRECT_SPACE               = -1, &
                        RECIPROCAL_SPACE           =  1, &
                        DIRECT_TO_RECIPROCAL_SPACE = -1, &
                        RECIPROCAL_TO_DIRECT_SPACE =  1
  type, public :: field
   integer              :: nr1,nr2,nr3, &! FFT dimensions
                           ngm,         &! # of G vectors
                           state,       &! DIRECT_SPACE / RECIPROCAL_SPACE 
                           status=IS_IDLE
   integer,     pointer :: ig1(:), & ! [ig1(i),ig2(i),ig3(i)] are the
                           ig2(:), & ! FFT indeces of G(i)
                           ig3(:)    !
   real(DP),    pointer :: g(:,:)    ! G vectors
   real(DP),    pointer :: gg(:)     ! |G|^2
   complex(DP), pointer :: val(:,:,:)! value of the the field on the grid
  end type field

  !> The operator `=' is used to assign values to wavefunctions and fields.

!-------------------------+
  interface assignment(=) !
!-------------------------+
   module procedure copy_wvfct_to_wvfct,   & 
                    copy_wvfct_to_field,   &
                    copy_field_to_wvfct,   &
                    copy_field_to_field,   &
                    copy_real_to_wvfct,    &
                    copy_complex_to_wvfct, &
                    copy_real_to_field,    &
                    copy_complex_to_field
  end interface
  private :: copy_wvfct_to_wvfct,   copy_wvfct_to_field, &
             copy_field_to_wvfct,   copy_field_to_field, &
             copy_real_to_wvfct,    copy_real_to_field,  &
             copy_complex_to_wvfct, copy_complex_to_field
  
!---------------------------------------------------------------------------

!---------------------------+
  interface operator(.dot.) !
!---------------------------+
   module procedure wvfct_dot_wvfct, field_dot_field
  end interface
  private :: wvfct_dot_wvfct, field_dot_field
!---------------------------------------------------------------------------

!-----------------+
  interface axpy !
!-----------------+
   module procedure waxpy_r, waxpy_c, faxpy_r, faxpy_c
  end interface
  private waxpy_r, waxpy_c, faxpy_r, faxpy_c
!---------------------------------------------------------------------------

!----------------+
  interface scal !
!----------------+
   module procedure wscal_r, wscal_c, fscal_r, fscal_c
  end interface
  private wscal_r, wscal_c, fscal_r, fscal_c
!---------------------------------------------------------------------------

!---------------------+
  interface construct !
!---------------------+
   module procedure construct_k,     construct_ks,     &
                    construct_wvfct, construct_wvfcts, &
                    construct_field, construct_fields
  end interface
  private :: construct_k,     construct_ks,     &
             construct_wvfct, construct_wvfcts, &
             construct_field, construct_fields
!---------------------------------------------------------------------------

!-------------------+
  interface clonate !
!-------------------+
   module procedure clonate_wvfct, clonate_wvfcts, &
                    clonate_field, clonate_fields
  end interface

  private :: clonate_wvfct, clonate_wvfcts, clonate_field, clonate_fields
!---------------------------------------------------------------------------

!-------------------+
  interface destroy !
!-------------------+
   module procedure destroy_k,     destroy_ks, &
                    destroy_wvfct, destroy_wvfcts, &
                    destroy_field, destroy_fields
  end interface
  private :: destroy_k, destroy_ks, destroy_wvfct, destroy_wvfcts, &
                                    destroy_field, destroy_fields
!---------------------------------------------------------------------------

!---------------------+
  interface available !
!---------------------+
   module procedure available_k, available_wvfct, available_field
  end interface
  private :: available_k, available_wvfct, available_field
!---------------------------------------------------------------------------

  interface psi_link
   module procedure link_one_psi
   module procedure link_many_psis
  end interface
  private :: link_one_psi, link_many_psis

contains

  subroutine construct_ks( ks, xks, ecut, wks )

    type(k_point), intent(inout), dimension(:) :: &
         ks     ! k vectors
    real(kind=DP), intent(in), dimension(:,:) :: &
         xks    ! k vector coordinates
    real(kind=DP), intent(in) :: &
         ecut  ! kinetic-energy cutoff
    real(kind=DP), intent(in), optional, dimension(:) :: &
         wks   ! the weight of the k point

    integer  :: i
    if (size(ks) /= size(xks(1,:))) &
         call error("construct_ks", &
         "dimensions of input arguments do not match",1)

    if (present(wks)) then
       if (size(ks) /= size(wks) ) &
         call error("construct_ks","dimensions of ks and wks do not match",1)
    endif

    do i=1, size(ks)
       if (present(wks)) then
          call construct_k( ks(i), xks(:,i), ecut, wks(i) )
       else
          call construct_k( ks(i), xks(:,i), ecut )
       end if
    end do

    return
  end subroutine construct_ks

  subroutine construct_k( k, xk, ecut, wk )

    !> This routine constructs a variable of the {\tt k\_point} derived 
    !> data type. {\tt k(3)} are the coordinates of the k-point; {\tt ecut}
    !> is the kinetic-energy cutoff, and {\tt wk} (optional) is the weight
    !> for Brillouin-zone integrations

    use reciprocal_lattice, only: ngm, g, gcutm

    type(k_point), intent(inout) :: &
         k     ! k vector
    real(kind=DP), intent(in), dimension(:) :: &
         xk    ! k vector coordinates
    real(kind=DP), intent(in) :: &
         ecut  ! kinetic-energy cutoff
    real(kind=DP), intent(in), optional  :: &
         wk    ! the weight of the k point

    real(kind=DP), allocatable, dimension(:) :: gk
    integer, allocatable, dimension(:)       :: igk

    integer                                  :: ng, &! counter on   G vectors 
                                                npw  ! # of pw's

    real(kind=DP)                            :: kpg2, &! |k+G|^2
                                                g2mx   ! upper bound for |G|^2

    if (available_k(k)) call &
         error("construct_k","cannot construct a non idle k point",1)

    k%k(:)   = xk(:)
    if(present(wk)) k%wk = wk
    k%status = IS_CONSTRUCTED

    if(.not.allocated(g) .or. ngm /= size(g,2)) call &
         error("construct_k","g vectors not properly allocated",1)

    g2mx = (sqrt(k%k(1)**2+k%k(2)**2+k%k(3)**2)+sqrt(ecut)/tpiba)**2
    if (g2mx > gcutm) call error("construct_k", &
         "gcutm is too small for this k-point and kinetic-energy cutoff",2)

    allocate(igk(ngm),gk(ngm))

    npw = 0
    do ng=1,ngm
       if ( g(1,ng)**2+g(2,ng)**2+g(3,ng)**2 > g2mx ) exit

       kpg2 = ( ( k%k(1) + g(1,ng) )**2 + &
                ( k%k(2) + g(2,ng) )**2 + &
                ( k%k(3) + g(3,ng) )**2 ) * tpiba2

       if ( kpg2 <= ecut ) then
          npw=npw+1
          if ( npw > ngm ) call error ("construct_k", &
               "Too few g vectors for this kinetic-energy cutoff",npw)
          gk (npw) = kpg2
          igk(npw) = ng    ! set the initial value of index array

       endif
    end do

    ! order the gk array keeping the initial position of each one of 
    ! its elements in the igk(:) index array 

    call hpsort( gk(1:npw), igk )

    allocate(k%gk(npw),k%igk(npw))
    k%gk(:)  =  gk(1:npw)
    k%igk(:) = igk(1:npw)
    k%npw    = npw
    deallocate(igk,gk)

    k%status = IS_CONSTRUCTED

    return
  end subroutine construct_k

  subroutine destroy_k( k )

    !> This routine frees a variable of the {\tt k\_point} derived data
    !> data type.

    type(k_point), intent(in out) :: k ! k vector

    if (.not.available_k(k)) &
         call error ("destroy_k","cannot destroy an idle k point",1)

    deallocate (k%gk, k%igk)
    k%status = IS_IDLE

    return
  end subroutine destroy_k

  subroutine destroy_ks( ks )
    type(k_point), intent(inout) :: ks(:)
    integer                      :: i

    do i=1, size(ks)
       call destroy_k(ks(i))
    end do

    return
  end subroutine destroy_ks

  function available_k (k) result(is_available)

    !> This routine tests the status of a variable of the {\tt k\_point} 
    !> derived data type.

    logical                   :: is_available
    type(k_point), intent(in) :: k

    is_available = ( k%status == IS_CONSTRUCTED )

    return

  end function available_k

  function weight(ks)
    type(k_point), intent(in) :: ks
    real(DP)                  :: weight
    if(.not.available(ks)) call error("weight","input k point is idle",1)
    weight = ks%wk
    return
  end function weight

  !----------------------------+
  ! first two days  up to here !
  !----------------------------+

  subroutine construct_wvfct(the_wvfct,the_kpoint,pointee_array)

    type (wave_function), intent(in out)      :: the_wvfct
    type (k_point), intent(in), target        :: the_kpoint 
    complex(DP), intent(in), optional, target :: pointee_array(:)
  
    if (available_wvfct(the_wvfct))  &
       call error("construct_wvfct","cannot construct a non-idle wvfct",1)
    if (.not.available_k(the_kpoint)) &
       call error("construct_wvfct","the kpoint is not defined",1) 

    the_wvfct%k => the_kpoint

    if ( present(pointee_array) ) then
       the_wvfct%val => pointee_array(1:the_wvfct%k%npw)
       the_wvfct%status = IS_ASSOCIATED
    else 
       allocate(the_wvfct%val(1:the_wvfct%k%npw))
       the_wvfct%val(:) = cmplx(zero,zero)
       the_wvfct%status = IS_ALLOCATED
    end if

    return
  end subroutine construct_wvfct

  subroutine construct_wvfcts(the_wvfcts,the_kpoint,pointees)
    type(wave_function), intent(in out)       :: the_wvfcts(:)
    type(k_point), intent(in)                 :: the_kpoint
    complex(DP), intent(in), optional, target :: pointees(:,:)

    integer                                   :: i

    do i=1, size(the_wvfcts)
       if(present(pointees)) then
          call construct_wvfct(the_wvfcts(i),the_kpoint,pointees(:,i))
       else
          call construct_wvfct(the_wvfcts(i),the_kpoint)
       end if
    end do

    return
  end subroutine construct_wvfcts

  subroutine clonate_wvfct(the_wvfct,clone)
    type(wave_function), intent(in)     :: the_wvfct
    type(wave_function), intent(in out) :: clone

    call construct_wvfct(clone,the_wvfct%k)

    return
  end subroutine clonate_wvfct

  subroutine clonate_wvfcts(the_wvfct,clones)
    type(wave_function), intent(in)     :: the_wvfct
    type(wave_function), intent(in out) :: clones(:)

    call construct_wvfcts(clones,the_wvfct%k)

    return
  end subroutine clonate_wvfcts

  subroutine destroy_wvfct(the_wvfct)

    type(wave_function), intent(in out) :: the_wvfct

    select case(the_wvfct%status)
    case( IS_IDLE )
       call error("destroy_wvfct","cannot destroy an idle wave-function",1)
    case( IS_ALLOCATED )
       deallocate(the_wvfct%val)
    case( IS_ASSOCIATED )
       the_wvfct%val => null()
    case default
       call error("destroy_wvfct","unrecognized status: dunno what to do",2) 
    end select

    the_wvfct%status = IS_IDLE

    return
  end subroutine destroy_wvfct

  subroutine destroy_wvfcts(the_wvfcts)
    type(wave_function), intent(in out) :: the_wvfcts(:)
    integer                             :: i
    
    do i=1, size(the_wvfcts)
       call destroy_wvfct(the_wvfcts(i))
    end do
    
    return
  end subroutine destroy_wvfcts

  subroutine link_one_psi(hook,target)
    type(wave_function), intent(inout) :: target, hook

    if(.not.available(hook)) then
       call construct(hook,target%k,target%val)
    else
       if( hook%status == IS_ALLOCATED ) call error &
            ("link_one_psi","cannot link an allocated psi",1)
       !       if( hook%n /= target%n ) call error &
       !            ("link_one_psi","input dimensions do not match",2)
       hook%val => target%val
    end if
    
    return
  end subroutine link_one_psi
  
  subroutine link_many_psis(hooks,targets)
    type(wave_function), dimension(:), intent(inout) :: targets, hooks
    integer :: i
    
    if(size(hooks) /= size(targets)) &
         call error("link_many","input dimensions do not match",1)
    do i=1, size(hooks)
       call link_one_psi(hooks(i),targets(i))
    end do
    
    return
  end subroutine link_many_psis

  function available_wvfct(the_wvfct) result(is_available)
    logical                         :: is_available
    type(wave_function), intent(in) :: the_wvfct

    is_available = ( the_wvfct%status /= IS_IDLE )

    return
  end function available_wvfct

  subroutine copy_complex_to_wvfct(wvfct_out,complex_in)
    type(wave_function), intent (in out) :: wvfct_out
    complex(DP)        , intent (in)     :: complex_in

    if(.not.available(wvfct_out)) call error("copy_complex_to_wvfct", &
         "cannot copy to an idle wavefunction",1)

    wvfct_out%val(:) = complex_in

    return
  end subroutine copy_complex_to_wvfct

  subroutine copy_real_to_wvfct(wvfct_out,real_in)
    type(wave_function), intent (in out) :: wvfct_out
    real(DP   )        , intent (in)     :: real_in

    if(.not.available(wvfct_out)) call error("copy_real_to_wvfct", &
         "cannot copy to an idle wavefunction",1)

    wvfct_out%val(:) = cmplx(real_in,ZERO)

    return
  end subroutine copy_real_to_wvfct

  subroutine copy_wvfct_to_wvfct(wvfct_out,wvfct_in)
    type (wave_function), intent(in)     :: wvfct_in
    type (wave_function), intent(in out) :: wvfct_out

    if (.not. available_wvfct(wvfct_in) ) &
         call error ("copy_wvfct_to_wvfct","cannot copy an idle wvfct",1)

    if( .not. available_wvfct(wvfct_out) ) then
       call construct_wvfct(wvfct_out,wvfct_in%k)
    else 
       if ( any(wvfct_out%k%k /= wvfct_in%k%k) ) call error &
            ("copy_wvfct_to_wvfct","in and out kpoints do not match",1)
    end if

    wvfct_out%val(:) =  wvfct_in%val(:)

    return
  end subroutine copy_wvfct_to_wvfct

  subroutine wscal_c(a,x)
    complex(DP), intent(in)             :: a
    type(wave_function), intent(in out) :: x

    if(.not.available(x)) call error("wscal_c","input psi is idle",1)

    x%val = a * x%val

    return
  end subroutine wscal_c

  subroutine wscal_r(a,x)
    real(DP), intent(in)                :: a
    type(wave_function), intent(in out) :: x

    if(.not.available(x)) call error("wscal_r","input psi is idle",1)

    x%val = a * x%val

    return
  end subroutine wscal_r

  subroutine waxpy_c(a,x,y)
    complex(DP),         intent(in)     :: a
    type(wave_function), intent(in)     :: x
    type(wave_function), intent(in out) :: y
    
    if(.not.available(x) .or. .not.available(y)) &
         call error("waxpy_c","input psi's are idle",1)
    !    if(.not.agree(x,y)) call error("waxpy_c","input psi's do not agree",1)

    y%val = a*x%val + y%val

    return
  end subroutine waxpy_c

  subroutine waxpy_r(a,x,y)
    real(DP)                            :: a
    type(wave_function), intent(in)     :: x
    type(wave_function), intent(in out) :: y
    
    if(.not.available(x) .or. .not.available(y)) &
         call error("waxpy_r","input psi's are idle",1)
    !    if(.not.agree(x,y)) call error("waxpy_r","input psi's do not agree",1)

    y%val = a*x%val + y%val

    return
  end subroutine waxpy_r

  subroutine construct_field(the_field,state,pointee_array)

    use reciprocal_lattice, only: ngm, nr1,nr2,nr3, ig1,ig2,ig3, g, gg

    integer,          intent(in)                   :: state
    complex(kind=DP), intent(in), optional, target :: pointee_array(:,:,:)
    type(field),      intent(in out)               :: the_field

    if (available_field(the_field) ) call error &
         ("construct_field","cannot construct a non-idle field",1)

    if( .not.allocated(gg) ) call error("construct_field", &
         "g-vectors not allocated: cannot construct field",1)

    if( .not.allocated(ig1).or.  .not.allocated(ig2).or.   &
         .not.allocated(ig3)) call error("construct_field", &
         "ig-vectors not allocated: cannot construct field",1)
    
    if (nr1==0 .or. nr2==0 .or. nr3==0) call error ("construct_field", &
         "cannot construct a field with zero dimensions",1)
    
    the_field%state =  state
    
    the_field%nr1   =  nr1
    the_field%nr2   =  nr2
    the_field%nr3   =  nr3
    
    the_field%ig1   => ig1
    the_field%ig2   => ig2
    the_field%ig3   => ig3

    the_field%ngm   =  ngm

    the_field%g     => g
    the_field%gg    => gg
    
    if( present(pointee_array) ) then
       if( nr1 /= size(pointee_array,1) .or. &
           nr2 /= size(pointee_array,2) .or. &
           nr3 /= size(pointee_array,3) )    &
           call error("construct_field","incompatible pointee size",2)
       the_field%val    => pointee_array
       the_field%status =  IS_ASSOCIATED
    else 
       allocate ( the_field%val(the_field%nr1,the_field%nr2,the_field%nr3) )
       the_field%status = IS_ALLOCATED
       the_field%val(:,:,:) = cmplx(ZERO,ZERO)
    end if

    return
  end subroutine construct_field

  subroutine construct_fields(the_fields,state,pointees)
    type(field),      intent(in out)               :: the_fields(:)
    complex(kind=DP), intent(in), optional, target :: pointees(:,:,:,:)
    integer,          intent(in)                   :: state
    integer                                        :: i

    do i=1, size(the_fields)
       if(present(pointees)) then
          call construct_field(the_fields(i),state,pointees(:,:,:,i))
       else
          call construct_field(the_fields(i),state)
       end if
    end do

    return
  end subroutine construct_fields

  subroutine clonate_field(the_field,clone)
    type(field), intent(in)     :: the_field
    type(field), intent(in out) :: clone

    call construct_field(clone,the_field%state)

    return
  end subroutine clonate_field

  subroutine clonate_fields(the_field,clones)
    type(field), intent(in)     :: the_field
    type(field), intent(in out) :: clones(:)

    call construct_fields(clones,the_field%state)
    
    return
  end subroutine clonate_fields

  subroutine destroy_field(the_field)

    type(field), intent(in out)   :: the_field

    select case(the_field%status)
    case( IS_IDLE )
       call error("destroy_field","cannot destroy an idle field",1)
    case( IS_ALLOCATED )
       deallocate(the_field%val)
    case( IS_ASSOCIATED )
       the_field%val => null()
    case default
       call error("destroy_field","unrecognized status: dunno what to do",2) 
    end select

    the_field%ig1    => null()
    the_field%ig2    => null()
    the_field%ig3    => null()
    the_field%g      => null()
    the_field%gg     => null()

    the_field%status =  IS_IDLE

    return
  end subroutine destroy_field
  
  subroutine destroy_fields(the_fields)

    type(field), intent(in out) :: the_fields(:)
    integer                     :: i

    do i=1, size(the_fields)
       call destroy_field(the_fields(i))
    end do

    return
  end subroutine destroy_fields

  function available_field(the_field) result(is_available)
    logical                 :: is_available
    type(field), intent(in) :: the_field

    is_available = ( the_field%status /= IS_IDLE )

    return
  end function available_field

  subroutine copy_complex_to_field(field_out,complex_in)
    type(field), intent (in out) :: field_out
    complex(DP), intent (in)     :: complex_in

    if(.not.available(field_out)) call error &
         ("copy_complex_to_field","cannot copy to an idle field",1)

    field_out%val(:,:,:) = complex_in
    
    return
  end subroutine copy_complex_to_field

  subroutine set_field_state(the_field,state)
    type(field), intent(in out) :: the_field
    integer,     intent(in)     :: state

    if(.not.available(the_field)) call error &
         ("set_field_state","cannot set the state of an idle field",1)
    the_field%state = state

    return
  end subroutine set_field_state

  subroutine copy_real_to_field(field_out,real_in)
    type(field), intent (in out) :: field_out
    real(DP)   , intent (in)     :: real_in
    
    if(.not.available(field_out)) call error &
         ("copy_real_to_field","cannot copy to an idle field",1)
    
    field_out%val(:,:,:) = cmplx(real_in,ZERO)

    return
  end subroutine copy_real_to_field

  subroutine fscal_c(a,x)
    complex(DP), intent(in)     :: a
    type(field), intent(in out) :: x

    if(.not.available(x)) call error("fscal_c","input psi is idle",1)

    x%val = a * x%val

    return
  end subroutine fscal_c

  subroutine fscal_r(a,x)
    real(DP),    intent(in)     :: a
    type(field), intent(in out) :: x


    if(.not.available(x)) call error("fscal_r","input psi is idle",1)

    x%val = a * x%val

    return
  end subroutine fscal_r

  subroutine faxpy_c(a,x,y)
    complex(DP), intent(in)     :: a
    type(field), intent(in)     :: x
    type(field), intent(in out) :: y
    
    if(.not.available(x) .or. .not.available(y)) &
         call error("faxpy_c","input psi's are idle",1)
    ! if(.not.agree(x,y)) call error("faxpy_c","input fields do not agree",1)

    y%val = a*x%val + y%val

    return
  end subroutine faxpy_c

  subroutine faxpy_r(a,x,y)
    real(DP), intent(in)        :: a
    type(field), intent(in)     :: x
    type(field), intent(in out) :: y
    
    if(.not.available(x) .or. .not.available(y)) &
         call error("faxpy_c","input psi's are idle",1)
    ! if(.not.agree(x,y)) call error("faxpy_c","input fields do not agree",1)

    y%val = a*x%val + y%val

    return
  end subroutine faxpy_r

  subroutine field_square(the_field)
    type(field), intent(in out) :: the_field
    integer                     :: field_state

    field_state = the_field%state
    if( field_state == RECIPROCAL_SPACE ) &
         call field_ft(the_field,RECIPROCAL_TO_DIRECT_SPACE)

    the_field%val(:,:,:) = the_field%val(:,:,:) * conjg( the_field%val(:,:,:) )

    if( field_state == RECIPROCAL_SPACE ) &
         call field_ft(the_field,DIRECT_TO_RECIPROCAL_SPACE)

    return
  end subroutine field_square

  function average_field(the_field)
    complex(DP) :: average_field
    type(field), intent(in) :: the_field
    
    if( the_field%state == RECIPROCAL_SPACE ) then
       average_field = the_field%val(1,1,1)
    else
       average_field = sum(the_field%val) &
            / (the_field%nr1*the_field%nr2*the_field%nr3)
    end if

    return
  end function average_field

  subroutine copy_wvfct_to_field(the_field,the_wvfct)
    type (field),         intent(in out) :: the_field
    type (wave_function), intent(in)     :: the_wvfct
    integer                              :: the_field_state, &
                                            i, igk_of_i, n1,n2,n3

    if (.not. available_wvfct(the_wvfct) ) call error &
         ("copy_wvfct_to_field","the_wvfct is not defined",1) 
    
    if( .not. available_field(the_field) ) &
         call construct_field(the_field,RECIPROCAL_SPACE)

    the_field%val(:,:,:) = cmplx(ZERO,ZERO)
    the_field_state      = the_field%state
    the_field%state      = RECIPROCAL_SPACE

    do i=1, the_wvfct%k%npw
       igk_of_i                = the_wvfct%k%igk(i)
       n1                      = the_field%ig1(igk_of_i)
       n2                      = the_field%ig2(igk_of_i)
       n3                      = the_field%ig3(igk_of_i)
       the_field%val(n1,n2,n3) = the_wvfct%val(i)
    end do

    if(the_field_state == DIRECT_SPACE) &
         call field_ft(the_field,RECIPROCAL_TO_DIRECT_SPACE)
 
    return
  end subroutine copy_wvfct_to_field

  subroutine copy_field_to_wvfct(the_wvfct,the_field)
    type (wave_function), intent(in out) :: the_wvfct
    type (field),         intent(in)     :: the_field
    integer                              :: i, igk_of_i, n1,n2,n3
    
    if (.not.available_field(the_field)) call error &
         ("copy_field_to_wvfct","cannot copy an idle field",1)
    
    if( .not. available_wvfct(the_wvfct)) call error &
         ("copy_field_to_wvfct","destination wvfct cannot be idle",1) 

    the_wvfct%val = cmplx(ZERO,ZERO)
    if (the_field%state /= RECIPROCAL_SPACE) call error &
         ("copy_field_to_wvfct","cannot copy to a field in real space",1)

    do i=1, the_wvfct%k%npw
       igk_of_i         = the_wvfct%k%igk(i)
       n1               = the_field%ig1(igk_of_i)
       n2               = the_field%ig2(igk_of_i)
       n3               = the_field%ig3(igk_of_i)
       the_wvfct%val(i) = the_field%val(n1,n2,n3)
    end do
    
    return
  end subroutine copy_field_to_wvfct

  subroutine copy_field_to_field(field_out,field_in)
    type (field),         intent(in)     :: field_in
    type (field),         intent(in out) :: field_out
    
    if (.not. available_field(field_in) ) call error &
         ("copy_field_to_field","cannot copy an idle field",1)

    if (.not. available_field(field_out) ) &
         call construct_field(field_out,field_in%state)

    field_out%state =  field_in%state
    field_out%val   =  field_in%val

    return
  end subroutine copy_field_to_field

  function wvfct_dot_wvfct(psi_1,psi_2) result(dot)
    type (wave_function), intent(in) :: psi_1, psi_2
    complex(kind=DP)                 :: dot

    if ( .not.available_wvfct(psi_1) .or. .not.available_wvfct(psi_2) ) &
         call error("wvfct_dot_wvfct","input wvfct's cannot be idle",1)

    if( any ( psi_1%k%k /= psi_2%k%k ) ) call error &
         ("wvfct_dot_wvfct", "wave-function refer to different k points",1)

    dot = dot_product(psi_1%val,psi_2%val)

    return
  end function wvfct_dot_wvfct

  function field_dot_field(field_1,field_2) result(dot)
    type (field), intent(in) :: field_1, field_2
    complex(kind=DP)         :: dot
    integer                  :: i,j,k, nr1,nr2,nr3, state
    
    if ( .not.available_field(field_1) .or. .not.available_field(field_2) ) &
         call error("field_dot_field","the input fields cannot be idle",1)

    if( field_1%nr1   == field_2%nr1 .and. &
        field_1%nr2   == field_2%nr2 .and. &
        field_1%nr3   == field_2%nr3 .and. &
        field_1%state == field_2%state )  then
       nr1   = field_1%nr1
       nr2   = field_1%nr2
       nr3   = field_1%nr3
       state = field_1%state
    else
       call error("field_dot_field","field dimensions/state do not match",1)
    end if

    dot = cmplx(zero,zero)
    
    do k=1, nr3
       do j=1, nr2
          do i=1, nr1
             dot = dot + conjg(field_1%val(i,j,k)) * field_2%val(i,j,k)
          end do
       end do
    end do

    if(state==DIRECT_SPACE) dot = dot / (nr1*nr2*nr3)

    return
  end function field_dot_field

  subroutine field_ft(the_field,sign)
    use fourier, only: fft
    type(field), intent(in out) :: the_field
    integer,     intent(in)     :: sign

    if ( .not.available_field(the_field) ) &
         call error("field_ft","the field cannot be idle",1)

    if ( sign /= the_field%state ) call error("field_ft", &
         "sign of ft and field state do not match",1)

    call fft(the_field%val,the_field%state)
    the_field%state = -the_field%state

    return
  end subroutine field_ft

  subroutine field_times_wvfct(the_field,the_wvfct,resulting_wvfct)
    type(field),         intent(in)     :: the_field
    type(wave_function), intent(in)     :: the_wvfct
    type(wave_function), intent(in out) :: resulting_wvfct
    type(field)                         :: aux_field

    if (.not.available_field(the_field)) call error &
         ("field_times_wvfct","the field cannot be idle",1)

    if (.not.available_wvfct(the_wvfct)) call error &
         ("field_times_wvfct","the input wvfct cannot be idle",1)

    if (.not.available_wvfct(resulting_wvfct)) &
         call construct_wvfct(resulting_wvfct,the_wvfct%k)

    call construct_field(aux_field,RECIPROCAL_SPACE)
    
    aux_field =  the_wvfct
    
    call field_ft(aux_field,RECIPROCAL_TO_DIRECT_SPACE)

    aux_field%val   = the_field%val * aux_field%val
    
    call field_ft(aux_field,DIRECT_TO_RECIPROCAL_SPACE)

    resulting_wvfct = aux_field

    call destroy_field(aux_field)
    
    return
  end subroutine field_times_wvfct

end module pw_types

module energy_bands

    use constants, only : dp
    use pw_types, only : wave_function

    implicit none

    complex(DP), target, allocatable, dimension(:,:) :: evc
    real(DP),            allocatable, dimension(:)   :: et
    type(wave_function), allocatable, dimension(:)   :: psi
    integer,             parameter                   :: unit_wvfct=2
    integer,             parameter                   :: unit_wvfct_aux=3

    integer                       :: unit_psi_in  = unit_wvfct
    integer                       :: unit_psi_out = unit_wvfct_aux

    logical, save                 :: first = .true.

contains

  subroutine c_bands(kvect,nbnd,isolve)

    use constants,              only: ry_to_ev
    use lapack_wrap,            only: cdiagh
    use pw_types,               only: k_point, construct, destroy, &
                                      average_field
    use scf,                    only: Vscf, V0
    use hamiltonian,            only: fill_h
    use iterative,              only: cegter

    integer, intent(in)       :: nbnd
    complex(DP), allocatable  :: hc(:,:)
    integer                   :: i, npw, nks, swap, isolve

    integer                  :: iter, nbndx
    real(DP)                 :: iterations, avg_iter
    type(k_point), dimension(:)   :: kvect
    real(DP)                 :: x
    logical, parameter       :: reorder = .true.

    rewind(unit_psi_in) 
    rewind(unit_psi_out) 
    
    nks = size(kvect(:))
    for_each_k_point: do i=1, nks
       npw = kvect(i)%npw
       write(*,fmt="(' k = (',f6.3,',',f6.3,',',f6.3,'), npw = ',i5)")  &
            kvect(i)%k, kvect(i)%npw
       
       if(first.or.isolve.eq.0) then
          call fetch_psi(kvect(i), nbands=nbnd)
          allocate (hc(npw,npw))
          call fill_h(hc,kvect(i))
          call cdiagh(hc,et,evc)
          deallocate(hc)
       else
          V0 = average_field(Vscf)
          call fetch_psi(kvect(i), unit=unit_psi_in)
          call cegter ( psi, et, &
               maxter=20, maxdim = 4*nbnd, threshold = 1.0d-9 )
       end if

       write(*,fmt="(8f9.5)") et*Ry_to_eV
       
       call bury_psi(unit_psi_out,kvect(i))
       
    end do for_each_k_point
    
    first        = .false.              
    swap         = unit_psi_in
    unit_psi_in  = unit_psi_out
    unit_psi_out = swap
    
  end subroutine c_bands

  subroutine sum_bands(kvect,nbnd,nelec)

    use constants, only: zero, one, degspin, eps
    use pw_types,  only: field, available, direct_space, assignment(=), &
                         average_field, weight, construct, destroy, axpy, &
                         scal, set_field_state, field_square, k_point
    use reciprocal_lattice, only: g, ngm
    use structure,          only: omega
    use scf,                only: eband, rho
    use utilities, only : error

    integer, intent(in) :: nbnd, nelec

    integer             :: i, n, m, npw, nks
    type(k_point), dimension(:)   :: kvect
    type(field)         :: psi_field
    real(DP)            :: total_charge, echarge

    write (*,'(a)') ' calculating the charge density'

    if (mod(nelec,2)/=0) call error ('sum_bands', &
         'number of electrons must be even in a band isulator',1)
    if (nelec/2 > nbnd) call error ('sum_bands', &
         'number of bands is too small to contain all the electrons', nelec/2)

    rewind(unit_psi_in)
    
    if(.not.available(rho)) then
       call construct(rho,DIRECT_SPACE)
    else
       call set_field_state(rho,DIRECT_SPACE)
       rho = ZERO
    end if

    call construct(psi_field,DIRECT_SPACE)

    eband = ZERO
    
    nks = size(kvect(:))
    do i=1, nks

       call fetch_psi(kvect(i),unit=unit_psi_in)

       do n=1, nelec/2
          psi_field = psi(n)
          call field_square(psi_field) ! psi_field = |psi(n)|^2 (real space)
          ! rho <- rho + 2*w(k) * |psi(n)|^2
          call axpy(DEGSPIN * weight(kvect(i)), psi_field,rho)
          ! eband <- eband + 2*w(k) * e(n)
          eband = eband + et(n) * DEGSPIN * weight(kvect(i))
       end do

       call kill_psi
    end do

    call destroy(psi_field)

    call scal(ONE/omega, rho)

    total_charge = omega*average_field(rho)

    write(6,'(a,f12.8)') '   total charge =',total_charge
    if  (abs(total_charge-nelec).gt.eps) call error('sum_bands', &
         'total charge is not equal to the number of electrons',1)

    return
  end subroutine sum_bands
  
  subroutine fetch_psi(kvect, unit, nbands)

    use constants, only : zero
    use pw_types, only : k_point, construct
    use utilities, only : error

    type(k_point), intent(in)     :: kvect
    integer, intent(in), optional :: nbands, unit
    real(DP)                      :: k(3)
    integer                       :: npw, nbnd

    if(present(unit)) then
       read(unit) k(:), nbnd, npw
       if ( any( k(:) /= kvect%k(:) ) ) &
            call error("fetch_psi","k-vector mismatch",1)
       if ( npw /= kvect%npw ) &
            call error("fetch_psi","size mismatch",2)
       if( present(nbands) ) then
          if( nbnd /= nbands ) call error("fetch_psi","size mismatch",3)
       end if
    else
       if(.not.present(nbands)) &
            call error("fetch_psi","too few arguments",4)
          npw  = kvect%npw
          nbnd = nbands
    end if
       
    allocate (evc(npw,nbnd),et(nbnd),psi(nbnd))
    et(:) = ZERO

    if(present(unit)) read(unit) evc, et

    call construct(psi(1:nbnd),kvect,evc(:,1:nbnd))

    return
  end subroutine fetch_psi

  subroutine bury_psi(unit, kvect)

    use pw_types, only : k_point
    type(k_point), intent(in) :: kvect
    integer, intent(in)       :: unit

    write(unit) kvect%k, size(evc(1,:)), size(evc(:,1))
    write(unit) evc, et
     
    call kill_psi
    return
  end subroutine bury_psi

  subroutine kill_psi
    use pw_types, only : destroy

    if(allocated(psi)) then
       call destroy(psi)
       deallocate(psi)
    end if
    deallocate (evc,et)
    return
  end subroutine kill_psi

end module energy_bands

module scf
  use constants, only : dp, one
  use utilities, only : error
  use pw_types,  only : k_point, field, direct_space, available,  &
                        direct_to_reciprocal_space, reciprocal_to_direct_space,&
                        destroy, construct, axpy, field_ft, scal, &
                        is_idle, operator(.dot.), assignment(=)

  implicit none

  type(field)            :: rho, Vscf, delta_v
  real(DP)               :: eband, exc, evxc, ehar, eewald, etot
  real(DP)               :: V0
  logical                :: add_nscf_energy_correction=.true.
  real(DP), allocatable  :: force(:,:),forcelc(:,:),forceion(:,:)
  logical                :: new_atomic_configuration = .true.
  logical                :: verbose = .true.

contains

!> Subroutine {\tt v\_of\_rho} calculates the electrostatic and
!> exchange-correlation potential, $V({\bf r})$, generated by the
!> electron charge-density distribution, $\rho({\bf r})$: 
!> \[ V({\bf r}) =e^2 \int \frac{\rho({\bf r}')} {|{\bf r} - {\bf r'} |} + 
!> \mu_{xc}[\rho({\bf r})], \], 
!> where $\mu_{xc}[\rho({\bf r})]$ is the functional derivative
!> of the exchange-correlation energy in the LDA approximation.
  subroutine v_of_rho(rho,v) 
    use constants, only : e2, zero, fpi, tpiba2
    use structure,  only: omega
    use functionals, only: xc

    implicit none
 
    integer                     :: i,j,k
    type(field), intent(in)     :: rho
    type(field), intent(inout)  :: v
    complex(DP), allocatable    :: aux(:,:,:)
    complex(DP)                 :: car
    real(DP)                    :: ex,ec, vx,vc, fac
    integer                     :: nr1, nr2, nr3
    integer,     pointer        :: ig1(:), ig2(:), ig3(:) 
    real(DP),    pointer        :: gg(:)


    ! check that on input rho is in real space

    if (.not.available(rho)) &
         call error('v_of_rho','rho should already exists on input',1)

    nr1 = rho%nr1
    nr2 = rho%nr2
    nr3 = rho%nr3

    ig1 => rho%ig1
    ig2 => rho%ig2
    ig3 => rho%ig3

    gg  => rho%gg

    if(rho%state /= DIRECT_SPACE) &
         call error('v_of_rho','on input, rho should be in real space',1)

    ! check that v is available and that its dimensions match those of rho

    if( available(v) ) then
       if( v%nr1 /= nr1 .or. v%nr2 /= nr2 .or. v%nr3 /= nr3 ) &
            call error('v_of_rho', &
             'input and output field dimensions do not match',2)
    else
       call error('v_of_rho','output field is not available',3)
    end if

    v = rho
    call field_ft(v,DIRECT_TO_RECIPROCAL_SPACE)

    allocate(aux(nr1,nr2,nr3))

    aux(:,:,:) = (ZERO,ZERO)

    ehar=ZERO
    do i=2, v%ngm
       fac = (FPI * E2 / gg(i) / tpiba2 )  
       aux(ig1(i),ig2(i),ig3(i)) =  fac * v%val(ig1(i),ig2(i),ig3(i))
       ehar = ehar + fac * abs(v%val(ig1(i),ig2(i),ig3(i)))**2
    end do

    ehar=ehar*omega/2.d0
    v%val(:,:,:) = aux(:,:,:)
    
    call field_ft(v,RECIPROCAL_TO_DIRECT_SPACE)

    exc=ZERO
    evxc=ZERO
    do i=1, nr1
       do j=1, nr2
          do k=1, nr3
             call xc(real(rho%val(i,j,k)),ex,ec,vx,vc) 
             v%val(i,j,k) = v%val(i,j,k) + e2*(vx + vc)
             exc = exc + E2 * (ex+ec) * rho%val(i,j,k)
             evxc=evxc + E2 * (vx+vc) * rho%val(i,j,k)
          end do
       end do
    end do
    exc  = exc  * omega/(nr1*nr2*nr3)
    evxc = evxc * omega/(nr1*nr2*nr3)
    
    deallocate(aux)
    
    return
  end subroutine v_of_rho

  logical function linear_mixing(vin,vout,alpha,tol,tr2)

    ! simple potential linear mixing of potential
    ! On output: the mixed potential is in vout, vin=(vin-vout)

    implicit none
    real(DP), intent(in)    :: alpha, tol
    real(DP), intent(out)   :: tr2
    type(field), intent(inout) :: vin, vout
    
    ! vin <-  vin - vout
    call axpy(-ONE,vout,vin)
    tr2 = (vin .dot. vin)
    
    linear_mixing = (tr2 < tol)
    ! vout <- vout + ( ONE - alpha ) * vin
    call axpy((ONE-alpha),vin,vout)

    return

  end function linear_mixing

  logical function broyden (vin,vout,alpha,iter,n_iter,tol,tr2)

    ! Modified Broyden's method for potential mixing
    !             d.d. johnson prb 38, 12807 (1988)
    ! On output: the mixed potential is in vout, vin=(vin-vout)

    implicit none
    integer, intent(in)     :: iter, n_iter
    real(DP), intent(in)    :: alpha, tol
    real(DP), intent(out)   :: tr2
    type(field), intent(inout) :: vin, vout

    integer                 :: i, j, iwork(n_iter), info, iter_used, &
                               ipos, inext
    real(DP)                :: beta(n_iter,n_iter), gamma, work(n_iter),&
                               norm, DDOT, DNRM2, w0, w(n_iter)
    type(field)             :: vsave
    type(field), allocatable, save :: df(:), dv(:)
    external DSYTRF, DSYTRI

    w0=0.01_DP
    w =ONE
    
    if (iter < 1)   call error('broyden','iteration number wrong',1)
    if (n_iter < 1) call error('broyden','n_iter too small',2)
    if (vin%state /= vout%state .or. vin%status == IS_IDLE .or. &
         vout%status == IS_IDLE) call error('broyden','ma de che?',3)

    ! vin <-  vin - vout
    call axpy(-ONE,vout,vin)
    tr2 = (vin .dot. vin)

    broyden = (tr2 < tol)

    if (iter == 1) then
       allocate(df(n_iter))
       allocate(dv(n_iter))
       do i=1,n_iter
          call construct(df(i),vin%state)
          call construct(dv(i),vin%state)
       end do
    end if
    if (broyden) then
       do i=1,n_iter
          call destroy(df(i))
          call destroy(dv(i))
       end do
       deallocate(dv)
       deallocate(df)
       return
    end if

    ! iter_used = iter-1  if iter <= n_iter
    ! iter_used = n_iter  if iter >  n_iter
    
    iter_used=min(iter-1,n_iter)
    
    ! ipos is the position in which results from the present iteraction 
    ! are stored. ipos=iter-1 until ipos=n_iter, then back to 1,2,...
    
    ipos =iter-1-((iter-2)/n_iter)*n_iter
    
    if (iter > 1) then
       ! df(ipos) <-  vin - df(ipos)
       call scal(-ONE,df(ipos)) 
       call axpy(ONE,vin,df(ipos))
       ! dv(ipos) <-  vout- dv(ipos)
       call scal(-ONE,dv(ipos))
       call axpy(ONE,vout,dv(ipos))

       norm = sqrt((df(ipos) .dot. df(ipos)))
       call scal(ONE/norm,df(ipos))
       call scal(ONE/norm,dv(ipos))
    end if
    
    do i=1,iter_used
       do j=i+1,iter_used
          beta(i,j) = w(i)*w(j)*(df(j).dot.df(i))
       end do
       beta(i,i)=w0**2+w(i)**2
    end do
    
    call DSYTRF ('u',iter_used,beta,n_iter,iwork,work,n_iter,info)
    call error('broyden','factorization',info)
    call DSYTRI ('u',iter_used,beta,n_iter,iwork,work,info)
    call error('broyden','DSYTRI',info)
    
    do i=1,iter_used
       do j=i+1,iter_used
          beta(j,i)=beta(i,j)
       end do
    end do
    
    do i=1,iter_used
       work(i) = (df(i).dot.vin)
    end do
    
    call construct(vsave,vin%state)
    vsave = vout
    ! vout <- vout + (ONE-alpha) * vin
    call axpy(ONE-alpha,vin,vout)
    
    do i=1,iter_used
       gamma=0.d0
       do j=1,iter_used
          gamma = gamma + beta(j,i)*w(j)*work(j)
       end do
       ! vout <- vout - w(i) * gamma * ( alpha * df(i) + dv(i) )
       call axpy(-w(i)*gamma*(ONE-alpha), df(i), vout)
       call axpy(-w(i)*gamma            , dv(i), vout)
    end do
    
    inext=iter-((iter-1)/n_iter)*n_iter
    df(inext) = vin
    dv(inext) = vsave
    call destroy(vsave)
    
    return
  end function broyden

  subroutine tot_ene(conv)
    use structure, only : omega
    use constants, only : zero
    use ewald, only : ewald_energy
    use pw_types, only : operator(.dot.)
    implicit none
    logical, intent(in)    :: conv
    real(DP)               :: delta_e = ZERO
    logical                :: first = .true.
    integer, allocatable   :: ityp(:)
    integer                :: na

    if (first .or. new_atomic_configuration) then
       eewald= ewald_energy()
       first = .false.
       new_atomic_configuration = .false.
    end if

    if (add_nscf_energy_correction) delta_e = - (delta_v.dot.rho) * omega

    etot = eband-ehar+(exc-evxc)+eewald + delta_e

    write(*,*)
    if (conv) then
       write(*,'("!",4x,''Total   energy: '',f15.6)') etot
    else
       write(*,'(5x,''Total   energy: '',f15.6)') etot
    end if
    if (verbose.or.conv) then
       write(*,'(5x,''Band    energy: '',f15.6)') eband
       write(*,'(5x,''Hartree energy: '',f15.6)') ehar
       write(*,'(5x,''XC      energy: '',f15.6)') (exc-evxc)
       write(*,'(5x,''Ewald   energy: '',f15.6)') eewald
       if (add_nscf_energy_correction) &
            write(*,'(5x,''dscf    energy: '',f15.6)') delta_e
    end if

    return
  end subroutine tot_ene

  !> \large \newpage 
  !> The subroutine {\tt forces} computes the atomic forces using the
  !> Hellmann-Feynman  theorem 
  !> \[ {\bf F}_i = - \frac{\partial E}{\partial {\bf R}_i} =  
  !> - \left\langle \psi_{{\bf k}\nu} \mid \frac{\partial {\cal H}}
  !> {\partial {\bf R}_i} \mid \psi_{{\bf k}\nu} \right\rangle. \] 

  subroutine forces
    use constants, only : tpi, tpiba, tpiba2, zero
    use structure, only : nats, species, atoms
    use ewald, only: ewald_force
    use pw_types, only : available, operator(.dot.), destroy, &
                         direct_to_reciprocal_space, field_ft, &
                         assignment(=)
    implicit none

    real(DP)              :: valr, vali, arg
    integer               :: na, ig, ipol
    type(field)           :: aux
    complex(DP), pointer  :: vg(:)
    integer               :: nr1,nr2,nr3
    integer,     pointer  :: ig1(:), ig2(:), ig3(:)
    real(DP),    pointer  :: g(:,:)

    integer,  allocatable :: ityp(:)
    
    if (.not.allocated(forceion)) allocate(forceion(3,nats))
    if (.not.allocated(forcelc))  allocate(forcelc(3,nats))
    if (.not.allocated(force))    allocate(force(3,nats))

    !> The ionic contribution ${\bf F_i^{\rm ion}}$ arising from the 
    !> electrostatic potential on site $i$ due to all other ions at 
    !> sites $j \ne i$ is conditionally convergent with the distance 
    !> $R_{ij}=\mid {\bf R_{ij}} \mid$. 
    !> (notation: ${\bf R_{ij}}={\bf R_i - R_j}$). 
    !> To improve convergence the \hyperlink{ewald}{Ewald technique} is 
    !> employed (for a reference see M.P. Allen and D.J.
    !> Tildesley, "Computer Simulation of Liquids", Clarendon Press, Oxford 
    !> UK.). The ionic contribution to the total force 
    !> \[ -\frac{1}{2} \sum_{i,j} Z_i \, Z_j
    !> \frac{\partial}{\partial{\bf R_i}} \frac{1} {R_{ij}} = 
    !> -\frac{1}{2} \sum_{i,j} \frac{Z_i \, Z_j}{R_{ij}^{2}}  \, \,
    !> \frac{\bf R_{ij}}{R_{ij}} \]
    !> is calculated in \hyperlink{ewaldforce}{\tt ewald\_force}.
    !> \hypertarget{htforceion}{}

    call ewald_force  ( forceion )

    !> The electronic contribution ${\bf F}_j^{\rm el}$:
    !> \[ {\bf F}_j^{\rm el} = - \int \rho_{\bf R}({\bf r}) 
    !> \frac{\partial V_{\bf R}({\bf r})}{\partial{\bf R_i}} {\rm d \bf r}. \]
    !> is calculated in  reciprocal space:
    !> \[ {\bf F}_j^{\rm el} = \sum_{\bf G} i \, {\bf G} \, 
    !> V_{\bf G}^{\rm ion} \, \rho_{\bf G} \, e^{i \, {\bf G \cdot \tau}} \]
    !> To begin, get a reciprocal-space representation of the charge density
    !> $\rho_{\bf G}$ via a fast fourier transform:
    aux=rho
    call field_ft(aux,DIRECT_TO_RECIPROCAL_SPACE)

    nr1 = rho%nr1
    nr2 = rho%nr2
    nr3 = rho%nr3

    ig1 => rho%ig1
    ig2 => rho%ig2
    ig3 => rho%ig3
 
    g   => rho%g

    forcelc(:,:)=ZERO
    do na=1, nats    ! loop over atoms
       vg => species(atoms(na)%itype)%ps%vg
       do ig=1, aux%ngm   
          arg = ( g(1,ig)*atoms(na)%tau(1) + &
                  g(2,ig)*atoms(na)%tau(2) + &
                  g(3,ig)*atoms(na)%tau(3)  ) * TPI
          valr = real( aux%val(ig1(ig),ig2(ig),ig3(ig)) )
          vali = aimag(aux%val(ig1(ig),ig2(ig),ig3(ig)) )
          !> \[ \sum_{\bf G} {\bf G} \, V_{\bf G}^{\rm ion} \, \rho_{\bf G} \,
          !> \left[ \sin({\bf G \cdot \tau}){\rm Re}(\rho_{\bf G}) +
          !> \cos({\bf G \cdot \tau}){\rm Im}(\rho_{\bf G}) \right] \]
          do ipol=1,3
             forcelc(ipol,na) = forcelc(ipol,na) + g(ipol,ig) * vg(ig) * &
                  ( sin(arg) * valr + cos(arg) * vali )
          enddo
       enddo
       do ipol=1,3
          forcelc(ipol,na) = forcelc(ipol,na)*tpiba
       enddo
    enddo
  
    !> Sum the ionic and electronic contributions:
    !> \[ {\bf F_i} = {\bf F_i^{\rm ion}} + {\bf F_i^{\rm el}} \]
    do na=1,nats
       do ipol=1,3
          force(ipol,na)=forcelc(ipol,na)+forceion(ipol,na) 
       enddo
    enddo

    !> Print out

    write(*,*)  'Total forces'
    write(*,"(5x,'atom ',i3,' type ',i2,'   force = ',3f14.8)") &
         (na, atoms(na)%itype, force(:,na), na=1,nats)
    if (verbose) then
       write(*,*)  'Local forces'
       write(*,"(5x,'atom ',i3,' type ',i2,'   force = ',3f14.8)") &
            (na, atoms(na)%itype, forcelc(:,na), na=1, nats)
       write(*,*)  'Ionic forces'
       write(*,"(5x,'atom ',i3,' type ',i2,'   force = ',3f14.8)") &
            (na, atoms(na)%itype, forceion(:,na), na=1, nats)
    end if
    
    call destroy(aux)

  end subroutine forces

  !> \hyperlink{htendforces}{\red BACK} to the main program.
  
end module scf
